
; Byte Back.
; Project Started 14.01.09 @ 19:44.
; Project completed 13.03.09 @ 21:57.


; Definitions of constants.

SPCATT equ 0               ; space attributes.
DEADLY equ 64              ; deadly items attributes.
PLAT   equ 1               ; standard platform.
JUMP   equ 2               ; water.
LEFT   equ 4               ; fodder wall.
RIGHT  equ 8               ; fodder wall.
WALATT equ 16              ; solid wall.
DOOR   equ 32              ; magic door.
PLATS  equ 1 + 2 + 4 + 8   ; all platforms.
WALLS  equ 16 + 32         ; all walls.
DOWN   equ PLATS + WALLS


CELLW  equ 1               ; standard wall.
CELLP1 equ 2               ; standard platform.
CELLP2 equ 3               ; jump up cell.
CELLU  equ 4               ; jump up cell.
CELLL  equ 5               ; force left.
CELLR  equ 6               ; cell right.
MAXCHR equ CELLR + 1

; Table of sprites.

NUMITM equ 14              ; number of items.
ELSIZE equ 6               ; size of each sprite table entry.

CURSPD equ 1               ; cursor speed (1, 3, 7 etc.)
MAXCOM equ 3               ; complaints before warning.

; Foodstuffs.

SOS    equ 0               ; sausages.
EGG    equ 1               ; eggs.
TEA    equ 2               ; tea.
MIN    equ 3               ; mineral water.
SAN    equ 4               ; sarnies.
APP    equ 5               ; apples.
EXPLOD equ 6               ; explosion at end of sprites.
END    equ 255             ; end of orders or delivery.

; Text routine constants.

ATTR   equ 97              ; ATTR control code for dchar routine.
AT     equ 98              ; AT control code for dchar routine.
ENDCHR equ 99              ; termination code.
ZERO   equ 27              ; zero code.

NUMLEV equ 12              ; number of levels.
PLSIZ  equ 16              ; size of player data structure.




       org 28160

game   ld de,loadsc        ; place to put loading screen.
       ld hl,16384         ; physical screen address.
       ld bc,6144          ; bytes to transfer.
       ldir                ; copy to RAM for later.

       call clrsc          ; clear the screen.
       xor a               ; zero for black.
       call 8859           ; set permanent border colour.
       ld hl,23693         ; attributes system variable.
       ld (hl),71          ; set permanent attributes.
       call 3503           ; clear screen.

       ld hl,masks         ; edge masks for sprites.
       ld de,64512         ; address where we want them.
       ld bc,masken-masks  ; size of mask table.
       ldir                ; transfer the data.

       call music          ; initialise music.

       di                  ; switch interrupts off while we reconfigure them.
       ld a,190            ; interrupt address table.
       ld i,a              ; set address.
       im2                 ; interrupt mode 2.
       ei                  ; start interrupts again to begin the music.

menu0  ld hl,menuno        ; menu number to display.
       inc (hl)            ; move it along.
       ld a,(hl)           ; get menu number.
       and 7               ; only 8 to display.
       rlca                ; multiply byte by 2.
       ld e,a              ; displacement in de.
       ld d,0              ; no high byte for displacement.
       ld hl,menptr        ; pointer to menu routines.
       add hl,de           ; point to address of routine.
       ld e,(hl)           ; low byte of address in e.
       inc hl              ; next byte.
       ld d,(hl)           ; high byte of address in e.
       ex de,hl            ; put address in hl.
       jp (hl)             ; jump to routine.

menptr defw menua,dishs    ; menu routine sequence.
       defw menua,menub
       defw menua,dishs
       defw menua,menuc
menuno defb 255

chtxt  defb AT,6,5,ATTR,68
       defb 25,15,21,39,22,5,0,8,1,4,0,25,15,21,18,0,3,8,9,16,19
       defb ENDCHR

mtxt0  defb AT,11,8,ATTR,69
       defb 28,37,0,11,5,25,2,15,1,18,4

       defb AT,13,8
       defb 29,37,0,11,5,13,16,19,20,15,14

       defb AT,15,8
       defb 30,37,0,19,9,14,3,12,1,9,18

       defb AT,17,8
       defb 31,37,0,18,5,4,5,6,9,14,5,0,11,5,25,19

       defb AT,19,8
       defb 32,37,0,5,4,9,20,0,12,5,22,5,12,19

       defb ENDCHR

crtxt  defb AT,0,11,ATTR,3
       defb 9,14,9,20,9,1,20,15,18
       defb AT,1,11,ATTR,71
       defb 13,1,20,0,3,15,18,14,5
       defb AT,4,7,ATTR,4
       defb 2,1,19,5,4,0,15,14,0,9,4,5,1,19,0,2,25
       defb AT,5,9,ATTR,70
       defb 1,9,4,1,14,0,12,15,3,11,5,20,20
       defb AT,6,9,ATTR,5
       defb 4,13,0,2,15,15,26,5,6,18,5,1,11
       defb AT,9,7,ATTR,66
       defb 7,1,13,5,0,1,14,4,0,7,18,1,16,8,9,3,19
       defb AT,10,7,ATTR,67
       defb 10,15,14,1,20,8,1,14,0,3,1,21,12,4,23,5,12,12

       defb AT,13,13,ATTR,6
       defb 13,21,19,9,3
       defb AT,14,8,ATTR,68
       defb 13,1,20,20,8,5,23,0,23,5,19,20,3,15,20,20

       defb AT,17,6,ATTR,2
       defb 1,4,4,9,20,9,15,14,1,12,0,7,18,1,16,8,9,3,19
       defb AT,18,10,ATTR,69
       defb 13,9,7,21,5,12,0,1,14,7,5,12
       defb AT,19,8,ATTR,70
       defb 13,1,20,20,8,5,23,0,23,5,19,20,3,15,20,20

       defb AT,22,7,ATTR,3
       defb 12,5,22,5,12,19,0,4,5,19,9,7,14,5,4,0,2,25
       defb AT,23,7,ATTR,69
       defb 2,25,20,5,2,1,3,11,0,1,20,20,5,14,4,5,5,19
       defb ENDCHR

hstxt0 defb AT,2,10,ATTR,66
       defb 2,5,19,20,0,19,3,15,18,5,19
       defb ATTR,69
       defb ENDCHR
hstxt2 defb AT,6,10,ATTR,66
       defb 7,18,5,1,20,0,19,3,15,18,5
       defb AT,9,8,ATTR,70
       defb 5,14,20,5,18,0,25,15,21,18,0,14,1,13,5
       defb ENDCHR
hstab  defb 10,15,14,1,20,8,1,14
       defb 27,27,27,32,27,27
       defb 13,1,20,20,0,0,0,0
       defb 27,27,27,31,27,27
       defb 2,5,2,2,5,18,19,0
       defb 27,27,27,30,27,27
       defb 10,15,6,6,1,0,0,0
       defb 27,27,27,29,27,27
       defb 16,19,10,0,0,0,0,0
       defb 27,27,27,28,27,27
       defb 6,15,7,1,18,20,25,0
       defb 27,27,27,27,27,28
       defb ENDCHR



; Display high-score table.

dishs  call blind          ; clear screen.
       ld b,6              ; number of entries to display.
       ld hl,hstab
dishs0 push bc
       push hl
       ld a,9              ; top of table.
       sub b
       rlca
       inc a
       ld (dispx),a        ; set vertical position.
       ld a,8              ; column number.
       ld (dispy),a        ; set horizontal now.
       ld a,67             ; colour of names.
       ld (23693),a        ; set attributes.
       ld b,8              ; length of name.
       call htxt           ; display name.
       ld hl,dispy         ; y coordinate.
       inc (hl)            ; move along one.
       pop hl
       push hl
       ld a,70             ; bright yellow.
       ld (23693),a        ; set score attributes.
       ld de,8             ; length of each name.
       add hl,de           ; add to pointer to find score.
       ld b,6              ; number of digits in score.
       call htxt           ; show digits.
       pop hl
       pop bc
       ld de,14            ; distance to next name.
       add hl,de
       djnz dishs0         ; repeat for all entries.
       ld hl,hstxt0        ; title at the top.
       call rfont          ; show header.
       ld a,244            ; delay of approx 10 seconds.
       jp menu1            ; rest of menu.

htxt   push bc             ; store registers.
       push hl
       ld a,(hl)           ; get character to display.
       call dsymb          ; display it.
       pop hl              ; restore registers.
       pop bc
       inc hl              ; point to next character.
       djnz htxt           ; repeat.
       ret

; Try high score table to see if score qualifies.

tryhs  ld hl,hstab+78      ; end of high score table.
       ld b,6              ; number of scores to check.
tryhs0 push bc             ; store list counter.
       ld de,score         ; player's score.
       push hl             ; store position in table.
       ld b,6              ; digits to compare.
tryhs3 ld a,(de)           ; player's score digit.
       cp (hl)             ; table digit.
       jr c,tryhs1         ; score is greater.
       jr nz,tryhs2        ; score is lower.
       inc hl              ; digit is the same - go to next column.
       inc de
       djnz tryhs3
       jr tryhs1           ; score is same, first registered comes first.
tryhs2 pop hl
       ld de,65522         ; 65536 - 14.
       add hl,de           ; subtract 14 - next entry in table.
       pop bc
       djnz tryhs0
       ld hl,hstab+8

; top of table.

tryhs4 push hl
       ld de,65528
       add hl,de
       ld d,h
       ld e,l
       ld hl,hstab+84
       and a
       sbc hl,de
       ld b,h
       ld c,l
       ld hl,hstab+69
       ld de,hstab+83
       lddr
       pop hl
       ld de,score         ; player's score.
       ex de,hl
       ld bc,6             ; number of digits to transfer.
       ldir                ; copy to table.
       ld hl,65522         ; minus 14.
       add hl,de           ; go back to start of name.
       ex de,hl            ; Address of name in de.
       push de
       call ent            ; enter name.
       pop de
       ld hl,nambuf        ; place where name is stored.
       ld bc,8             ; length of name.
       ldir                ; copy to high score table.
       ret
tryhs1 pop hl
       pop bc
       ld a,b
       cp 6                ; failed at bottom of table?
       ret z               ; yes - no high score then.
       ld de,14            ; next element down.
       add hl,de           ; point to next in list.
       jr tryhs4           ; put in table at this point.

nament defb AT,16,12
nambuf defb 8,5,12,12,15,0,0,0
       defb ENDCHR
gotxt  defb AT,23,0
       defb 0,0,0,0,0,0
       defb 7,0,1,0,13,0,5,0
       defb 0,0,0,0
       defb 0,15,0,22,0,5,0,18
       defb 0,0,0,0,0,0
       defb ENDCHR
txbuf  defw nambuf


ent    call clrsc          ; clear screen.
       ld hl,hstxt2        ; high score text.
       call rfont          ; prompt for name.
       ld hl,nambuf        ; input line in buffer.
       ld (txbuf),hl
       ld de,nambuf+1      ; second char of buffer.
       ld bc,7             ; 8 characters maximum.
       ld (hl),b           ; make first character a space.
       ldir                ; copy to rest of buffer.
       xor a
       ld (23560),a        ; clear keypress.
       ld (23658),a        ; turn off caps lock.
ent00  call ecuron         ; switch on cursor.
       ld hl,nament        ; string we're typing in.
       call dfont          ; display on screen.
       ld hl,23560         ; keypress system variable.
       ld a,(hl)           ; what was key pressed?
       and a               ; anything pressed?
       jr z,ent00          ; no, wait until it is.
       ld (hl),0           ; clear buffer.
       ld c,a              ; store keypress.
       call ecurof         ; remove cursor.
       ld a,c              ; restore keypress.
       cp 13               ; enter.
       jp z,ent13
       cp 8                ; left.
       jp z,ent08
       cp 9                ; right.
       jp z,ent09
       cp 12               ; delete.
       jp z,ent12
       cp 32               ; is it space?
       call z,ent32        ; frig a space character.
       sub 96              ; below space/letter 'A'?
       jr c,ent00          ; yes, don't accept.
       ld c,a              ; put key in c.
       cp 27               ; above letter 'Z'?
       jr nc,ent00         ; yes, that's invalid.
ent00a ld a,(nambuf+7)     ; last char.
       and a               ; is it space?
       jp nz,ent00         ; no more room on line.
       ld hl,(txbuf)       ; pointer to place in string.
ent00b ld a,(hl)           ; get character we'll overwrite.
       ld (hl),c           ; place character there.
       ld c,a              ; get character overwritten.
       inc hl              ; point to next in string.
       ld a,(hl)           ; get this character.
       cp ENDCHR           ; end of buffer?
       jr nz,ent00b        ; no, keep going.
       ld hl,(txbuf)       ; text position.
       call ecurof         ; cursor is already off, just want address.
       ld a,l              ; put into accumulator.
       cp 19               ; reached end of string?
       jp z,ent00          ; yes, cursor is at end of string.
       ld hl,(txbuf)       ; get buffer position.
       inc hl              ; point to next one.
       ld (txbuf),hl       ; store pointer.
       jp ent00            ; wait for next character.
ent08  call ecurof         ; get address in l.
       ld a,l              ; y position now in accumulator.
       cp 12               ; reached the minimum?
       jp z,ent00          ; yes.
       ld hl,(txbuf)       ; buffer position.
       dec hl              ; back a character.
       ld (txbuf),hl       ; new position.
       jp ent00            ; back to input routine.
ent09  call ecurof         ; get address in l.
       ld a,l              ; y position now in accumulator.
       cp 19               ; reached the end?
       jp z,ent00          ; yes, wait for next character.
       ld hl,(txbuf)       ; text pointer.
       inc hl              ; next character.
       ld (txbuf),hl       ; point there.
       jp ent00            ; next letter.
ent12  call ecurof         ; position on screen.
       ld a,l              ; y position now in accumulator.
       cp 12               ; at left edge?
       jp z,ent00          ; yes, no more please.
       ld hl,(txbuf)       ; text position.
       ld d,h              ; copy to de.
       ld e,l
       dec hl              ; left a character.
       ld (txbuf),hl       ; new pointer.
ent12b ld a,(de)           ; get buffer character.
       cp ENDCHR           ; reached the end?
       jr z,ent12a         ; no, keep going.
       ld (hl),a           ; write new character.
       inc hl              ; next in buffer.
       inc de              ; ditto.
       jr ent12b           ; repeat uuntil end of string.
ent12a ld (hl),0           ; one character below letter A.
       jp ent00
ent13  ld hl,nambuf        ; point to buffer.
       ld b,8              ; length.
ent13b ld a,(hl)           ; get char.
       and a               ; is it a space?
       jr nz,ent13a        ; no, something entered then.
       inc hl              ; next char.
       djnz ent13b         ; repeat for entire buffer.

; Oh dear, how boring.  Let's put something else in for him.

entemp ld hl,namep         ; blank name substitute.
entob0 ld de,nambuf        ; text buffer.
       ld bc,8             ; number of chars to copy.
       ldir                ; copy name into buffer.
       ret

ent13a ld hl,nambuf        ; point to buffer.
       call word           ; find word in list.
       and a               ; is it recognised?
       ret z               ; no, it's okay as it is then.
       cp 2                ; is it naughty?
       jr z,entob          ; replace rudeness.
       cp 4                ; is it the cheat?
       ret nz              ; no, it's okay as it is then.
       xor a               ; opcode for a NOP.
       ld (cheatb),a       ; set cheat mode.
       ld hl,namec         ; cheat name.
       jr entob0

entob  ld hl,name          ; obscenity substitute.
       jr entob0           ; use this name instead.


ent32  ld a,96             ; 96 - 96 = 0, SPACE code in our font.
       ld c,a              ; put it into c register as well.
       ret

ecurof ld b,0              ; cursor off.
       jr curset           ; draw cursor.
ecuron ld b,124            ; cursor on.
curset ld hl,(txbuf)       ; buffer position.
       ld de,nambuf-12     ; buffer minus 12 chars for centre of screen.
       and a               ; clear carry.
       sbc hl,de           ; find number of chars along.
       ld h,87             ; final segment, last line.
       ld (hl),b           ; set sursor.
       ret

; Check if a known word has been entered.
; On entry HL points to the buffer.

word   ld de,vocab             ; table of naughty words.
word3  ld hl,nambuf            ; name we wish to check.
word0  ld a,(de)               ; DE=char in vocabulary table.
       inc de
       cp (hl)                 ; do they match?
       jr nz,word1             ; no - find next word.
       cp 255                  ; end of listed word?
       jr z,word2              ; yes - try next word in table.
       inc hl                  ; next buffer char.
       jr word0
word1  cp 255                  ; end of word?
       jr z,word4              ; yes - return verb number.
word2  ld a,(de)               ; character in lexicon.
       inc de                  ; point to next one.
       cp 255                  ; have we reached end of word in table?
       jr nz,word2             ; no, loop round again.
       ld a,(de)               ; which word is this?
       inc de                  ; point to start of first letter.
       cp 255                  ; is it the last one?
       jr nz,word3             ; no.
       xor a                   ; return 0 (not found) in A.
       ret
word4  ld a,(de)               ; name number returned in A.
       ret

; This is the recognised naughty word list.

vocab  defb 6,21,3,11,255,2            ; swear words.
       defb 3,21,14,20,255,2           ; swear words.
       defb 2,15,12,12,15,3,11,19,255,2
       defb 1,18,19,5,255,2
       defb 19,8,9,20,255,2
       defb 23,1,14,11,255,2
       defb 18,7,255,4                 ; RG cheat.
       defb 10,16,13,255,4             ; JPM cheat.
       defb 2,6,7,255,4                ; BFG cheat.
       defb 5,4,6,5,0,19,21,24,255,4   ; EDGE SUX cheat.
       defb 255,255
namec  defb 8,1,4,4,15,3,11,0          ; petrol.
namep  defb 3,8,9,16,19,0,0,0          ; chips.
name   defb 2,1,16,19,0,0,0,0          ; baps.


; Debug routine - not used in the game.

debug  ld de,NEWTAB
debug5 ld hl,16408         ; attribute address to write.
       ld a,2              ; segments to write.
debug4 push af
       ld b,8              ; lines to write.
debug3 push bc
       ld a,(de)
       ld b,8
debug0 push hl
       rla
       jr c,debug1
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       inc h               ; next line down.
       ld (hl),0
       jr debug2
debug1 ld (hl),0
       inc h               ; next line down.
       ld (hl),126
       inc h               ; next line down.
       ld (hl),126
       inc h               ; next line down.
       ld (hl),126
       inc h               ; next line down.
       ld (hl),126
       inc h               ; next line down.
       ld (hl),126
       inc h               ; next line down.
       ld (hl),126
       inc h               ; next line down.
       ld (hl),0
debug2 pop hl
       inc hl
       djnz debug0
       push de
       ld de,24
       add hl,de
       pop de
       inc de
       pop bc
       djnz debug3
       push de
       ld de,1792      ; distance to next segment.
       add hl,de
       pop de
       pop af
       dec a
       jp nz,debug4
       ret

gfram  defb 0              ; game frame timer.
levspd defb 13             ; level speed.
levno  defb 0              ; current level number.

lvtxt0 defb AT,8,9,ATTR,70
       defb 6,18,25,9,14,7
       defb AT,8,16
       defb 20,15,14,9,7,8,20
       defb ENDCHR
lvtxt1 defb AT,12,9,ATTR,69
       defb 12,5,22,5,12
       defb AT,12,15
       defb 3,15,13,16,12,5,20,5
       defb ENDCHR
lvtxt2 defb AT,11,10,ATTR,69
       defb 1,14,15,20,8,5,18
       defb AT,11,18
       defb 19,20,1,18
       defb AT,13,6
       defb 6,15,18
       defb AT,13,10
       defb 25,15,21,18
       defb AT,13,15
       defb 14,1,13,5
       defb AT,13,20
       defb 2,1,4,7,5
       defb ENDCHR

pantxt defb AT,20,7,ATTR,70
       defb 0,0,0,0,0,0,0,0
       defb AT,21,7
       defb 0,0,0,0,0,0,0,0
       defb AT,22,7
       defb 0,0,0,0,0,0,0,0
       defb AT,23,0,ATTR,69
       defb 14,5,24,20
       defb AT,23,6
       defb 3,15,13,16,12,1,9,14,20,19
       defb AT,23,18
       defb 16,15,9,14,20,19
       defb AT,23,26
       defb 18,5,3,15,18,4
       defb ENDCHR


gitim  defb 0              ; goods in timer.
giflag defb 0              ; goods in flag.
gityp  defb 0              ; type of food.
ginum  defb 4              ; number left to deliver.
delptr defw del0           ; pointer to deliveries.
del0   defb SOS,4          ; sausages, 4.
       defb EGG,3          ; eggs, 3.
       defb TEA,3          ; tea, 3.
       defb EGG,3          ; eggs, 4.
       defb SOS,2          ; 2 final sausages.
       defb TEA,2          ; tea, 2.
       defb END
del1   defb SOS,4          ; sausages, 4.
       defb EGG,4          ; eggs, 4.
       defb TEA,3          ; tea, 3.
       defb SOS,3          ; 3 final sausages.
       defb EGG,3          ; eggs, 3.
       defb TEA,2          ; tea, 2.
       defb END
del2   defb MIN,4          ; mineral water.
       defb SAN,4          ; sandwiches.
       defb TEA,3
       defb MIN,3
       defb SAN,3
       defb TEA,4
       defb END
del8   defb APP,6
       defb SAN,5
       defb MIN,5
       defb APP,3
       defb SAN,3
       defb MIN,5
       defb APP,2
       defb SAN,1
       defb END
del3   defb SOS,3          ; 3 sausages.
       defb TEA,4
       defb EGG,3
       defb SOS,3
       defb TEA,3
       defb EGG,3
       defb TEA,2
       defb END
del4   defb TEA,6
       defb SAN,3
       defb SOS,4
       defb EGG,3
       defb TEA,3
       defb SOS,3
       defb EGG,3
       defb END
del5   defb SAN,4
       defb MIN,3
       defb APP,3
       defb TEA,4
       defb SAN,3
       defb APP,4
       defb TEA,4
       defb SAN,3
       defb APP,4
       defb TEA,3
       defb SAN,2
       defb APP,2
       defb END
del6   defb EGG,4
       defb SOS,4
       defb TEA,4
       defb EGG,3
       defb MIN,3
       defb SAN,3
       defb SOS,3
       defb TEA,3
       defb SOS,3
       defb SAN,2
       defb EGG,3
       defb END
del7   defb SAN,6
       defb EGG,4
       defb TEA,3
       defb MIN,4
       defb TEA,3
       defb EGG,5
       defb SOS,4
       defb MIN,4
       defb TEA,4
       defb SOS,3
       defb END
del9   defb SOS,8
       defb TEA,5
       defb END
del10  defb SOS,5
       defb TEA,6
       defb EGG,5
       defb SOS,4
       defb TEA,6
       defb EGG,4
       defb SOS,4
       defb TEA,6
       defb EGG,4
       defb SOS,4
       defb TEA,6
       defb EGG,4
       defb SOS,3
       defb TEA,3
       defb EGG,3
       defb SOS,3
       defb TEA,2
       defb END
del11  defb SOS,5
       defb TEA,5
       defb EGG,3
       defb SAN,4
       defb MIN,5
       defb SOS,4
       defb APP,4
       defb TEA,5
       defb EGG,3
       defb SAN,4
       defb SOS,4
       defb MIN,4
       defb END


; Speed of deliveries for each level.

gispd  defb 180,175,170,180    ; delivery speeds.
       defb 200
       defb 150,160,150
       defb 145,140,150,155

delivs defw del9,del0,del1,del2,del8
       defw del3,del4,del5
       defw del6,del7,del10,del11

order0 defb SOS,99
       defb SOS,99
       defb SOS,EGG,99
       defb SOS,EGG,99
       defb EGG,TEA,99
       defb SOS,EGG,TEA,99
       defb EGG,TEA,99
       defb END
order1 defb SOS,99
       defb SOS,99
       defb SOS,EGG,99
       defb SOS,EGG,99
       defb EGG,TEA,99
       defb SOS,EGG,TEA,99
       defb EGG,TEA,99
       defb SOS,99
       defb END
order2 defb MIN,99
       defb MIN,99
       defb SAN,99
       defb SAN,MIN,99
       defb TEA,SAN,99
       defb MIN,SAN,99
       defb TEA,SAN,99
       defb SAN,TEA,MIN,99
       defb END
order3 defb SOS,TEA,99
       defb TEA,TEA,99
       defb SOS,EGG,99
       defb SOS,SOS,99
       defb TEA,EGG,SOS,99
       defb TEA,TEA,99
       defb SOS,TEA,99
       defb END
order4 defb TEA,99
       defb TEA,TEA,99
       defb SAN,99
       defb SAN,TEA,99
       defb SOS,EGG,TEA,99
       defb SOS,SOS,99
       defb SOS,EGG,TEA,99
       defb TEA,TEA,EGG,99
       defb END
order5 defb SAN,99
       defb SAN,99
       defb SAN,MIN,99
       defb MIN,99
       defb APP,TEA,99
       defb SAN,SAN,TEA,99
       defb APP,TEA,99
       defb APP,TEA,99
       defb APP,TEA,99
       defb SAN,SAN,TEA,99
       defb APP,TEA,99
       defb END
order6 defb EGG,99
       defb EGG,99
       defb SOS,EGG,99
       defb SOS,99
       defb TEA,EGG,99
       defb SOS,EGG,99
       defb MIN,99
       defb MIN,EGG,99
       defb SAN,TEA,99
       defb TEA,TEA,TEA,99
       defb MIN,EGG,99
       defb END
order7 defb SAN,99
       defb SAN,99
       defb EGG,99
       defb SAN,TEA,99
       defb TEA,EGG,99
       defb SAN,MIN,99
       defb SAN,TEA,EGG,99
       defb MIN,TEA,99
       defb SOS,EGG,99
       defb MIN,99
       defb TEA,SAN,MIN,99
       defb SAN,TEA,EGG,99
       defb SOS,EGG,99
       defb END
order8 defb APP,99
       defb APP,99
       defb APP,APP,99
       defb SAN,99
       defb SAN,99
       defb APP,SAN,99
       defb SAN,99
       defb MIN,SAN,99
       defb APP,MIN,99
       defb MIN,MIN,APP,99
       defb SAN,MIN,99
       defb APP,SAN,MIN,99
       defb MIN,APP,99
       defb END
order9 defb SOS,99
       defb SOS,99
       defb TEA,SOS,99
       defb TEA,SOS,99
       defb SOS,99
       defb SOS,TEA,99
       defb END
orde10 defb SOS,99
       defb TEA,SOS,99
       defb SOS,99
       defb TEA,99
       defb TEA,SOS,EGG,99
       defb TEA,99
       defb TEA,SOS,EGG,99
       defb TEA,SOS,EGG,99
       defb TEA,99
       defb TEA,SOS,EGG,99
       defb TEA,TEA,99
       defb TEA,SOS,EGG,99
       defb TEA,99
       defb TEA,SOS,EGG,99
       defb TEA,99
       defb TEA,SOS,EGG,99
       defb TEA,SOS,EGG,99
       defb TEA,TEA,99
       defb TEA,SOS,EGG,99
       defb SOS,EGG,99
       defb TEA,TEA,99
       defb END
orde11 defb SOS,99
       defb SOS,99
       defb SOS,TEA,99
       defb TEA,SOS,99
       defb EGG,SOS,99
       defb TEA,99
       defb SAN,99
       defb TEA,SAN,99
       defb SOS,EGG,99
       defb MIN,MIN,99
       defb MIN,SAN,99
       defb SOS,TEA,99
       defb APP,MIN,SAN,99
       defb EGG,SOS,MIN,99
       defb SOS,TEA,99
       defb TEA,APP,SAN,99
       defb TEA,SAN,EGG,99
       defb EGG,SOS,SOS,99
       defb END

ordptr defw order1         ; pointer to orders.

grace  defb 10


; Table of speeds with which orders are placed.

speeds defb 12,11,10,11,9,10,10,9,12,9,8,9

; Table of orders for each level.

orders defw order9,order0,order1,order2,order8
       defw order3,order4,order5
       defw order6,order7,orde10,orde11


rooms  defw scda00,scda05,scda03,gasman,scda04
       defw scda01,bebbin,chimny,scda02,other0
       defw nasty,horrid

; Make sure following screens are aligned on even byte address.

ALIGNW equ $
ALIGNH equ ($+1)/2
ALIGNE equ ALIGNH + ALIGNH

       org ALIGNE

nasty  defb 1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,6,6,2,3,2,3,2,3,2,3,2,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,6,6,2,3,2,3,2,3,2,3,2,3,1,1,0,0,0,0,2,3,2,3,2,3,2,3
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,2,3,2,3,2,3,1,1,0,0,2,3,2,3,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,0,0,2,3,2,3,2,3,2,3,2,3,5,5,4,4,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,2,3,2,3,0,0,0,0,0,0,0,0,2,3,2,3,2,3,4,4,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,1,1,1,1,1,1,4,4,2,3,4,4,2,3,2,3,2,3,4,4,2,3,2,3,2,3

horrid defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,2,3,2,3,1,1,0,0,2,3,2,3,0,0,2,3,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,6,6,2,3,2,3,1,1,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,3,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,4,4,2,3,2,3,1,1,0,0,2,3,2,3,2,3,2,3,2,3,2,3,2,3,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,2,3,2,3,1,1,2,3,2,3,0,0,0,0,0,0,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,4,4,2,3,2,3,4,4,2,3

scda05 defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,6,6,2,3,2,3,2,3,2,3,0,0,2,3,2,3,2,3,2,3,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,0,0,0,0,0,0,0,0,2,3,2,3,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,0,0,0,0,2,3,2,3,2,3,0,0,0,0,2,3,4,4,2,3
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,0,0,0,0,0,0,0,0,0,0,2,3,2,3,4,4,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,4,4,2,3,2,3,2,3

scda03 defb 1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,2,3,2,3,2,3,1,1,1,1,0,0,2,3,2,3,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,0,0,0,0,2,3,2,3,2,3,0,1,4,4,4,4,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0
       defb 1,1,1,1,1,1,4,4,2,3,2,3,2,3,2,3,0,0,0,0,2,3,2,3,0,1,0,0,4,4,4,4
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,0,0,0,0,2,3,2,3,2,3,2,3,2,3,2,3,4,4,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,2,3,2,3,2,3,2,3,2,3,2,3,0,0,0,0,0,0,0,0,4,4,4,4
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,6,6,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3

scda02 defb 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,00,00,01,01,01,01,01,01,01,01,01,01,01,01,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,02,03,02,03,01,01,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,01,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,01,00,00
       defb 01,01,01,01,01,01,02,03,06,06,02,03,00,00,01,01,02,03,02,03,02,03,02,03,02,03,00,00,00,01,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,01,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,01,00,00
       defb 01,01,01,01,01,01,00,00,02,03,02,03,02,03,01,01,02,03,02,03,01,01,02,03,02,03,00,00,00,01,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,00,00,00,00,00,00,00,00,01,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,00,00,00,00,00,00,00,00,01,00,00
       defb 01,01,01,01,01,01,02,03,06,06,02,03,02,03,02,03,02,03,00,00,02,03,02,03,02,03,02,03,01,01,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,02,03,02,03,02,03,02,03,02,03,04,04,02,03,00,00,00,00,02,03,02,03,02,03,02,03
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,02,03,05,05,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03

scda01 defb 01,01,01,01,01,01,00,00,01,01,01,01,01,01,01,01,01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,00,00,00,00,06,06,02,03,02,03,02,03,05,05,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,02,03,02,03,06,06,00,00,02,03,02,03,01,01,02,03,02,03,02,03,00,00,02,03,02,03
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,02,03,02,03,02,03,02,03,01,01,00,00,00,00,04,04,02,03,02,03,02,03
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,02,03,02,03,02,03,00,00,06,06,02,03,02,03,02,03,02,03,02,03,02,03,04,04,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,02,03,02,03,01,01,00,00,00,00,04,04,02,03,02,03,02,03,02,03,02,03
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,02,03,02,03,04,04,02,03,01,01,02,03,02,03,02,03,02,03,02,03,04,04,02,03,02,03

bebbin defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,3,5,5,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,2,3,0,0,0,0,0,0,0,0,0,0,0,0,5,5,2,3,2,3,0,0,0,0,1,1
       defb 1,1,1,1,1,1,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,2,3,5,5,2,3,2,3,0,0,0,0,5,5,2,3,2,3,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,2,3,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,3,4,4,0,0,0,0,1,1
       defb 1,1,1,1,1,1,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,5,5,2,3,2,3,0,0,0,0,0,0,0,0,0,0,2,3,6,6,2,3,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,1,1,4,4

gasman defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1
       defb 1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,3,2,3,2,3,2,3,2,3,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,0,0,4,4,2,3,0,0,0,0,2,3,4,4,0,0,2,3,2,3,1,1
       defb 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1
       defb 1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,2,3,2,3,2,3,2,3,0,0,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,4,4,0,0,2,3,4,4,2,3,2,3,4,4,2,3,0,0,4,4,2,3,1,1
       defb 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1
       defb 1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,4,4,2,3,2,3,1,1,1,1,2,3,2,3,4,4,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,1,1,1,1

other0 defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0
       defb 1,1,1,1,1,1,0,0,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,2,3,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,1,1,1,1,2,3,2,3,2,3,0,0,0,0,0,0,0,0,2,3,2,3,2,3,2,3
       defb 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,2,3,2,3,2,3,0,0,0,0,0,0,0,0,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,2,3,2,3
       defb 1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,1,1,2,3,0,0,0,0,0,0,1,0,0,0,0,0,0,0,4,4
       defb 0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,7,7
       defb 0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,7,7
       defb 1,1,1,1,1,1,2,3,2,3,1,1,1,1,2,3,2,3,2,3,1,1,1,1,1,1,2,3,2,3,2,3

chimny defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,1,1,1,1,0,0,2,3,1,1,4,4,2,3,1,1,2,3,0,0,1,1,1,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,2,3,4,4,1,0,0,0,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,0,0,0,1,4,4,2,3,1,0,0,0,2,3,2,3,2,3,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,2,3,4,4,1,0,0,0,0,0,0,0,0,0,1,1
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,1,1



scda00 defb 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,00,00,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,02,03,02,03,02,03,01,01
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,02,03,02,03,00,00,00,00,00,00,00,00,00,00,02,03,02,03,02,03,02,03,02,03,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,00,00,00,00,02,03,02,03,02,03,02,03,02,03,02,03,00,00,04,04,02,03,00,00,01,01
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,01
       defb 01,01,01,01,01,01,02,03,02,03,02,03,00,00,00,00,00,00,06,06,02,03,02,03,02,03,02,03,04,04,01,01
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,00,00,02,03,02,03,02,03,02,03,05,05,02,03,00,00,00,00,04,04,02,03,02,03,02,03
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 01,01,01,01,01,01,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,02,03,01,01,04,04

scda04 defb 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,4,4,2,3,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,0,0,0,0,0,1,2,3,2,3,2,3,2,3,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,2,3,2,3,2,3,2,3,0,0,0,0,0,0,0,0,0,0,2,3,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,4,4,2,3,2,3,2,3,2,3,0,0,0,0,2,3,2,3,2,3,2,3,2,3,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,2,3,4,4,2,3,5,5,0,0,0,0,0,0,0,0,0,0,2,3,4,4,2,3,2,3
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 1,1,1,1,1,1,4,4,2,3,2,3,2,3,2,3,1,1,2,3,2,3,2,3,4,4,2,3,2,3,2,3




; Menu routines.  Set up screen then straight to menu1.

menuc  call blind          ; clear the screen.
       ld hl,crtxt         ; credits text.
       call rfont          ; show the text.
       ld a,244            ; delay of approx 10 seconds.
       jr menu1            ; rest of menu.

menub  call blind          ; clear the screen.
       ld hl,22528         ; attributes address.
       ld de,22529         ; second attribute cell.
       ld (hl),6           ; set to yellow ink on black paper.
       ld bc,767           ; remaining bytes.
       ldir                ; colour rest of screen.
       ld hl,loadsc        ; place where we put loading screen.
       ld de,16384         ; physical screen address.
       ld bc,6144          ; bytes to transfer.
       ldir                ; copy to screen.
       ld a,122            ; delay of approx 5 seconds.
       jr menu1            ; rest of menu.

menua  call clrsc          ; clear screen.
       ld hl,23693         ; attributes system variable.
       ld (hl),71          ; set permanent attributes.
       call 3503           ; clear attributes too.
       ld de,bmlogo        ; logo to draw.
       ld hl,16391         ; seven chars in to screen.
       ld b,64             ; pixels per screen segment.
dlogo0 push bc             ; store line counter.
       ex de,hl            ; swap source into hl, target into de.
       ld bc,18            ; bytes to transfer to screen.
       ldir                ; copy line of image to screen.
       ex de,hl            ; swap source and target back.
       ld bc,14            ; bytes to skip.
       add hl,bc           ; point to next character line.
       pop bc              ; restore loop counter.
       djnz dlogo0

       ld hl,mtxt0         ; menu text.
       call rfont          ; show the text.
       ld a,244            ; delay of approx 10 seconds.
menu1  ld (mentim),a       ; set menu timer.
menu2  halt                ; pause for 2 50ths of a second.
       halt
       push bc             ; store count.
       call 654            ; keyboard routine.
       pop bc              ; restore count.
       ld a,e              ; test key returned.
       cp 36               ; keyboard selected?
       jp z,gamek          ; yes, select how many players.
       cp 28               ; Kempston joystick option?
       jp z,gamejk         ; yes.
       cp 20               ; is it Sinclair?
       jp z,gamejs         ; yes.
       cp 12               ; is it redefine keys?
       jp z,redkey         ; redefine them then.
       cp 4                ; is it screen editor?
       jp z,drsc           ; yes, draw screens.
       ld hl,mentim        ; menu timer.
       dec (hl)            ; one less iteration to go.
       jr nz, menu2
       jp menu0
mentim defb 0              ; menu timer.


gamek  xor a               ; keyboard setting.
       jr howc             ; start.
gamejk ld a,1              ; Kempston setting.
       jr howc             ; start.
gamejs ld a,2              ; Sinclair setting.
       jr howc             ; start.
howc   ld (contrl),a       ; set control type.
play   ld a,70             ; bright yellow on black.
       ld (23693),a        ; set attributes.
       call 3503           ; clear the screen.

       xor a               ; colour.
       ld (23560),a
       call 8859           ; set up the border.
       ld a,(23672)        ; fetch clock value.
       ld (seed),a         ; set random number seed.


; Game initialisation.

       ld hl,score         ; score.
       ld b,6              ; digits to reset.
rscor  ld (hl),27          ; set digit to zero.
       inc hl              ; point to next digit.
       djnz rscor          ; reset rest of score.

       xor a               ; put zero in accumulator.
       ld (stars),a        ; start with no stars.

       ld (levno),a        ; start at level zero.

       ld a,3              ; number three.
       ld (numlif),a       ; set up the player's lives.

; Initialise new level.

; Clear table.

newlev ld hl,ftable            ; food table.
       ld de,ftable+1          ; second byte of table.
       ld bc,TABSIZ+TABSIZ-1   ; data to transfer.
       ld (hl),255             ; set all bits.
       ldir                    ; clear rest of table.

; Set up panel.

       ld hl,pantxt        ; panel text.
       call dfont          ; show text.
       call dscor          ; display score.
       call dstar          ; show stars.
       call dwarn          ; set up warning status.
       call dfont          ; display warning.

; Set up orders for this level.

       ld hl,orders        ; table of orders.
       ld a,(levno)        ; level number.
       rlca                ; multiply by 2.
       call addac          ; add accumulator to hl.
       ld de,ordptr        ; pointer to orders.
       ldi                 ; point to this table.
       ldi                 ; don't forget second byte.

; Set up deliveries for this level.

       ld hl,delivs        ; table of deliveries.
       ld a,(levno)        ; level number.
       rlca                ; multiply by 2.
       call addac          ; add accumulator to hl.
       ld de,delptr        ; pointer to deliveries.
       ldi                 ; point to this table.
       ldi                 ; don't forget second byte.

; Now for the speed with which orders come in.

       ld a,(levno)        ; level number.
       ld hl,speeds        ; level speeds.
       call addac          ; add accumulator to hl.
       ld a,(hl)           ; get speed.
       ld (levspd),a       ; set the level speed.

; Speed of deliveries.

       call setgis         ; set goods in speed.

       ld hl,0             ; zeroes in h and l.
       ld (dispx),hl       ; set screen coordinates.
       call gradd          ; find screen.
       call droom

; Find first blank cell through which deliveries can drop.

       ld hl,rbuff         ; room buffer.
       ld b,255            ; horizontal position minus 1.
fcell  ld a,(hl)           ; fetch cell there.
       inc hl              ; point to next cell.
       inc b               ; next position to check.
       and a               ; is it a space?
       jr nz,fcell         ; no, continue.
       ld a,b              ; get position.
       rlca                ; multiply by 8 pixels.
       rlca
       rlca
       ld (drop+3),a       ; set drop coordinates.

; Initialise variables for this screen.

       xor a               ; zero in accumulator.
       ld (comps),a        ; reset complaints.
       ld (gitim),a        ; reset timer.
       ld (gfram),a        ; reset game frame timer.
       ld (dflag),a        ; reset done flag.
       ld (dtimer),a       ; reset done timer.
       ld (comps),a        ; no complaints.
       inc a               ; value of 1.
       ld (lrcnt),a        ; set left/right counter.
       ld (udcnt),a        ; same for vertical.

       ld a,(levspd)       ; level speed.
       ld (sltim0),a       ; reset customer time.
       ld (sltim1),a       ; reset customer time.
       ld (sltim2),a       ; reset customer time.
       call ran3           ; get random slot number.
       ld hl,sltim0        ; slot times.
       call addac          ; point to random slot.
       ld (hl),5           ; start one off earlier.

       call giinit         ; initialise first delivery.

       ld hl,slots         ; slots.
       ld b,12             ; bytes to delete.
init0  ld (hl),255         ; delete slot.
       inc hl              ; next byte.
       djnz init0
       call dcur           ; show cursor.

mloop  call haltr          ; synch with display.
       call dspr           ; draw/delete sprites.
       ld hl,NEWTAB        ; new sprite data.
       ld de,ftable        ; old positions.
       ld bc,TABSIZ        ; data to transfer.
       ldir                ; copy current to previous positions.
       call pspr           ; process sprites.
       call pause          ; pause mode stuff.
       call gi             ; goods in processing.
       call cust           ; customer order processing.
       call wait           ; customer waiting.
       call docon          ; game controls.
       call timer          ; end-of-level timer stuff.
       ld hl,gfram         ; game frame timer.
       inc (hl)            ; increase it.
       jp mloop


; Up the score.

uscor  ld a,(hl)           ; current value of digit.
       add a,b             ; add points to this digit.
       ld (hl),a           ; place new digit back in string.
       cp 37               ; more than value '9'?
       ret c               ; no - relax.
       sub 10              ; subtract 10.
       ld (hl),a           ; put new character back in string.
uscor0 dec hl              ; previous character in string.
       inc (hl)            ; up this by one.
       ld a,(hl)           ; what's the new value?
       cp 37               ; gone past nine?
       ret c               ; no, scoring done.
       sub 10              ; down by ten.
       ld (hl),a           ; put it back.
       jp uscor0           ; go round again.

; Display the score.

dscor  ld hl,scpos         ; position text.
       jp dfont            ; show score.
dstar  ld hl,22+18*256     ; star position.
       ld (dispx),hl       ; set the coordinates.
       ld a,71             ; colours.
       ld (23693),a        ; set attributes.
       ld a,(stars)        ; number of stars.
       and a               ; any awarded yet?
       ret z               ; no, so nothing to display.
       ld b,a              ; loop counter variable.
dstar0 push bc             ; store counter on stack.
       ld a,38             ; star character.
       call dsymb          ; show star.
       pop bc              ; retrieve counter.
       djnz dstar0         ; repeat until all drawn.
       ret

; Display warning dstatus.

dwarn  ld a,71             ; white on black, bright.
       ld (23693),a        ; set attributes.
       ld a,(numlif)       ; number of lives.
       rlca                ; multiply by 8.
       rlca
       rlca
       ld hl,wartxt        ; warnings text.
       call addac          ; 8 * lives points to text.
       ld de,wartgt        ; target address.
       ld bc,7             ; characters to display.
       ldir                ; copy across.
       ld hl,wartgt-3      ; address.
       ret

wartxt defb 19,1,3,11,5,4,ENDCHR,ENDCHR
       defb 12,5,20,20,5,18,ENDCHR,ENDCHR
       defb 22,5,18,2,1,12,ENDCHR,ENDCHR
       defb 3,12,5,1,14,0,ENDCHR,ENDCHR
       defb AT,21,26       ; position.
wartgt defb 0,0,0,0,0,0,0,ENDCHR
vwtxt  defb AT,10,9,ATTR,67
       defb 22,5,18,2,1,12,0,23,1,18,14,9,14,7,ENDCHR
wwtxt  defb AT,10,8,ATTR,66
       defb 23,18,9,20,20,5,14,0,23,1,18,14,9,14,7,ENDCHR

vwarn  ld hl,vwtxt         ; verbal warning text.
       jp rfont            ; show warning.
wwarn  ld hl,wwtxt         ; written warning text.
       call rfont          ; show warning.
       ld a,99             ; make sure dec a won't produce zero.
       ret


stars  defb 0              ; stars awarded to player.

scpos  defb AT,21,18,ATTR,70
score  defb 27,27,27,27,27,27
       defb ENDCHR


; Process Goods In.

gi     ld a,(giflag)       ; goods in flag.
       and a               ; are we delivering?
       jr nz,gidel         ; goods in delivery.
       ld a,(gfram)        ; frame counter.
       and 3               ; time to decrement good-in timer?
       ret nz              ; no, not yet.
       ld hl,gitim         ; goods-in timer.
       dec (hl)            ; decrement counter.
       ret nz              ; not time for a delivery yet.
giinit ld hl,(delptr)      ; deliveries pointer.
       ld a,(hl)           ; fetch type.
       cp 255              ; reached end of table?
       ret z               ; yes, no more deliveries to come.
       ld (gityp),a        ; set up the type.
       inc hl              ; point to number of items.
       ld a,(hl)           ; fetch number.
       ld (ginum),a        ; set up number of items.
       ld (giflag),a       ; set delivering flag.
       inc hl              ; point to next delivery.
       ld (delptr),hl      ; set up the delivery.
       ld a,(hl)           ; type of sprite to show.
       call iconab         ; get icon address.
       ld hl,21633         ; screen address.
       jp write

; Goods In deliveries.

gidel  ld hl,gitim         ; goods-in timer.
       dec (hl)            ; decrement counter.
       ld a,(hl)           ; fetch counter value.
       and 15              ; time for new item to drop?
       ret nz              ; no, not yet.
       ld ix,NEWTAB        ; where to put new entries.
       ld b,NUMITM         ; number of slots to check.
       ld de,ELSIZE        ; size of each table entry.
gi0    ld a,(ix)           ; fetch slot flag.
       inc a               ; is this enabled?
       jr z,gi1            ; no, put new item here.
       add ix,de           ; point to next table element.
       djnz gi0            ; repeat for all slots.
       ret                 ; wait until we can deliver the item.
gi1    ld a,(gityp)        ; new delivery type.
       ld (ix),a           ; set up food type.
       ld (ix+1),0         ; set direction = down.
       ld (ix+2),0         ; set vertical position to top.
drop   ld (ix+3),224       ; set horizontal to right edge.
       ld hl,fx2           ; drop sound effect.
       call isnd           ; start the sound.
       ld hl,jtabd         ; jump table.
       call psprmv         ; set jump pointer for sprite.
gi2    ld hl,ginum         ; number of items remaining.
       dec (hl)            ; one less to drop.
       ret nz              ; no reached the limit yet.
       xor a               ; zero in accumulator.
       ld (giflag),a       ; reset delivering flag.
setgis ld hl,gispd         ; goods in delivery speed.
       ld a,(levno)        ; level number.
       call addac          ; add level to speed table address.
       ld a,(hl)           ; fetch speed for this level.
       ld (gitim),a        ; set timer.
       ret



; Icon address.
; Only works for 8 icons at present.

iconab cp 255              ; is it on?
       jp z,icona0         ; no, show blank instead.
       jp icona2
iconad cp 255              ; is it on?
       jp z,icona1         ; no, show walls instead.
icona2 and 7               ; remove unwanted bits.
       rrca                ; multiply type by 32.
       rrca
       rrca
       ld c,a              ; low byte.
       xor a               ; zero in accumulator, clear carry flag.
       ld b,a              ; zeroise high byte of bc.
       ld hl,icons         ; sprite images.
       add hl,bc           ; add displacement for position.
       ex de,hl            ; put result in de.
       ret
icona0 ld de,blanks        ; blank sprite.
       ret
icona1 ld de,walls         ; blank sprite.
       ret

sltim0 defb 0              ; slot timer.
sltim1 defb 0
sltim2 defb 0

slots  defb 255,255,255,255
       defb 255,255,255,255
       defb 255,255,255,255

slotad defw 16480,16482,16484,0
       defw 18464,18466,18468,0
       defw 18656,18658,18660,0


slotc  defw 22624,22626,22628,0
       defw 22816,22818,22820,0
       defw 23008,23010,23012,0


; Display slot.
; On entry:
; A = slot number
; B = number within slot.

dslot  rlca                ; multiply slot by 4.
       rlca
       add a,b             ; add item within slot.
       ld c,a              ; displacement in low byte.
       ld b,0              ; no high byte required for displacement.

       ld hl,slots         
       add hl,bc           ; point to slot contents.
       ld a,(hl)           ; get item.
       push bc             ; store displacement on stack.
       call iconad         ; get icon image data address.
       pop bc              ; restore displacement.
       push de             ; store address away for now.

       ld hl,slotad        ; slot screen addresses.
       add hl,bc           ; point to slot address.
       add hl,bc
       ld e,(hl)           ; fetch address low.
       inc hl              ; next byte.
       ld d,(hl)           ; fetch address high.
       ex de,hl            ; put address in hl.
       pop de              ; restore pointer to image.
       jp write

; Set attributes for slot.

aslot  push af             ; store slot.
       push bc             ; store position within window.
       rlca                ; multiply slot by 4.
       rlca
       add a,b             ; add item within slot.
       ld c,a              ; displacement in low byte.
       ld b,0              ; no high byte required for displacement.

       ld hl,slotc         ; slot colour cell addresses.
       add hl,bc           ; point to slot contents.
       add hl,bc
       ld e,(hl)           ; address low.
       inc hl              ; next byte.
       ld d,(hl)           ; fetch address high.
       ex de,hl            ; put address in hl.
       pop bc              ; restore number within slot.
       ld (hl),c           ; set the colour.
       inc l               ; next cell.
       ld (hl),c           ; set the colour.
       ld de,31            ; distance to cell on next line.
       add hl,de           ; point to left cell on lower line.
       ld (hl),c           ; set the colour.
       inc l               ; next cell.
       ld (hl),c           ; set the colour.
       pop af              ; restore slot number.
       ret


; Get slot address.
; On entry:
; A = slot number
; B = number within slot.

gslot  ld hl,slots         ; slot contents.
       rlca                ; multiply slot by 4.
       rlca
       add a,b             ; item number within slot.
       ld c,a              ; displacement in low byte.
       ld b,0              ; no high byte required for displacement.
       ld hl,slots         
       add hl,bc           ; point to slot contents.
       ld a,(hl)           ; get item.
       ret

; Check slot.
; Tests if slot is empty, zero flag set if all vacant.
; Doesn't corrupt de.

cslot  ld b,0              ; first item in slot.
       call gslot          ; get address.
       inc a               ; is it empty?
       ret nz              ; no, it's taken.
       inc hl              ; next item in slot.
       ld a,(hl)           ; get item.
       inc a               ; is it empty?
       ret nz              ; no, it's taken.
       inc hl              ; next item in slot.
       ld a,(hl)           ; get item.
       inc a               ; is it empty?
       ret



; Customer waiting time.

wait   ld a,(gfram)        ; game frame number.
       add a,16            ; avoid clash with placing orders.
       and 127             ; approx once every 5 seconds or so.
       ret nz              ; don't decrement timer this time around.
       xor a               ; first window.
       ld (slot),a         ; set up the slot.

       call cslot          ; make sure there's an order.
       ld hl,sltim0        ; first slot timer.
       call nz,wtime       ; decrement window timer.
       ld hl,slot          ; current slot.
       inc (hl)            ; point to next one.
       ld a,(slot)         ; slot in accumulator.
       call cslot          ; make sure there's an order.
       ld hl,sltim1        ; next slot timer.
       call nz,wtime       ; decrement window timer.
       ld hl,slot          ; current slot.
       inc (hl)            ; point to next one.
       ld a,(slot)         ; slot in accumulator.
       call cslot          ; make sure there's an order.
       ld hl,sltim2        ; last slot timer.
       call nz,wtime       ; decrement window timer.
       ret

wtime  dec (hl)            ; decrement timer.
       ld a,(hl)           ; fetch value.
       cp 3                ; last 15 seconds?
       jp z,wtime0         ; yes, flash the order.
       and a               ; reached the end?
       ret nz              ; not reached end yet.

; Tired of waiting.  Complain to the management.

       call compln         ; make a complaint.

       ret

; Getting impatient, flash the items above the window.

wtime0 ld a,(slot)         ; slot number.
       rlca                ; multiply by 8.
       rlca
       rlca
       ld hl,slotc         ; slot colour addresses.
       call addac          ; address of attribute pointer.
       ld e,(hl)           ; low byte of address.
       inc hl              ; point to high byte.
       ld d,(hl)           ; get address high.
       ex de,hl            ; now swap into hl pair.
       ld b,40             ; attribute cells to check.
wtime1 ld a,(hl)           ; fetch colour.
       cp 78               ; bright yellow on blue?
       jp nz,wtime2        ; no, skip cell.
       ld (hl),206         ; make it flash.
wtime2 inc hl              ; next cell along.
       djnz wtime1
       ret


; Place customer orders.

cust   ld a,(gfram)        ; game frame number.
       and 31              ; reached decrement period?
       ret nz              ; no, not yet.
       ld hl,(ordptr)      ; pointer to order.
       ld a,(hl)           ; fetch item.
       inc a               ; end of level?
       jp z,ckeol          ; yes, check windows are empty.
       call ran3           ; get random number 0, 1 or 2.
       ld e,a              ; store slot number.
       ld b,0              ; first item in window.
       ld d,b              ; high byte of de.
       call cslot          ; check slot is empty, must not corrupt de.
       ret nz              ; slot isn't empty.
       ld hl,sltim0        ; slot timers.
       add hl,de           ; point to slot.
       dec (hl)            ; count down to order.
       ret nz              ; not timer to order yet.
       ld a,(levspd)       ; level speed.
       ld (hl),a           ; reset timer.
       ld a,e              ; slot number.
       ld (slot),a         ; set slot for display.
       ld b,0              ; first item.
       call gslot          ; get slot.
       ex de,hl            ; put slot address in de.
       ld hl,(ordptr)      ; pointer to order.
       ld b,0              ; zero = first slot number,
cust2  ld a,(hl)           ; get item.
       cp 99               ; is it food?
       jr nc,cust1         ; no, job done.
       push bc             ; store slot number.
       ld c,h              ; keep c out of way so b won't decrement.
       ldi                 ; transfer to slot.
       push hl             ; store order pointer.
       push de             ; store slot position.
       ld a,(slot)         ; get slot number.
       ld c,78             ; yellow on blue.
       call aslot          ; set attributes for the slot.
       call dslot          ; display slot contents.
       pop de
       pop hl
       pop bc              ; restore position within slot.
       inc b               ; count up through slot spaces.
       jr cust2
cust1  inc a               ; is it end of level?
       ret z               ; yep.
       inc hl              ; point to start of next order.
       ld (ordptr),hl      ; next order pointer.
       ld hl,sltim0        ; slot timers.
       ld a,(slot)         ; get slot number.
       call addac          ; point to relevant timer.
       ld a,(grace)        ; time permitted to service orders.
       ld (hl),a           ; set the timer.
       ret
slot   defb 0              ; slot number we're showing.


; End of level check.

ckeol  xor a               ; zero in accumulator for first window.
       call cslot          ; check slot is vacant.
       ret nz              ; it isn't.
       ld a,1              ; second window.
       call cslot          ; check slot is vacant.
       ret nz              ; it isn't.
       ld a,2              ; bottom window.
       call cslot          ; check slot is vacant.
       ret nz              ; it isn't.
       ld hl,dflag         ; done flag.
       ld (hl),h           ; set done flag to non-zero.
settmr ld hl,dtimer        ; done timer.
       ld a,(hl)           ; fetch value.
       and a               ; has this been set up already?
       ret nz              ; yes, leave it be.
       ld (hl),125         ; about 5 seconds.
       ret
dflag  defb 0              ; done flag.
dtimer defb 0              ; delay timer.

timer  ld hl,dtimer        ; delay timer.
       ld a,(hl)           ; fetch current value.
       and a               ; is it zero?
       ret z               ; yes, it hasn't been set.
       dec (hl)            ; decrement it.
       ret nz              ; not reached the end yet.
       pop de              ; remove return value from stack.
       ld a,(comps)        ; number of complaints.
       cp MAXCOM           ; reached maximum?
       jr z,timer1         ; yes, lose a life.
       ld hl,lvtxt0        ; "frying tonight" text.
       call dfont          ; display text.
       ld a,(levno)        ; current level.
       inc a               ; progress to the next one.
       cp NUMLEV           ; reached last level?
       jr c,timer0         ; not yet we haven't.
       xor a               ; start again at first level.
timer0 ld (levno),a        ; set next level.
       call exstar         ; award extra star.
       ld b,100            ; two seconds.
       call delay          ; short pause.
       jp newlev
timer1 call blind          ; venetian blind effect.
       call clatts         ; clear attributes area.
       ld hl,numlif        ; number of lives.
cheatb dec (hl)            ; one less.
       jp z,gamov          ; none left, end the game.
       ld a,(hl)           ; get lives.
       dec a               ; last one?
       call z,wwarn        ; show written warning.
       dec a               ; still two left?
       call z,vwarn        ; show verbal warning.
       call dwarn          ; set up warning status.
       call rfont          ; rotate warning into position.
       ld b,100            ; two seconds.
       call delay          ; pause.
       jp newlev           ; start again.
numlif defb 3              ; number of lives.
exstar ld a,(comps)        ; complaints received this time around.
       and a               ; any received?
       jp nz,nostar        ; yes, don't award a star.
       ld hl,stars         ; stars awarded.
       ld a,(hl)           ; find number awarded so far.
       cp 5                ; reached maximum number?
       ret nc              ; yes, no more allowed.
       inc (hl)            ; add a star.
       ld hl,lvtxt2        ; end of level text.
       call dfont          ; display text.
       call dstar          ; show stars.
       ld hl,23249         ; address to left of star attributes.
       ld a,(stars)        ; stars.
       call addac          ; get address of cell.
       ld b,25             ; one second.
exsta0 ld (hl),66          ; make it red.
       call snda           ; sound.
       halt                ; wait for frame update.
       ld (hl),70          ; make it yellow.
       call snda           ; sound.
       halt                ; wait for frame update.
       djnz exsta0         ; repeat.
       ret
nostar ld hl,lvtxt1        ; end of level text.
       jp dfont            ; display text.
delay  halt                ; wait for interrupt.
       djnz delay          ; repeat until loop counter is zero.
       ret
snda   ld d,10             ; duration.
snda0  ld e,40             ; noise frequency.
       ld a,e              ; set up bits from loop.
       rrca                ; rotate lower bits into speaker position.
       rrca
       rrca
       and 248             ; remove border bits.
       out (254),a         ; output to speaker.
snda1  dec e               ; decrement inner loop counter.
       jr nz,snda1         ; repeat.
       dec d               ; decrement duration counter.
       jr nz,snda0         ; repeat.
       ret

clatts ld hl,22528         ; first attribute cell.
       ld de,22529         ; second cell.
       ld bc,639           ; cells to blank out.
       ld (hl),71          ; set first attribute.
       ldir                ; copy to remaining cells.
       ret

gamov  call clatts         ; clear attributes.
       call dwarn          ; display warning status.
       call noisa          ; failure sound.
       xor a               ; zero for black.
       call chcol          ; set chip colour.

       ld de,chips         ; logo to draw.
       ld hl,18444         ; twelve chars in to middle segment.
       ld b,64             ; pixels per screen segment.
dchip0 push bc             ; store line counter.
       ex de,hl            ; swap source into hl, target into de.
       ld bc,8             ; bytes to transfer to screen.
       ldir                ; copy line of image to screen.
       ex de,hl            ; swap source and target back.
       ld bc,24            ; bytes to skip.
       add hl,bc           ; point to next character line.
       pop bc              ; restore loop counter.
       djnz dchip0

       ld hl,chtxt         ; chips text.
       call rfont          ; show the text.

; Now fade in the chips.

       ld a,1              ; blue.
dchip1 call chcol          ; set colour of chips.
       ld b,5              ; speed of fade.
       call delay          ; short delay.
       inc a               ; next colour.
       cp 7                ; gone past yellow?
       jr c,dchip1         ; not yet, keep fading up.

       ld b,150            ; 150 = 3 seconds.
       call delay          ; wait a bit.
       call tryhs          ; check for high scores.
       jp menu0


; Set chips' colour.

chcol  ld hl,22784         ; middle segment attributes.
       ld de,22785         ; next cell along.
       ld (hl),a           ; make first cell colour we want.
       ld bc,255           ; remaining cells.
       ldir                ; colour them all.
       ret

; Noise when player loses the game.

noisa  ld e,250
noisa2 push de
       ld b,32         ; length of step.
noisa0 push bc
       call random
       and 248
       out (254),a
       ld a,e
       cpl
noisa1 dec a
       jr nz,noisa1
       pop bc
       djnz noisa0
       pop de
       ld a,e
       sub 24          ; size of step.
       cp 30           ; end of range.
       ret z
       ret c
       ld e,a
       cpl
noisa3 ld b,40             ; silent period.
noisa4 djnz noisa4
       dec a
       jr nz,noisa3
       jr noisa2


plsnd  call plsnd1         ; first channel.
       call plsnd2         ; second one.
       call plsnd3         ; final channel.

; Write the contents of our AY buffer to the AY registers.

w8912  ld hl,snddat        ; start of AY-3-8912 register data.
       ld de,14*256        ; start with register 0, 14 to write.
       ld c,253            ; low byte of port to write.
w8912a ld b,255            ; port 65533=select soundchip register.
       out (c),e           ; tell chip which register we're writing.
       ld a,(hl)           ; value to write.
       ld b,191            ; port 49149=write value to register.
       out (c),a           ; this is what we're putting there.
       inc e               ; next sound chip register.
       inc hl              ; next byte to write.
       dec d               ; decrement loop counter.
       jp nz,w8912a        ; repeat until done.
       ret

snddat defw 0              ; tone registers, channel A.
       defw 0              ; channel B tone registers.
       defw 0              ; as above, channel C.
sndwnp defb 0              ; white noise period.
sndmix defb 60             ; tone/noise mixer control.
sndv1  defb 0              ; channel A amplitude/envelope generator.
sndv2  defb 0              ; channel B amplitude/envelope.
sndv3  defb 0              ; channel C amplitude/envelope.
sndenv defw 600            ; duration of each note.
       defb 0

; Initialise a sound.

isnd   ld de,(ch1ptr)      ; first pointer.
       ld a,(de)           ; get first byte.
       inc a               ; reached the end?
       jr z,isnd1          ; that'll do.
       ld de,(ch2ptr)      ; second pointer.
       ld a,(de)           ; get first byte.
       inc a               ; reached the end?
       jr z,isnd2          ; that'll do.
       ld de,(ch3ptr)      ; final pointer.
       ld a,(de)           ; get first byte.
       inc a               ; reached the end?
       jr z,isnd3          ; that'll do.
       ret
isnd1  ld (ch1ptr),hl      ; set up the sound.
       ret
isnd2  ld (ch2ptr),hl      ; set up the sound.
       ret
isnd3  ld (ch3ptr),hl      ; set up the sound.
       ret

ch1ptr defw spmask
ch2ptr defw spmask
ch3ptr defw spmask

plwn   inc hl              ; next byte of sound.
       and 56              ; check if we're bothering with white noise.
       ret nz              ; we're not.
       ld a,(hl)           ; fetch byte.
       ld (sndwnp),a       ; set white noise period.
       ret


plsnd2 call cksnd2         ; check sound for first channel.
       cp 255              ; reached end?
       jr z,silen2         ; silence this channel.
       and 15              ; sound bits.
       ld (sndv2),a        ; set volume for channel.
       ld a,(sndmix)       ; mixer byte.
       and 237             ; remove bits for this channel.
       ld b,a              ; store in b register.
       call plmix          ; fetch mixer details.
       and 18              ; mixer bits we want.
       or b                ; combine with mixer bits.
       ld (sndmix),a       ; new mixer value.
       call plwn           ; white noise check.
       inc hl              ; tone low.
       ld e,(hl)           ; fetch value.
       inc hl              ; tone high.
       ld d,(hl)           ; fetch value.
       ld (snddat+2),de    ; set tone.
       inc hl              ; next bit of sound.
       ld (ch2ptr),hl      ; set pointer.
       ret

plsnd3 call cksnd3         ; check sound for first channel.
       cp 255              ; reached end?
       jr z,silen3         ; silence last channel.
       and 15              ; sound bits.
       ld (sndv3),a        ; set volume for channel.
       ld a,(sndmix)       ; mixer byte.
       and 219             ; remove bits for this channel.
       ld b,a              ; store in b register.
       call plmix          ; fetch mixer details.
       and 36              ; mixer bits we want.
       or b                ; combine with mixer bits.
       ld (sndmix),a       ; new mixer value.
       call plwn           ; white noise check.
       inc hl              ; tone low.
       ld e,(hl)           ; fetch value.
       inc hl              ; tone high.
       ld d,(hl)           ; fetch value.
       ld (snddat+4),de    ; set tone.
       inc hl              ; next bit of sound.
       ld (ch3ptr),hl      ; set pointer.
       ret

plmix  ld a,(hl)           ; fetch mixer byte.
       and 192             ; mix bits are d6 and d7.
       rlca                ; rotate into d0 and d1.
       rlca
       ld e,a              ; displacement in de.
       ld d,0
       push hl             ; store pointer on stack.
       ld hl,mixtab        ; mixer table.
       add hl,de           ; point to mixer byte.
       ld a,(hl)           ; fetch mixer value.
       pop hl              ; restore pointer.
       ret
mixtab defb 63,56,7,0      ; mixer byte settings.

silen1 xor a               ; zero.
       ld (sndv1),a        ; sound off.
       ld a,(sndmix)       ; mixer byte.
       or 9                ; mix bits off.
       ld (sndmix),a       ; mixer setting for channel.
       ret
silen2 xor a               ; zero.
       ld (sndv2),a        ; sound off.
       ld a,(sndmix)       ; mixer byte.
       or 18               ; mix bits off.
       ld (sndmix),a       ; mixer setting for channel.
       ret
silen3 xor a               ; zero.
       ld (sndv3),a        ; sound off.
       ld a,(sndmix)       ; mixer byte.
       or 36               ; mix bits off.
       ld (sndmix),a       ; mixer setting for channel.
       ret
cksnd1 ld hl,(ch1ptr)      ; pointer to sound.
       ld a,(hl)           ; fetch mixer/flag.
       ret
cksnd2 ld hl,(ch2ptr)      ; pointer to sound.
       ld a,(hl)           ; fetch mixer/flag.
       ret
cksnd3 ld hl,(ch3ptr)      ; pointer to sound.
       ld a,(hl)           ; fetch mixer/flag.
       ret

plsnd1 call cksnd1         ; check sound for first channel.
       cp 255              ; reached end?
       jr z,silen1         ; silence first channel.
       and 15              ; sound bits.
       ld (sndv1),a        ; set volume for channel.
       ld a,(sndmix)       ; mixer byte.
       and 246             ; remove bits for this channel.
       ld b,a              ; store in b register.
       call plmix          ; fetch mixer details.
       and 9               ; mixer bits we want.
       or b                ; combine with mixer bits.
       ld (sndmix),a       ; new mixer value.
       call plwn           ; white noise check.
       inc hl              ; tone low.
       ld e,(hl)           ; fetch value.
       inc hl              ; tone high.
       ld d,(hl)           ; fetch value.
       ld (snddat),de      ; set tone.
       inc hl              ; next bit of sound.
       ld (ch1ptr),hl      ; set pointer.
       ret

fx1    defb 064+12         ; volume and mixer.
       defb 0              ; white noise.
       defw 5400           ; tone register.
       defb 064+12         ; volume and mixer.
       defb 0              ; white noise.
       defw 5390           ; tone register.
       defb 064+11         ; volume and mixer.
       defb 0              ; white noise.
       defw 5380           ; tone register.
       defb 064+11         ; volume and mixer.
       defb 0              ; white noise.
       defw 5370           ; tone register.
       defb 064+10         ; volume and mixer.
       defb 0              ; white noise.
       defw 5360           ; tone register.
       defb 064+8          ; volume and mixer.
       defb 0              ; white noise.
       defw 5350           ; tone register.
       defb 064+6          ; volume and mixer.
       defb 0              ; white noise.
       defw 5340           ; tone register.
       defb 064+3          ; volume and mixer.
       defb 0              ; white noise.
       defw 5330           ; tone register.
       defb 064+0          ; volume and mixer.
       defb 0              ; white noise.
       defw 5320           ; tone register.
       defb 064+0          ; volume and mixer.
       defb 0              ; white noise.
       defw 5310           ; tone register.
       defb 255

; Level complete.

fx2    defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4300           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4280           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4260           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4290           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4270           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4250           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4280           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4260           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4240           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4230           ; tone register.
       defb 255

; Kill player.

fx3    defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5100           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5110           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5130           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5160           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5200           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5250           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5310           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5380           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5460           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 5550           ; tone register.
       defb 255

fx0    defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 6800           ; tone register.
       defb 064+15         ; volume and mixer.
       defb 0              ; white noise.
       defw 4900           ; tone register.
       defb 064+14         ; volume and mixer.
       defb 0              ; white noise.
       defw 6600           ; tone register.
       defb 064+14         ; volume and mixer.
       defb 0              ; white noise.
       defw 4850           ; tone register.
       defb 064+13         ; volume and mixer.
       defb 0              ; white noise.
       defw 6400           ; tone register.
       defb 064+13         ; volume and mixer.
       defb 0              ; white noise.
       defw 4800           ; tone register.
       defb 064+12         ; volume and mixer.
       defb 0              ; white noise.
       defw 6200           ; tone register.
       defb 064+12         ; volume and mixer.
       defb 0              ; white noise.
       defw 4750           ; tone register.
       defb 064+11         ; volume and mixer.
       defb 0              ; white noise.
       defw 6000           ; tone register.
       defb 064+10         ; volume and mixer.
       defb 0              ; white noise.
       defw 4700           ; tone register.
       defb 255


; Pseudo-random number generator.
; Steps a pointer through the ROM (held in seed), returning the contents
; of the byte at that location.

random ld hl,(seed)        ; pointer to ROM.
       ld a,h
       cp 58               ; approaching end of "random" area?
       jr nc,rand0         ; yes - reset pointer.
       ld a,(hl)           ; get "random" number from location.
       xor l               ; more randomness.
       inc hl              ; increment pointer.
       ld (seed),hl
       ret
rand0  ld hl,0             ; reset pointer.
       ld (seed),hl
       ret
seed   defw 0

; Random number between 0 and 2 inclusive.

ran3   call random         ; get random number.
       and 3               ; want it in range 0 - 3.
       cp 3                ; is it 3?
       jp z,ran3           ; that slot doesn't exist.
       ret

; Add accumulator to hl pair.

addac  ld e,a              ; copy to de.
       ld d,0
       add hl,de           ; point to orders for this screen.
       ret


; Display current room.

droom  ld de,rbuff         ; room buffer area.
       ld bc,20*32         ; size of room to transfer.
       ldir                ; transfer screen prior to display.
       ld hl,rbuff         ; now start at room buffer.
       ld b,20             ; screen is 18 rows high.
droom2 push bc             ; push row counter.
       ld b,32             ; screen is 32 columns wide.
droom1 push bc             ; push column counter.
       push hl
       call findad
       ld a,(hl)
droom4 push af             ; store block type on stack.
       rlca
       rlca
       rlca
       ld c,a
       and 7
       ld b,a
       ld a,c
       and 248
       ld c,a
       ld hl,blkgfx        ; address of block graphics.
       add hl,bc
       ld b,8
droom0 ld a,(hl)           ; block graphic data.
       ld (de),a           ; transfer to screen.
       inc hl
       inc d
       djnz droom0
       pop af              ; remove copy of block type from stack.
       ld e,a              ; displacement in de.
       ld d,0              ; no high byte.
       push de             ; store displacement.
       ld hl,blcols        ; block colours.
       add hl,de           ; point to attributes.
       ex de,hl            ; get address in de.
       call atadd          ; address of character's attributes.
       ld a,(de)           ; get attributes.
       ld (hl),a           ; write to screen.
       pop de              ; remove displacement from stack.
       ld hl,chprop        ; block properties.
       add hl,de           ; point to this block's properties.
       ex de,hl
       call bufadd         ; address of buffer position.
       ld a,(de)           ; get cell properties.
       ld (hl),a           ; write to buffer.
       ld hl,dispy
       inc (hl)
       pop hl
       inc hl
       pop bc              ; pop column counter.
       djnz droom1         ; next column.
       ld de,(dispx)
       inc e
       ld d,0
       ld (dispx),de
       pop bc              ; pop row counter.
       djnz droom2         ; next row.
       ret

; Find address for character block at (dispx, dispy).

findad ld a,(dispx)
       ld e,a
       and 24              ; which segment, 1 to 3?
       or 64               ; 64 * 256 = 16384, start of screen.
       ld d,a
       ld a,e
       and 7               ; which row within segment?
       rrca                ; multiply row by 32.
       rrca
       rrca
       ld e,a
       ld a,(dispy)        ; add on y coordinate.
       add a,e
       ld e,a              ; displacement to screen address in DE.
       ret

dispx  defb 0
dispy  defb 0

; Calculate address of attribute for character at (dispx, dispy).

atadd  ld a,(dispx)        ; x position.
       rrca                ; multiply by 32.
       rrca
       rrca
       ld l,a              ; store away in l.
       and 3               ; mask bits for high byte.
       add a,88            ; 88*256=22528, start of attributes.
       ld h,a              ; high byte done.
       ld a,l              ; get x*32 again.
       and 224             ; mask low byte.
       ld l,a              ; put in l.
       ld a,(dispy)        ; get y displacement.
       add a,l             ; add to low byte.
       ld l,a              ; hl=address of attributes.
       ret

; Calculate address of buffer position for character at (dispx, dispy).

bufadd ld a,(dispx)        ; x position.
       rrca                ; multiply by 32.
       rrca
       rrca
       ld l,a              ; store away in l.
       and 3               ; mask bits for high byte.
       add a,253           ; 88*256=22528, start of attributes.
       ld h,a              ; high byte done.
       ld a,l              ; get x*32 again.
       and 224             ; mask low byte.
       ld l,a              ; put in l.
       ld a,(dispy)        ; get y displacement.
       add a,l             ; add to low byte.
       ld l,a              ; hl=address of attributes.
       ret


; Screen address.
; Customised version, uses c register because sprite routine uses it
; for low byte of mask address when calculating shifts.

scadd  ld a,(dispx)        ; vertical position.
       ld c,a              ; store in c register.
       and 7               ; get position within char cell.
       add a,64            ; add to screen start address.
       ld h,a              ; place that in high byte.
       ld a,c              ; restore the vertical.
       rrca                ; divide by 8 to find segment.
       rrca
       rrca
       and 24              ; 0, 8 and 16 for segment displacement.
       add a,h             ; add to high byte.
       ld h,a              ; store in high byte.
       ld a,c              ; restore vertical again.
       rlca                ; multiply by 4.
       rlca
       and 224             ; multiples of 32 wanted.
       ld l,a              ; put in low byte.
       ld a,(dispy)        ; fetch horizontal position.
       ld c,a              ; copy to c register.
       rrca
       rrca
       rrca
       and 31
       add a,l
       ld l,a
       ret                 ; hl = address of screen.


; Return character cell address of block at (dispx, dispy).

chadd  ld a,(dispx)        ; vertical position.
       ld e,a              ; store in e.
       and 24              ; which segment, 1 to 3?
       add a,64            ; 64*256 = 16384, Spectrum's screen memory.
       ld d,a              ; this is our high byte.
       ld a,e              ; what was that vertical position again?
       and 7               ; which row within segment?
       rrca                ; multiply row by 32.
       rrca
       rrca
       ld e,a              ; low byte.
       ld a,(dispy)        ; add on y coordinate.
       add a,e             ; mix with low byte.
       ld e,a              ; address of screen position in de.
       ret



; Write sprite to screen.
; Overwrites, and sprite must be char-aligned.

write  ld b,16             ; number of lines to write.
write0 ld a,(de)           ; source byte.
       ld (hl),a           ; write result.
       inc l               ; next target address.
       inc de              ; next source byte of line.
       ld a,(de)           ; source byte.
       ld (hl),a           ; write result.
       inc de              ; next source byte.
       dec l               ; restore hl to start of line.

; Line drawn, now work out next target address.

       inc h               ; increment pixel.
       ld a,h              ; get pixel address.
       and 7               ; straddling character position?
       jr nz,write1        ; no, we're on next line already.
       ld a,h              ; get pixel address.
       sub 8               ; subtract 8 for start of segment.
       ld h,a              ; new high byte of address.
       ld a,l              ; get low byte of address.
       add a,32            ; one line down.
       ld l,a              ; new low byte.
       jr nc,write1        ; not reached next segment yet.
       ld a,h              ; address high.
       add a,8             ; add 8 to next segment.
       ld h,a              ; new high byte.
write1 djnz write0
       ret


rcur   ld hl,(cursx)       ; player x position.
       ld (dispx),hl       ; set display coordinates.
       call getcel         ; get address of cells at cursor.
       ld a,(hl)           ; first cell number.
       push hl             ; store cell address on stack.
       call ccell          ; colour cell.
       ld hl,dispy         ; get cell y position.
       inc (hl)            ; look one cell to the right.
       pop hl              ; restore cell address in screen.
       inc hl              ; look one cell right.
       ld a,(hl)           ; first cell number.
ccell  ld e,a              ; displacement in de.
       ld d,0              ; no high byte.
       ld hl,blcols        ; block colours.
       add hl,de           ; point to attributes.
       ex de,hl            ; get address in de.
       call atadd          ; address of character's attributes.
       ld a,(de)           ; get attributes.
       ld (hl),a           ; write to screen.
       ret


dcur   ld hl,(cursx)       ; player x position.
       ld (dispx),hl       ; set display coordinates.
       call atadd          ; find attributes of this position.
       ld (hl),79          ; highlight attributes.
       inc l               ; next cell position.
       ld (hl),79          ; write second cell.
       ret

; Work out address of cell for character at (dispx, dispy).

getcel ld hl,(cursx)       ; player x position.
       ld (dispx),hl       ; set display coordinates.
       call atadd          ; find attributes of this position.
       ld a,h              ; high byte of attributes.
       and 3               ; only want in range 0 - 2.
       ld h,a              ; displacement.
       ld de,rbuff         ; room data.
       add hl,de           ; point to cell.
       ret

; Display or delete cell at (dispx, dispy).

dcell  call findad         ; find screen address.
       ld a,(hl)           ; get cell at address.
dchar  rlca                ; multiply cell by 8.
       rlca
       rlca
       ld c,a              ; store in c register.
       and 7               ; remove all but high byte bits.
       ld b,a              ; store in high byte of bc.
       ld a,c              ; restore the shift result.
       and 248             ; need low byte bits now.
       ld c,a              ; low byte in c register.
       ld hl,blkgfx        ; address of block graphics.
       add hl,bc           ; add displacement for block.
       ex de,hl            ; flip source and target addresses.
       ld b,8
dchar0 ld a,(de)           ; block graphic data.
       xor (hl)            ; merge with existing image.
       ld (hl),a           ; transfer to screen.
       inc de              ; next image byte.
       inc h               ; next screen address.
       djnz dchar0         ; repeat for 8 pixel lines of cell.
       ret

; Delete or draw platform.

dplat  push hl             ; store cell address on stack.
       call dcell          ; delete cell.
       ld hl,dispy         ; get cell y position.
       inc (hl)            ; look one cell to the right.
       pop hl              ; restore cell address in screen.
       inc hl              ; look one cell right.
       ld a,(hl)           ; second cell number.
       call dcell          ; delete cell.
       ld hl,dispy         ; get cell y position.
       dec (hl)            ; go back to previous position.
       ret


cursx  defb 7
cursy  defb 8

; Icons.

icons  equ $

; Sausages.

       defb 0,0,0,224,97,240,241,248,241,248,240,252,248,124,248,126
       defb 252,62,124,62,126,62,63,126,63,124,31,124,14,56,0,0

; Eggs.

       defb 0,0,1,240,7,252,31,254,63,254,127,254,127,250,255,250
       defb 255,246,255,244,127,252,127,232,63,216,31,112,7,192,0,0

; Tea.

       defb 0,0,0,0,0,0,255,224,170,188,213,118,255,226,255,246
       defb 255,252,255,224,255,224,127,192,63,128,0,0,0,0,0,0

; Mineral water.

       defb 0,0,0,0,0,16,0,56,1,220,2,232,7,112,11,176
       defb 29,208,46,224,55,64,59,128,29,0,14,0,0,0,0,0

; Sandwiches.

       defb 0,0,0,80,0,208,1,208,3,208,7,208,15,208,31,208
       defb 63,208,127,208,63,208,15,208,3,208,0,208,0,0,0,0

; Apple.

       defb 0,0,12,120,14,240,3,192,29,56,63,252,63,252,127,254
       defb 127,254,127,254,63,252,63,252,31,248,15,240,3,192,0,0


walls  defb 239,239,239,239,239,239,0,0
       defb 254,254,254,254,254,254,0,0
       defb 239,239,239,239,239,239,0,0
       defb 254,254,254,254,254,254,0,0

blanks defw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0



; Sprites.

sprgfx equ $

; Sausage left.

       defb 1,194,163,236,71,230,167,228,39,200,31,240,15,128,15,128
       defb 15,192,7,192,7,224,7,240,11,232,9,200,24,28,60,30
       defb 0,0,0,112,0,248,169,250,17,249,173,242,35,252,3,224
       defb 3,224,3,240,1,240,1,248,3,252,4,250,216,113,252,1
       defb 0,28,0,62,0,126,0,126,32,124,72,252,245,251,78,248
       defb 4,252,8,124,0,126,0,127,128,190,128,156,193,129,227,193
       defb 0,7,128,15,128,31,170,159,17,31,42,255,194,62,0,62
       defb 0,63,0,31,128,31,128,31,128,31,0,23,192,59,192,59

; Sausage right.

       defb 67,128,55,197,103,226,39,229,19,228,15,248,1,240,1,240
       defb 3,240,3,224,7,224,15,224,23,208,19,144,56,24,120,60
       defb 0,0,0,224,1,240,85,249,137,248,84,251,67,252,0,124
       defb 0,124,0,252,0,248,1,248,3,252,5,242,184,225,248,3
       defb 0,56,0,124,0,126,0,126,4,62,18,63,175,223,114,31
       defb 32,63,16,62,0,126,0,254,1,125,1,57,131,129,199,131
       defb 0,14,0,31,128,31,149,95,136,143,245,79,196,55,192,7
       defb 192,15,128,15,128,31,128,31,128,31,128,14,192,61,192,61


; Egg left.

       defb 0,0,15,128,63,224,127,248,127,252,255,254,255,254,127,255
       defb 127,255,63,255,63,254,31,254,15,24,3,108,28,112,15,0
       defb 0,0,3,224,15,248,31,254,31,255,191,255,191,255,223,255
       defb 223,255,207,255,143,255,7,255,137,254,220,249,143,131,3,14
       defb 0,248,3,254,135,255,199,255,239,255,239,255,247,255,247,255
       defb 243,255,227,255,224,255,195,15,131,187,0,227,128,64,128,15
       defb 0,62,128,255,225,255,241,255,251,255,251,255,253,255,253,255
       defb 252,255,248,255,248,127,240,35,96,29,0,31,0,0,128,15


; Egg right.

       defb 0,0,1,240,7,252,31,254,63,254,127,255,127,255,255,254
       defb 255,254,255,252,127,252,127,248,24,240,54,192,14,56,0,240
       defb 0,124,1,255,135,255,143,255,223,255,223,255,191,255,191,255
       defb 63,255,31,255,31,254,15,196,6,184,0,248,0,0,1,240
       defb 0,31,192,127,225,255,227,255,247,255,247,255,239,255,239,255
       defb 207,255,199,255,7,255,195,240,193,221,0,199,1,2,1,240
       defb 0,0,192,7,240,31,248,127,248,255,253,255,253,255,251,255
       defb 251,255,243,255,241,255,224,255,145,127,59,159,241,193,192,112

; Tea left.

       defb 0,0,0,0,127,240,85,94,106,187,127,241,127,251,127,254
       defb 127,240,127,240,63,224,63,192,15,112,24,96,13,192,124,0
       defb 0,0,0,0,31,252,149,87,218,174,95,252,223,254,159,255
       defb 31,252,31,252,15,248,14,248,17,128,31,56,14,28,4,120
       defb 0,0,7,255,229,85,182,171,23,255,183,255,231,255,7,255
       defb 7,255,3,254,3,174,1,52,0,240,1,128,0,12,0,124
       defb 0,0,193,255,121,85,237,170,197,255,237,255,249,255,193,255
       defb 193,255,128,255,128,247,0,108,0,7,0,30,0,16,0,124


; Tea right.

       defb 0,0,0,0,15,254,122,170,221,86,143,254,223,254,127,254
       defb 15,254,15,254,7,252,3,252,14,240,6,24,3,176,0,62
       defb 0,0,131,255,158,170,183,85,163,255,183,255,159,255,131,255
       defb 131,255,1,255,1,239,0,54,0,224,0,120,0,8,0,62
       defb 0,0,224,255,167,170,109,213,232,255,237,255,231,255,224,255
       defb 224,255,192,127,192,117,128,44,0,15,128,1,0,48,0,62
       defb 0,0,0,0,248,63,169,234,91,117,250,63,251,127,249,255
       defb 248,63,248,63,240,31,112,31,136,1,248,28,112,56,32,30


; Bottle left.

       defb 8,0,20,0,43,128,23,64,14,224,13,208,11,184,7,116
       defb 2,236,1,220,2,184,51,112,30,112,28,28,12,60,0,248
       defb 2,0,5,0,10,224,5,208,3,184,3,116,2,238,1,221
       defb 0,187,0,119,0,126,3,108,3,240,0,240,0,12,0,252
       defb 0,128,1,64,2,184,1,116,0,238,0,221,128,187,64,119
       defb 192,46,192,29,128,59,0,60,0,15,0,31,0,220,0,224
       defb 0,32,0,80,0,174,0,93,128,59,64,55,224,46,208,29
       defb 176,11,112,7,224,2,192,11,240,13,112,24,96,252,224,252


; Bottle right.

       defb 0,16,0,40,1,212,2,232,7,112,11,176,29,208,46,224
       defb 55,64,59,128,29,192,3,192,15,0,15,128,3,176,0,112
       defb 0,4,0,10,0,117,0,186,1,220,2,236,7,116,11,184
       defb 13,208,14,224,7,224,3,108,0,252,0,240,3,0,3,240
       defb 0,1,128,2,64,29,128,46,0,119,0,187,1,221,2,238
       defb 3,116,3,184,1,212,192,236,128,231,131,131,3,195,1,240
       defb 64,0,160,0,80,7,160,11,192,29,192,46,64,119,128,187
       defb 0,221,0,238,0,116,0,61,0,251,128,225,240,99,240,115


; Sarnies left.

       defb 0,40,0,232,3,232,15,232,63,232,31,232,15,232,7,232
       defb 3,232,1,232,2,232,51,104,30,112,28,28,12,60,0,248
       defb 0,10,0,58,0,250,3,250,15,250,7,250,3,250,1,250
       defb 0,250,0,26,0,122,3,106,3,242,0,240,0,12,0,252
       defb 128,2,128,14,128,62,128,254,131,254,129,254,128,254,128,126
       defb 128,62,128,30,128,58,128,60,0,15,0,31,0,220,0,224
       defb 160,0,160,3,160,15,160,63,160,255,160,127,160,63,160,31
       defb 160,15,160,7,160,3,192,11,240,13,112,24,96,252,224,252


; Sarnies right.

       defb 20,0,23,0,23,192,23,240,23,252,23,248,23,240,23,224
       defb 23,192,23,128,23,64,22,204,14,120,56,56,60,48,31,0
       defb 5,0,5,192,5,240,5,252,5,255,5,254,5,252,5,248
       defb 5,240,5,224,5,192,3,208,15,176,14,24,6,63,7,63
       defb 1,64,1,112,1,124,1,127,193,127,129,127,1,127,1,126
       defb 1,124,1,120,1,92,1,60,0,240,0,248,0,59,0,7
       defb 0,80,0,92,0,95,192,95,240,95,224,95,192,95,128,95
       defb 0,95,0,88,0,94,192,86,192,79,0,15,0,48,0,63


; Apple left.

       defb 12,120,14,240,3,192,29,56,63,252,63,252,127,254,127,254
       defb 127,254,63,252,63,252,31,248,15,244,11,236,28,24,124,56
       defb 3,30,3,188,0,240,7,78,15,255,15,255,159,255,159,255
       defb 159,255,15,255,15,255,55,254,23,252,29,231,12,15,0,62
       defb 128,199,0,239,0,60,129,211,195,255,195,255,231,255,231,255
       defb 231,255,195,255,195,255,129,255,7,255,3,198,0,15,0,63
       defb 224,49,192,59,0,15,224,116,240,255,240,255,249,255,249,255
       defb 249,255,240,255,240,255,224,127,192,63,192,27,192,28,0,126


; Apple right.

       defb 30,48,15,112,3,192,28,184,63,252,63,252,127,254,127,254
       defb 127,254,63,252,63,252,31,251,15,250,57,238,60,12,31,0
       defb 7,140,3,220,0,240,7,46,15,255,15,255,159,255,159,255
       defb 159,255,15,255,15,255,7,254,11,252,13,244,6,14,135,15
       defb 1,227,0,247,0,60,129,203,195,255,195,255,231,255,231,255
       defb 231,255,195,255,195,255,129,255,0,255,0,246,0,206,128,31
       defb 192,120,192,61,0,15,224,114,240,255,240,255,249,255,249,255
       defb 249,255,240,255,240,255,224,127,248,63,240,24,0,60,0,63


; Explosion frame 1.

       defb 0,0,0,0,48,96,120,240,120,240,120,240,63,224,7,128
       defb 7,128,3,40,28,28,60,28,60,72,24,224,0,64,0,0
       defb 0,0,0,0,12,24,30,60,30,60,30,60,15,248,1,224
       defb 1,224,0,202,7,7,15,7,15,18,6,56,0,16,0,0
       defb 0,0,0,0,3,6,7,143,7,143,7,143,3,254,0,120
       defb 0,120,128,50,193,193,195,193,131,196,1,142,0,4,0,0
       defb 0,0,0,0,128,193,193,227,193,227,193,227,128,255,0,30
       defb 0,30,160,12,112,112,112,240,32,241,128,99,0,1,0,0


; Explosion frame 2.

       defb 0,0,48,112,120,248,253,248,253,248,253,248,127,248,63,224
       defb 7,252,31,254,62,126,127,126,127,254,63,252,30,240,0,0
       defb 0,0,12,28,30,62,63,126,63,126,63,126,31,254,15,248
       defb 1,255,135,255,143,159,159,223,159,255,15,255,7,188,0,0
       defb 0,0,3,7,135,143,143,223,143,223,143,223,135,255,3,254
       defb 192,127,225,255,227,231,231,247,231,255,195,255,1,239,0,0
       defb 0,0,192,193,225,227,227,247,227,247,227,247,225,255,128,255
       defb 240,31,248,127,248,249,249,253,249,255,240,255,192,123,0,0

; Explosion frame 3.

       defb 48,248,121,252,127,254,255,254,255,254,255,254,127,254,127,252
       defb 63,254,63,254,126,255,255,127,255,254,255,254,127,252,28,56
       defb 12,62,30,127,159,255,191,255,191,255,191,255,159,255,31,255
       defb 143,255,143,255,223,191,255,223,191,255,191,255,31,255,7,14
       defb 131,15,199,159,231,255,239,255,239,255,239,255,231,255,199,255
       defb 227,255,227,255,247,239,255,247,239,255,239,255,199,255,129,195
       defb 224,195,241,231,249,255,251,255,251,255,251,255,249,255,241,255
       defb 248,255,248,255,253,251,255,253,251,255,251,255,241,255,224,112

; Explosion frame 4.

       defb 120,252,253,254,255,254,239,207,207,239,255,255,254,254,127,252
       defb 63,254,57,239,126,95,255,63,255,63,255,254,127,254,62,124
       defb 30,63,191,127,191,255,251,243,243,251,255,255,191,191,31,255
       defb 143,255,206,123,223,151,255,207,255,207,191,255,159,255,15,159
       defb 199,143,239,223,239,255,254,252,252,254,255,255,239,239,199,255
       defb 227,255,243,158,247,229,255,243,255,243,239,255,231,255,195,231
       defb 241,227,251,247,251,255,63,191,191,63,255,255,251,251,241,255
       defb 248,255,188,231,125,249,255,252,255,252,251,255,249,255,240,249

; Explosion frame 5.

       defb 120,140,253,222,191,222,207,143,195,111,222,247,254,240,124,240
       defb 56,230,0,79,124,31,254,63,255,51,247,54,127,126,62,124
       defb 30,35,191,119,175,247,243,227,240,219,247,189,63,188,31,60
       defb 142,57,192,19,223,7,255,143,255,204,189,205,159,223,15,159
       defb 199,136,239,221,235,253,252,248,252,54,125,239,15,239,7,207
       defb 99,142,240,4,247,193,255,227,63,243,111,115,231,247,195,231
       defb 49,226,123,247,122,255,63,62,191,13,223,123,195,251,193,243
       defb 152,227,60,1,125,240,255,248,207,252,219,220,249,253,240,249

; Explosion frame 6.

       defb 48,128,61,220,29,206,141,142,192,7,206,66,222,224,28,224
       defb 24,70,0,15,56,31,126,15,198,0,195,6,119,78,30,108
       defb 12,32,15,119,135,115,163,99,240,1,179,144,55,184,7,56
       defb 134,17,192,3,206,7,223,131,49,128,176,193,157,211,7,155
       defb 3,8,195,221,225,220,232,216,124,0,44,228,13,238,1,206
       defb 97,132,240,0,243,129,247,224,12,96,108,48,231,116,193,230
       defb 0,194,112,247,56,119,58,54,31,0,11,57,131,123,128,115
       defb 24,97,60,0,124,224,61,248,3,24,27,12,57,221,176,121


; Complaint graphic.

compgf defb 50,128,26,128,207,128,111,192,62,224,95,102,62,63,119,255
       defb 47,254,111,248,55,192,31,0,31,0,31,224,15,240,7,224


; Banger Management logo.

bmlogo defb 0,0,0,0,0,0,0,0,0,0,15,224,0,0,0,0,0,0
       defb 255,135,252,15,255,240,31,241,255,7,252,127,193,255,254,31,241,255
       defb 255,255,248,31,247,248,31,253,255,7,252,0,1,255,252,31,255,254
       defb 255,135,252,63,227,254,31,247,255,7,252,255,193,255,0,31,241,255
       defb 255,143,252,127,193,255,31,241,255,7,252,127,193,255,255,31,241,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,127,135,188,63,124,61,225,243,227,224,127,191,207,129,251,224,248
       defb 251,239,143,254,62,252,127,241,243,227,224,125,247,207,129,247,224,248
       defb 255,255,0,7,255,224,31,129,255,0,127,248,1,255,254,31,255,224
       defb 255,135,252,15,247,240,31,241,255,7,252,127,193,255,0,31,241,255
       defb 255,255,240,31,247,248,31,255,255,7,252,0,1,255,252,31,255,254
       defb 255,135,252,63,255,254,31,247,255,7,252,127,193,255,0,31,241,255
       defb 255,255,252,127,193,255,31,241,255,3,252,255,193,255,255,31,241,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,127,135,188,63,124,61,225,243,227,224,127,191,207,129,251,224,248
       defb 251,239,159,255,62,252,255,249,243,227,224,125,247,207,129,247,224,248
       defb 255,255,192,7,255,224,31,193,255,0,255,254,1,255,254,31,255,248
       defb 255,135,252,15,247,240,31,241,255,7,252,127,193,255,0,31,241,255
       defb 255,255,128,31,227,252,31,255,255,7,252,0,1,255,252,31,255,252
       defb 255,135,252,63,255,254,31,247,255,7,252,127,193,255,0,31,241,255
       defb 255,255,252,127,193,255,31,240,255,3,255,255,193,255,255,31,241,255
       defb 252,31,131,248,60,124,31,192,63,3,252,126,15,207,241,227,231,255
       defb 255,127,135,188,63,124,61,225,240,3,252,127,191,207,241,251,224,248
       defb 249,207,159,255,62,124,255,249,243,227,224,124,231,207,129,243,224,248
       defb 255,255,240,7,255,224,31,193,255,1,255,255,1,255,254,31,255,252
       defb 255,135,252,15,247,240,31,249,255,7,252,127,193,255,0,31,241,255
       defb 255,255,224,31,227,252,31,255,255,7,252,255,193,255,252,31,255,224
       defb 255,135,252,63,255,254,31,243,255,7,252,127,193,255,0,31,241,255
       defb 255,255,248,255,193,255,31,240,255,3,255,255,193,255,255,31,241,255
       defb 252,31,131,248,60,124,31,192,255,195,252,126,15,207,241,227,231,255
       defb 255,127,143,188,63,252,125,225,240,3,252,127,191,207,241,255,224,248
       defb 249,207,159,31,62,124,248,249,255,227,254,124,231,207,249,243,224,248
       defb 255,255,240,7,255,224,31,193,255,3,255,255,1,255,254,31,255,254
       defb 255,135,252,15,247,248,31,249,255,7,252,127,193,255,0,31,241,255
       defb 255,255,248,31,227,252,31,255,255,7,252,255,193,255,252,31,255,252
       defb 255,135,252,127,255,254,31,243,255,7,252,127,193,255,0,31,241,255
       defb 255,255,248,255,193,255,159,240,255,1,255,239,193,255,255,31,241,255
       defb 252,31,131,248,62,124,31,192,255,195,252,126,15,207,241,243,231,255
       defb 255,255,143,30,63,252,120,241,247,227,252,127,255,207,241,255,224,248
       defb 249,207,159,31,62,124,248,248,255,227,254,124,231,207,249,243,224,248
       defb 255,255,248,7,255,224,31,225,255,3,255,255,129,255,254,31,255,254
       defb 255,135,252,15,247,248,31,249,255,7,252,127,193,255,0,31,241,255
       defb 255,255,248,63,227,252,31,255,255,7,252,255,193,255,252,31,255,254
       defb 255,135,252,127,255,254,31,243,255,7,252,127,193,255,0,31,241,255
       defb 255,255,240,255,193,255,159,240,127,0,255,239,193,255,255,31,241,255
       defb 254,63,135,248,62,124,63,193,255,227,252,127,31,207,241,243,231,255
       defb 255,255,143,30,63,252,120,241,247,227,252,127,255,207,241,255,224,248
       defb 249,207,159,31,62,60,248,248,254,227,254,124,231,207,249,241,224,248
       defb 255,255,248,15,255,240,31,225,255,3,252,127,129,255,254,31,255,254
       defb 255,135,252,31,247,248,31,253,255,7,252,127,193,255,0,31,241,255
       defb 255,143,252,63,227,252,31,255,255,7,252,255,193,255,252,31,243,254
       defb 255,135,252,127,255,255,31,241,255,7,252,127,193,255,0,31,241,255
       defb 255,255,192,255,193,255,159,240,127,0,127,207,193,255,255,31,241,255
       defb 254,63,135,188,62,124,61,225,243,227,224,127,31,207,129,243,224,248
       defb 251,239,143,30,63,252,120,241,247,227,224,125,247,207,129,255,224,248
       defb 249,207,159,31,62,60,248,248,62,227,254,124,231,207,249,241,224,248
       defb 255,143,252,15,255,240,31,225,255,7,252,127,193,255,254,31,243,255
       defb 255,143,252,31,247,248,31,253,255,7,252,0,1,255,0,31,243,255
       defb 255,135,252,63,227,252,31,247,255,7,252,255,193,255,0,31,241,255
       defb 255,135,252,127,255,255,31,241,255,7,252,127,193,255,255,31,241,255
       defb 0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0
       defb 254,63,135,188,62,124,61,225,243,227,224,127,31,207,129,243,224,248
       defb 251,239,143,254,62,252,127,241,243,227,224,125,247,207,129,247,224,248
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

; Chips.

chips  defb 0,0,0,0,0,0,0,0,0,6,204,29,243,188,0,0
       defb 1,248,207,96,7,238,120,0,3,167,241,221,231,217,207,192
       defb 0,61,249,179,33,255,255,192,0,15,255,255,159,192,7,224
       defb 0,0,28,3,249,251,255,224,0,0,0,31,255,207,254,0
       defb 0,0,0,0,0,48,0,0,0,7,124,28,243,253,0,0
       defb 30,248,111,97,231,238,240,0,15,115,241,221,231,217,159,192
       defb 0,15,62,128,15,252,255,192,0,7,255,255,159,240,7,224
       defb 0,0,15,129,249,255,255,224,0,0,0,31,255,199,252,0
       defb 0,0,0,12,0,252,0,0,0,3,126,30,247,123,184,0
       defb 31,252,111,109,227,238,243,0,15,249,248,221,199,147,63,192
       defb 0,3,206,0,255,252,255,192,0,7,255,255,207,248,3,224
       defb 0,0,7,220,252,255,255,224,0,0,0,15,255,231,240,0
       defb 0,0,0,31,128,127,0,0,0,3,190,14,247,251,190,0
       defb 15,254,103,36,227,236,240,128,2,124,252,223,199,144,127,192
       defb 0,8,224,13,255,252,115,192,0,3,255,191,207,252,3,224
       defb 0,0,3,223,254,127,255,224,0,0,0,15,255,227,192,0
       defb 0,0,0,38,193,178,0,0,0,1,190,46,119,251,60,0
       defb 7,255,55,174,3,204,240,192,15,190,62,27,151,145,255,192
       defb 0,48,0,124,127,252,7,192,0,1,255,191,231,252,113,224
       defb 0,0,1,255,254,63,255,224,0,0,0,7,255,243,0,0
       defb 0,3,224,61,227,158,0,0,7,193,190,111,119,247,124,0
       defb 1,255,147,142,247,217,225,192,7,223,143,27,183,135,255,192
       defb 0,96,1,254,127,248,7,192,0,0,255,157,231,252,255,224
       defb 0,0,0,255,255,63,255,224,0,0,0,0,255,128,0,0
       defb 0,3,248,61,227,190,0,0,15,65,158,231,119,247,124,0
       defb 0,31,219,143,247,217,227,192,3,231,231,187,179,143,255,192
       defb 0,112,255,255,63,224,15,192,0,0,127,129,243,248,255,224
       defb 0,0,0,127,255,31,255,192,0,0,0,0,0,0,0,0
       defb 0,5,240,29,227,188,0,0,30,225,222,103,119,246,124,0
       defb 0,15,235,221,231,217,231,192,0,243,243,187,176,63,255,192
       defb 0,31,255,255,63,128,15,224,0,0,62,3,243,249,255,224
       defb 0,0,0,63,255,143,255,128,0,0,0,0,0,0,0,0





TABSIZ equ 84              ; 14 items, 6 bytes each.

sprite call gsprad         ; get sprite address.

       ld l,(ix+2)         ; x coordinate.
       ld h,(ix+3)         ; y coordinate.
       ld (dispx),hl       ; coordinates for display.
       call scadd          ; work out screen address.
       call spmask         ; get sprite mask.

       exx                 ; store addresses.

       call gspran         ; get next sprite address.
       ld l,(ix+TABSIZ+2)  ; x coordinate.
       ld h,(ix+TABSIZ+3)  ; y coordinate.
       ld (dispx),hl       ; coordinates for deletion.
       call scadd          ; work out screen address.
       call spmask         ; get sprite mask.

       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       exx                 ; restore old addresses for deletion.
       call dline          ; delete a line.
       exx                 ; restore new addresses.
       call dline          ; draw a line.
       ret


; Display single sprite at (ix).

sspria call gsprad         ; get sprite address.
       ld l,(ix+2)         ; x coordinate.
       ld h,(ix+3)         ; y coordinate.
       ld (dispx),hl       ; coordinates for display.
       call scadd          ; work out screen address.
       call spmask         ; get sprite mask.
       ld a,16             ; rows to display/delete.
sspri0 ex af,af'           ; store count in alternate accumulator.
       call dline          ; draw a line.
       ex af,af'           ; restore line count.
       dec a               ; one iteration down.
       jp nz,sspri0        ; still more to go.
       ret

; Display single sprite at (ix+TABSIZ).

ssprib call gspran         ; get next sprite address.
       ld l,(ix+TABSIZ+2)  ; x coordinate.
       ld h,(ix+TABSIZ+3)  ; y coordinate.
       ld (dispx),hl       ; coordinates for display.
       call scadd          ; work out screen address.
       call spmask         ; get sprite mask.
       ld a,16             ; rows to display/delete.
       jp sspri0

; Sprite graphic address calculation.

gspran ld d,(ix+TABSIZ)    ; fetch type.
       ld a,(ix+TABSIZ+1)  ; sprite direction.
       dec a               ; zero or 1 wanted.
       and 1               ; remove unwanted bits.
       rrca                ; shift into highest bit.
       ld e,a              ; copy to displacement low byte.
       ld a,(ix+TABSIZ+3)  ; sprite y.
       jp gspra0
gsprad ld d,(ix)           ; fetch type.
       ld a,(ix+1)         ; sprite direction.
       dec a               ; zero or 1 wanted.
       and 1               ; remove unwanted bits.
       rrca                ; shift into highest bit.
       ld e,a              ; copy to displacement low byte.
       ld a,(ix+3)         ; sprite y.
gspra0 and 6               ; coordinate straddling cells * 2.
       rrca                ; multiply by another 16.
       rrca
       rrca
       rrca
       ld c,a              ; low byte.
       xor a               ; zero in accumulator, clear carry flag.
       ld b,a              ; zeroise high byte of bc.
       ld hl,sprgfx        ; sprite images.
       add hl,bc           ; add displacement for position.
       add hl,de           ; find address.
       ex de,hl            ; put result in de.
       ret



dline  ld a,(de)           ; source byte.
       and b               ; apply left mask.
       xor (hl)            ; combine with screen.
       ld (hl),a           ; write result.
       inc l               ; next target address.
       inc de              ; next source byte.

       ld a,(de)           ; source byte.
       xor (hl)            ; combine with screen.
       ld (hl),a           ; write result.
       inc l               ; next target address.
       dec de              ; back to first source byte of line.
       ld a,(de)           ; source byte.
       and c               ; apply right mask.
       xor (hl)            ; combine with screen.
       ld (hl),a           ; write result.
       inc de              ; next source byte.
       inc de              ; next source byte.
       dec l               ; restore hl to start of line.
       dec l

; Line drawn, now work out next target address.

       inc h               ; increment pixel.
       ld a,h              ; get pixel address.
       and 7               ; straddling character position?
       ret nz              ; no, we're on next line already.
       ld a,h              ; get pixel address.
       sub 8               ; subtract 8 for start of segment.
       ld h,a              ; new high byte of address.
       ld a,l              ; get low byte of address.
       add a,32            ; one line down.
       ld l,a              ; new low byte.
       ret nc              ; not reached next segment yet.
       ld a,h              ; address high.
       add a,8             ; add 8 to next segment.
       ld h,a              ; new high byte.
       ret

spmask ld a,c              ; pixel column.
       and 7               ; need position between cells.
       ld c,a              ; back in c.
       ld b,252            ; high byte of maskad.
       ld a,(bc)           ; fetch mask byte.
       ld c,a              ; store mask in c.
       cpl                 ; reverse all bits.
       ld b,a              ; left mask in b register.
       ret


; Display sprites.

dspr   ld ix,ftable        ; table of food.
       ld b,NUMITM         ; items.
dspr0  push bc             ; store counter.
       ld a,(ix)           ; type (255 = off).
       cp 255              ; is this enabled?
       jr nz,dspr1         ; yes, display/delete it.
       ld a,(ix+TABSIZ)    ; type.
       cp 255              ; is this enabled?
       jr nz,dspr3         ; yes, display it.
dspr2  ld de,ELSIZE        ; distance to next object.
       add ix,de           ; next one.
       pop bc              ; restore counter.
       djnz dspr0
       ret
dspr1  ld a,(ix+TABSIZ)    ; type of second sprite.
       cp 255              ; is this enabled?
       jr nz,dspr4         ; yes, display both.
       call sspria         ; show single sprite.
       jp dspr2
dspr4  call sprite         ; show sprite.
       jp dspr2
dspr3  call ssprib         ; show single sprite.
       jp dspr2

; Process sprites.

pspr   ld ix,NEWTAB        ; table of food.
       ld b,NUMITM         ; items.
pspr0  push bc             ; store counter.
       ld a,(ix)           ; type.
       cp 255              ; is this enabled?
       jr nz,pspr1         ; yes, process it.
pspr2  ld de,ELSIZE        ; distance to next object.
       add ix,de           ; next one.
       pop bc              ; restore counter.
       djnz pspr0
       ret
pspr1  cp EXPLOD           ; is it an explosion?
       jr nc,psprex        ; yes, process that.
       xor a               ; zeroise accumulator.
       ld (kflag),a        ; reset kill food flag.
       call psprh          ; horizontal movement.
       call psprv          ; vertical stuff.
       call psprb          ; below check.
       ld a,(kflag)        ; kill flag.
       and a               ; has it been set?
       jp z,pspr2          ; no, carry on.
       ld (ix),EXPLOD      ; start explosion.
       ld (ix+1),1         ; set to first frame of pair.
       jp pspr2

psprh  ld a,(ix+1)         ; direction.
       cp 8                ; temporary freeze?
       jr nc,psprs         ; stay still for a bit.
       dec a               ; moving left?
       jp z,psprl          ; move left.
       dec a               ; moving right?
       jp z,psprr          ; move right.
       ret

; Process sprite - still.

psprs  sub 8               ; decrement delay bits.
       ld (ix+1),a         ; set him going eventually.
       ret

psprex ld a,(ix+1)         ; direction - accounts for alternate frames.
       inc a               ; 1 or 2.
       ld (ix+1),a         ; new frame.
       cp 3                ; only 1 or 2 are used.
       jp c,pspr2          ; no need to increase type yet.
       ld (ix+1),1         ; first half of next frame.
       ld a,(ix)           ; item type.
       inc a               ; increment sprite type.
       cp EXPLOD+3         ; end of explosion frames?
       jp c,psprx0         ; no, not yet.
       ld a,255            ; last type.
psprx0 ld (ix),a           ; reset the type.
       jp pspr2

kilspr ld (ix),EXPLOD      ; start an explosion.
       ld (ix),1           ; start at first of two frames for type.
       ret


; Process sprite - left.

psprl  ld l,(ix+2)         ; x coordinate.
       ld h,(ix+3)         ; y coordinate.
       dec h               ; look 1 pixel left.
       ld a,h              ; get value.
       inc a               ; moving off left edge?
       jp z,psprlg         ; going off edge - remove this sprite.
       ld (dispx),hl       ; set up test coordinates.
       call fblk           ; find block here.
       jr nz,psprcd        ; not space, change direction.
       ld de,32            ; distance to next cell.
       add hl,de           ; point one row down.
       call tblk           ; test that block.
       jr nz,psprcd        ; not space, change direction.
       ld a,(dispx)        ; x coordinate tested.
       and 7               ; straddling cells?
       jr z,psprl0         ; no, we're okay to move.
       add hl,de           ; point one row down.
       call tblk           ; test that block.
       jr nz,psprcd        ; not space, change direction.
psprl0 dec (ix+3)          ; left 2 pixels.
       dec (ix+3)
       ret

; Change direction.

psprcd ld a,3              ; sum of both directions.
       sub (ix+1)          ; toggle direction.
       ld (ix+1),a         ; set the new direction.
       ret

; Process sprite - right.

psprr  ld l,(ix+2)         ; x coordinate.
       ld a,(ix+3)         ; y coordinate.
       add a,16            ; look 16 pixels right.
       jr c,psprcd         ; that would go off-screen.
       ld h,a              ; ensure hl holds coordinates.
       ld (dispx),hl       ; set up test coordinates.
       call fblk           ; find block here.
       jr nz,psprcd        ; not space, change direction.
       ld de,32            ; distance to next cell.
       add hl,de           ; point one row down.
       call tblk           ; test that block.
       jr nz,psprcd        ; not space, change direction.
       ld a,(dispx)        ; x coordinate tested.
       and 7               ; straddling cells?
       jr z,psprr0         ; no, we're okay to move.
       add hl,de           ; point one row down.
       call tblk           ; test that block.
       jr nz,psprcd        ; not space, change direction.
psprr0 inc (ix+3)          ; right 2 pixels.
       inc (ix+3)
       ret

; Process sprite vertical.

psprv  ld l,(ix+4)         ; jump pointer low.
       ld h,(ix+5)         ; jump pointer high.
psprv1 ld a,(hl)           ; fetch distance.
       cp 128              ; is this the end marker?
       jp nz,psprv0        ; no, this value is good.
       dec hl              ; back one byte.
       jp psprv1           ; now try again.
psprv0 inc hl              ; point to next position.
       ld (ix+5),h         ; set pointer high.
       ld (ix+4),l         ; set pointer low.
       cp 128              ; is this the end marker?
       jp c,psprd          ; moving sprite down.

; Move sprite up.

pspru  neg                 ; make number of pixels positive.
pspru0 ex af,af'           ; store loop counter.
       call getabv         ; get coordinates above sprite.
       call blkad          ; fetch block address.
       call ublk           ; test block up.
       jr nz,psprmd        ; hit a wall, move down next.
       inc hl              ; look one cell right.
       call ublk           ; test block up.
       jr nz,psprmd        ; hit a wall, move down next.
       ld a,(ix+3)         ; find y position.
       and 7               ; is it straddling cells?
       jr z,pspru1         ; no, we're okay to move then.
       inc hl              ; look at final cell.
       call ublk           ; test block up.
       jr nz,psprmd        ; hit a wall, move down next.
pspru1 dec (ix+2)          ; move up one pixel.
       ex af,af'           ; restore pixel loop count.
       dec a               ; one less iteration.
       jp nz,pspru0
       ret

psprd  and a               ; are we stationary?
       ret z               ; yes, don't move.
psprd0 ex af,af'           ; store loop counter.
       ld a,(ix+2)         ; find x position.
       and 7               ; is it straddling cells?
       jr nz,psprd1        ; yes, no platform check required.
       call getblw         ; get coordinates below sprite.
       call blkad          ; fetch block address.
       call dblk           ; test block down.
       jr nz,psprmd        ; hit a wall, move down next.
       inc hl              ; look one cell right.
       call dblk           ; test block down.
       jr nz,psprmd        ; hit a wall, move down next.
       ld a,(ix+3)         ; find y position.
       and 7               ; is it straddling cells?
       jr z,psprd1         ; no, we're okay to move then.
       inc hl              ; look at final cell.
       call dblk           ; test block down.
       jr nz,psprmd        ; hit a wall, move down next.
psprd1 inc (ix+2)          ; move down one pixel.
       ex af,af'           ; restore pixel loop count.
       dec a               ; one less iteration.
       jp nz,psprd0
       ret

; Process sprite - move down.

psprmd ld hl,jtabd         ; jump table at start of drop.
       ld a,(ix+1)         ; direction.
       and a               ; has it been set yet?
       call z,psprml       ; no, set it moving left.
psprmv ld (ix+4),l         ; set low byte of pointer.
       ld (ix+5),h         ; same for high.
       ret

; Process sprite - check cells below.

psprb  ld a,(ix+2)         ; x position.
       and 7               ; straddling cells?
       ret nz              ; yes, do nothing.
       ld a,(ix+3)         ; y position.
       ld b,a              ; store in b register for now.
       and 15              ; find position straddling cells/double cells.
       cp 8                ; is it halfway between cell pairs?
       jp z,psprj          ; yes, do jump check.
       and a               ; is it aligned with cell pair?
       ret nz              ; no, nothing to do.
       call getblw         ; set up cell position below.
       call blkad          ; fetch block address.
       ld a,(hl)           ; get cell type.
       cp LEFT             ; is it a move left cell?
       jr z,psprml         ; yes, force left.
       cp RIGHT            ; is it a move right cell?
       ret nz              ; no, nothing to do.
psprmr ld (ix+1),2         ; force sprite right.
       ret
psprml ld (ix+1),1         ; force sprite left.
       ret
psprj  call getblw         ; find position below player.
       call blkad          ; fetch block address.
       ld a,(ix+1)         ; sprite direction.
       dec a               ; is it moving left?
       jr z,psprj0         ; yes, just check position below player.
       inc hl              ; look one cell right.
psprj0 ld a,(hl)           ; get cell's contents.
       cp JUMP             ; is it a jump cell?
       ret nz              ; no.
       ld hl,fx1           ; jump sound effect.
       call isnd           ; start the sound.
       ld hl,jtab          ; jump table start.
       jp psprmv           ; move vertically.

; Sprite going through window.

psprlg call which          ; determine window with x coordinate.
       call cslot          ; see if slot is empty.
       jp z,psprmr         ; nothing ordered, about turn instead.
       ld a,(slot)         ; get window again.
       call gslot          ; find first byte.
       ld b,0              ; first item in window.
       cp (ix)             ; do we have a match?
       jr z,kslot          ; yes, kill the item.
       inc b               ; second item.
       inc hl              ; point to next item ordered.
       ld a,(hl)           ; fetch item.
       cp (ix)             ; do we have a match?
       jr z,kslot          ; yes, kill the item.
       inc b               ; third item.
       inc hl              ; point to last item ordered.
       ld a,(hl)           ; fetch item.
       cp (ix)             ; do we have a match?
       jr z,kslot          ; yes, kill the item.

;       ld a,(levno)        ; current level.
;       and a               ; first level?
;       jr z,kfood          ; yes, just kill the food.

; I didn't order this.  Complain to the management.

       call compln         ; make a complaint.
       jp kfood            ; oops, not ordered.

kslot  ld (hl),255         ; remove from the order.

       ld a,(slot)         ; window we're dealing with.
       ld c,66             ; black/red.
       call aslot          ; set attributes for the slot.
       call dslot          ; delete slot item.

       ld b,5              ; number to add.
       ld hl,score+5       ; units column.
       call uscor          ; up the score.
       ld a,(stars)        ; stars awarded.
       ld b,a              ; number to add.
       ld hl,score+5       ; units column.
       call uscor          ; up the score.

       call dscor          ; display score.

kfood  ld (ix),255         ; kill off the sprite.
       ret

which  ld b,0              ; default window = top.
       ld a,(ix+2)         ; vertical (x) position.
       cp 64               ; top one?
       jr c,which0         ; set the window.
       inc b               ; try next one.
       cp 112              ; middle one?
       jr c,which0         ; set the window.
       inc b               ; must be the last one.
which0 ld a,b              ; put window in accumulator.
       ld (slot),a         ; write to variable.
       ret

getabv ld l,(ix+2)         ; x coordinate.
       ld h,(ix+3)         ; y coordinate.
       dec l               ; look up 1 pixel.
       ld (dispx),hl       ; set test coordinates.
       ret

getblw ld a,(ix+2)         ; x coordinate.
       ld h,(ix+3)         ; y coordinate.
       add a,16            ; look down 16 pixels.
       ld l,a              ; set up low byte.
       ld (dispx),hl       ; set test coordinates.
       ret

; Remove entire order from window and increment complaints tally.

compln ld hl,fx3           ; complaint sound effect.
       call isnd           ; start the sound.
       ld a,(slot)         ; current slot.
       ld b,0              ; first item in slot.
       call cslot          ; get address.
       ld (hl),255         ; write item.
       inc hl              ; next item.
       ld (hl),255         ; write item.
       inc hl              ; next item.
       ld (hl),255         ; write item.

       ld b,3              ; items to blank.
compl0 push bc             ; store loop counter.
       ld a,(slot)         ; slot number.
       dec b               ; need b in range 0-2, not 1-3.
       ld c,66             ; black/red.
       push bc
       call aslot          ; set attributes for the slot.
       pop bc
       call dslot          ; delete slot item.
       pop bc              ; retrieve loop counter from stack.
       djnz compl0         ; blank all items in slot.

       ld hl,sltim0        ; slot timers.
       ld a,(slot)         ; current slot.
       call addac          ; point to timer.
       ld a,(levspd)       ; level speed.
       ld (hl),a           ; set time before new order appears here.

       ld hl,comps         ; number of complaints.
       ld a,(hl)           ; how many have there been already?
       cp MAXCOM           ; reached maximum?
       ret nc              ; yes, don't need any more.
       cp MAXCOM - 1       ; about to reach the limit?
       call z,settmr       ; yes, set up timer.
       ld hl,comps         ; number of complaints.
       ld a,(hl)           ; how many have there been already?
       inc (hl)            ; one more.
       rlca                ; double complaints, so 0, 2 or 4.
       ld hl,compxy        ; x and y coordinates.
       call addac          ; point to coordinates.
       ld de,dispx         ; coordinates.
       ldi                 ; copy coordinates to variables.
       ldi
       call scadd          ; work out screen address.
       ld de,compgf        ; complaint sprite.
       ld bc,65280         ; set up mask.
       ld a,16             ; rows to display/delete.
       jp sspri0           ; draw sprite.

compxy defb 164,56
       defb 164,80
       defb 164,104


comps  defb 0              ; complaints received.
kflag  defb 0              ; kill food flag.



; Find/test block at (dispx, dispy).
; Pixel coordinates, not character positions.

fblk   call blkad          ; find block here.
tblk   ld a,(hl)           ; get attributes of cell.
       cp DEADLY           ; is it deadly?
       jr z,tblkd          ; yes, set flag and allow to continue.
       and WALLS           ; walls?
       ret
tblkd  ld (kflag),a        ; set the kill flag.
tblk0  xor a               ; return blank space.
       ret

ublk   ld a,(hl)           ; get cell characteristics.
       and WALLS           ; walls?
       ret                 ; return with zero flag set accordingly.
dblk   ld a,(hl)           ; get cell characteristics.
       and DOWN            ; walls or platforms?
       ret                 ; return with zero flag set accordingly.

; Find character block at (dispx, dispy) for collision detection.

blkad  ld a,(dispx)        ; displacement from top of screen.
       rlca                ; for each 8 pixels down we move 32
       rlca                ; bytes down screen data.
       ld c,a              ; store in c for later.
       and 224             ; rows are multiples of 32.
       ld l,a              ; part of low byte.
       ld a,(dispy)        ; displacement from left edge.
       rra                 ; 3 right shifts
       rra                 ; effectively divide
       rra                 ; coordinate by 8.
       and 31              ; discard anything shifted into high bits.
       add a,l             ; splice with low byte.
       ld l,a
       ld a,c
       and 3
       add a,253           ; 253 x 256 = start of properties data.
       ld h,a
       ld a,(hl)           ; return with attribute in accumulator.
       ret

; Do controls stuff.

docon  ld hl,(cursx)       ; cursor coords.
       ld (dispx),hl       ; set up test position.
       call joykey         ; do controls stuff.
       ld a,(joyval)       ; joystick reading.
       and 16              ; was fire pressed?
       jp nz,ctyp          ; yes, change type.
       call dohor          ; do horizontal.
dover  ld a,(joyval)       ; get last joystick reading.
       and 12              ; get left/right status.
       sub 4               ; going down?
       jp z,mcd            ; move cursor down.
       sub 4               ; going up?
       jp z,mcu            ; move cursor up.
       ret
dohor  ld a,(joyval)       ; get last joystick reading.
       and 3               ; get left/right status.
       dec a               ; going right?
       jp z,mcr            ; move cursor right.
       dec a               ; going left?
       jp z,mcl            ; move cursor left.
       ret


ctyp   ld a,(joyval)       ; joystick reading.
       and 15              ; any direction required?
       ret z               ; no, do nothing.
       call getcel         ; get address of cells at cursor.
       ld a,(hl)           ; get contents of address.
       and a               ; is it a space?
       ret z               ; yes, nothing doing there.
       call bufadd         ; get map pointer.
       ld a,(hl)           ; fetch type there.
       and WALLS           ; is it a wall?
       ret nz              ; yes, don't change it.
       ld a,(joyval)       ; joystick reading.
       and 3               ; read horizontal position.
       dec a               ; going right?
       jp z,ctypr          ; change to right.
       dec a               ; going left?
       jp z,ctypl          ; change platform to left.
       ld a,(joyval)       ; joystick reading.
       and 12              ; read vertical position.
       sub 4               ; going down?
       jp z,ctypn          ; point it nowhere.
       sub 4               ; going up?
       jp z,ctypu          ; point it up.
       ret
ctypl  call getcel         ; get cell address.
       ld a,(hl)           ; what sort is it?
       cp CELLL            ; cell left?
       ret z               ; yes, no need to change it.
       call dplat          ; delete platform.
       call bufadd         ; get map pointer.
       ld (hl),LEFT        ; force sprites left here.
       inc hl              ; next cell.
       ld (hl),LEFT        ; force sprites left here.
       call getcel         ; get address of cells.
       ld (hl),CELLL       ; make it point left.
       inc hl              ; next cell.
       ld (hl),CELLL       ; make it point left.
       dec hl
       jp dplat            ; display new platform.
ctypr  call getcel         ; get cell address.
       ld a,(hl)           ; what sort is it?
       cp CELLR            ; cell right?
       ret z               ; yes, no need to change it.
       call dplat          ; delete platform.
       call bufadd         ; get map pointer.
       ld (hl),RIGHT       ; force sprites right here.
       inc hl              ; next cell.
       ld (hl),RIGHT       ; force sprites right here.
       call getcel         ; get address of cells.
       ld (hl),CELLR       ; make it point left.
       inc hl              ; next cell.
       ld (hl),CELLR       ; make it point left.
       dec hl
       halt
       jp dplat            ; display new platform.
ctypu  call getcel         ; get cell address.
       ld a,(hl)           ; what sort is it?
       cp CELLU            ; cell right?
       ret z               ; yes, no need to change it.
       call dplat          ; delete platform.
       call bufadd         ; get map pointer.
       ld (hl),JUMP        ; force sprites up here.
       inc hl              ; next cell.
       ld (hl),JUMP        ; force sprites up here.
       call getcel         ; get address of cells.
       ld (hl),CELLU       ; make it point up.
       inc hl              ; next cell.
       ld (hl),CELLU       ; make it point up.
       dec hl
       jp dplat            ; display new platform.
ctypn  call getcel         ; get cell address.
       ld a,(hl)           ; what sort is it?
       cp CELLP1           ; cell right?
       ret z               ; yes, no need to change it.
       call dplat          ; delete platform.
       call bufadd         ; get map pointer.
       ld (hl),PLAT        ; don't redirect sprites here.
       inc hl              ; next cell.
       ld (hl),PLAT        ; don't redirect sprites here.
       call getcel         ; get address of cells.
       ld (hl),CELLP1      ; make it point nowhere.
       inc hl              ; next cell.
       ld (hl),CELLP2      ; make it standard platform.
       dec hl
       jp dplat            ; display new platform.


; Get controls and act upon them.

getcon ld hl,(cursx)       ; cursor coords.
       ld (dispx),hl       ; set up test position.
       call joykey         ; do controls stuff.
       ld hl,0             ; default - no movement in any direction.
       and 3               ; get left/right stuff.
       jr z,getco0         ; nothing pressed.
       cp 3                ; both left and right simultaneously?
       jr z,getco0         ; yes, so no movement.
       ld h,a              ; keep horizontal in h.
       jr getco1           ; ignore the vertical.
getco0 ld a,(joyval)       ; get control reading again.
       and 12              ; get up/down stuff.
       jr z,getco1         ; nothing pressed.
       cp 12               ; both up and down simultaneously?
       jr z,getco1         ; yes, so no movement.
       ld l,a              ; keep vertical in l.
getco1 ld (joydir),hl      ; store directional controls.
       ld a,(joyval)       ; joystick reading.
       and 16              ; was fire pressed?
       ret nz              ; yes, change type.
       ld a,(joydir+1)     ; fetch horizontal.
       dec a               ; going right?
       jp z,mcr            ; move cursor right.
       dec a               ; going left?
       jp z,mcl            ; move cursor left.
getco2 ld a,(joydir)       ; fetch vertical.
       sub 4               ; going down?
       jp z,mcd            ; move cursor down.
       sub 4               ; going up?
       jp z,mcu            ; move cursor up.
       ret

; Move cursor up/down/left/right.

mcl    ld a,(dispy)        ; cursor position.
       cp 8                ; can we go left?
       ret c               ; no, don't move.
       ld hl,dispy         ; cursor y coordinate.
       dec (hl)            ; left two places.
       dec (hl)
       call bufadd         ; get map pointer.
       ld a,(hl)           ; fetch cell type.
       and WALLS           ; is it a wall?
;       ret nz              ; yes, don't move there.
       ld hl,lrcnt         ; left/right count.
       inc (hl)            ; increment it.
       ld a,(hl)           ; get value.
       and CURSPD          ; speed.
       ret nz              ; not time to move yet.
       call rcur           ; restore cursor colour.
       ld hl,cursy         ; coordinates.
       dec (hl)            ; left two places.
       dec (hl)
       call dcur           ; redisplay at new position.
       ret
mcr    ld a,(dispy)        ; cursor position.
       cp 30               ; can we go right?
       ret nc              ; no, don't move.
       ld hl,dispy         ; cursor y coordinate.
       inc (hl)            ; right two places.
       inc (hl)
       call bufadd         ; get map pointer.
       ld a,(hl)           ; fetch cell type.
       and WALLS           ; is it a wall?
;       ret nz              ; yes, don't move there.
       ld hl,lrcnt         ; left/right count.
       ld a,(hl)           ; get value.
       inc (hl)            ; post-increment it.
       and CURSPD          ; speed.
       ret nz              ; not time to move yet.
       call rcur           ; restore cursor colour.
       ld hl,cursy         ; coordinates.
       inc (hl)            ; right two places.
       inc (hl)
       call dcur           ; redisplay at new position.
       ret
mcu    ld a,(dispx)        ; cursor position.
       cp 6                ; can we go up?
       ret c               ; no, don't move.
       ld hl,dispx         ; cursor x coordinate.
       dec (hl)            ; up three places.
       dec (hl)
       dec (hl)
       call bufadd         ; get map pointer.
       ld a,(hl)           ; fetch cell type.
       and WALLS           ; is it a wall?
;       ret nz              ; yes, don't move there.
       ld hl,udcnt         ; up/down count.
       inc (hl)            ; increment it.
       ld a,(hl)           ; get value.
       and CURSPD          ; speed.
       ret nz              ; not time to move yet.
       call rcur           ; restore cursor colour.
       ld hl,cursx         ; coordinates.
       dec (hl)            ; up three places.
       dec (hl)
       dec (hl)
       call dcur           ; redisplay at new position.
       ret
mcd    ld a,(dispx)        ; cursor position.
       cp 17               ; can we go down?
       ret nc              ; no, don't move.
       ld hl,dispx         ; cursor x coordinate.
       inc (hl)            ; down three places.
       inc (hl)
       inc (hl)
       call bufadd         ; get map pointer.
       ld a,(hl)           ; fetch cell type.
       and WALLS           ; is it a wall?
;       ret nz              ; yes, don't move there.
       ld hl,udcnt         ; up/down count.
       ld a,(hl)           ; get value.
       inc (hl)            ; post-increment it.
       and CURSPD          ; speed.
       ret nz              ; not time to move yet.
       call rcur           ; restore cursor colour.
       ld hl,cursx         ; coordinates.
       inc (hl)            ; down three places.
       inc (hl)
       inc (hl)
       call dcur           ; redisplay at new position.
       ret
lrcnt  defb 0
udcnt  defb 0



; Joystick and keyboard reading routines.

joykey ld a,(contrl)       ; control flag.
       and a               ; is it the keyboard?
       jr nz,joyjoy        ; no, it's joystick.

; Keyboard controls.

       ld e,0              ; control.
       ld a,(keys+4)       ; fire key.
       call ktest          ; being pressed?
       ccf                 ; complement the carry.
       rl e                ; rotate into e register.
       ld a,(keys)         ; up key.
       call ktest          ; being pressed?
       ccf                 ; complement the carry.
       rl e                ; rotate into e register.
       ld a,(keys+1)       ; down key.
       call ktest          ; being pressed?
       ccf                 ; complement the carry.
       rl e                ; rotate into e register.
       ld a,(keys+2)       ; left key.
       call ktest          ; being pressed?
       ccf                 ; complement the carry.
       rl e                ; rotate into bit d0 of e register.
       ld a,(keys+3)       ; left key.
       call ktest          ; being pressed?
       ccf                 ; complement the carry.
       rl e                ; destined for bit d1 of e register.
       ld a,e              ; place result in accumulator.
       ld (joyval),a       ; put that into joyval.
       ret

joyjoy dec a               ; is it Kempston?
       jr z,joykem         ; yes.

; Sinclair joystick controls.

joysin ld bc,61438         ; port for Sinclair 2.
       in a,(c)            ; read joystick.
       ld d,a              ; clear values.
       xor a               ; clear accumulator.
       ld e,16             ; Kempston fire bit value.
       bit 0,d             ; fire bit pressed?
       call z,joysi0       ; add bit.
       ld e,1              ; Kempston bit value.
       bit 3,d             ; fire bit pressed?
       call z,joysi0       ; add bit.
       ld e,2              ; Kempston bit value.
       bit 4,d             ; fire bit pressed?
       call z,joysi0       ; add bit.
       ld e,8              ; Kempston bit value.
       bit 1,d             ; fire bit pressed?
       call z,joysi0       ; add bit.
       ld e,4              ; Kempston bit value.
       bit 2,d             ; fire bit pressed?
       call z,joysi0       ; add bit.
       ld (joyval),a       ; remember value.
       ret

joysi0 add a,e             ; add bit value.
       ret


; Kempston joystick controls.

joykem ld bc,31            ; port for Kempston interface.
       in a,(c)            ; read it.
       ld (joyval),a       ; remember value.
       ret

; Key test routine.

ktest  ld c,a              ; key to test in c.
       and 7               ; mask bits d0-d2 for row.
       inc a               ; in range 1-8.
       ld b,a              ; place in b.
       srl c               ; divide c by 8
       srl c               ; to find position within row.
       srl c
       ld a,5              ; only 5 keys per row.
       sub c               ; subtract position.
       ld c,a              ; put in c.
       ld a,254            ; high byte of port to read.
ktest0 rrca                ; rotate into position.
       djnz ktest0         ; repeat until we've found relevant row.
       in a,(254)          ; read port (a=high, 254=low).
ktest1 rra                 ; rotate bit out of result.
       dec c               ; loop counter.
       jp nz,ktest1        ; repeat until bit for position in carry.
       ret

; User defined keys.

keys   defb 28,29,27,35,16,1

joyval defb 0              ; keyboard/joystick value.
contrl defb 0              ; control method chosen.
joydir defw 0              ; joystick horizontal and vertical flags.

redkey call 654            ; D=shift, E=key.
       ld a,e              ; get value.
       inc a               ; is it 255?
       jr nz,redkey        ; yes - loop until key is released.
       call 3503           ; ROM routine to clear screen.
       ld hl,keys          ; redefined keys.
       ld de,keys+1
       ld bc,5
       ld (hl),255
       ldir                ; clear keys.
       ld hl,ktxt0         ; prompt to display.
       call dfont          ; display prompt for next key.
       call redky0         ; wait for keypress.
       ld a,e
       ld (keys),a         ; set this as up key.
       call noise
       ld hl,ktxt1         ; prompt to display.
       call dfont          ; display prompt for next key.
       call redky0         ; wait for keypress.
       ld a,e
       ld (keys+1),a       ; set this as down key.
       call noise
       ld hl,ktxt2         ; prompt to display.
       call dfont          ; display prompt for next key.
       call redky0         ; wait for keypress.
       ld a,e
       ld (keys+2),a       ; set this as left key.
       call noise
       ld hl,ktxt3         ; prompt to display.
       call dfont          ; display prompt for next key.
       call redky0         ; wait for keypress.
       ld a,e
       ld (keys+3),a       ; set this as right key.
       call noise
       ld hl,ktxt4         ; prompt to display.
       call dfont          ; display prompt for next key.
       call redky0         ; wait for keypress.
       ld a,e
       ld (keys+4),a       ; set this as spin key.
       call noise
       ld hl,ktxt5         ; prompt to display.
       call dfont          ; display prompt for next key.
       call redky0         ; wait for keypress.
       ld a,e
       ld (keys+5),a       ; set this as stake key.
       call noise
       jp menua            ; back to main menu now.

ktxt0  defb AT,2,9,ATTR,66
       DEFB 16,18,5,19,19,0,11,5,25,0,6,15,18,37
       defb AT,5,7,ATTR,67
       defb 21,16,AT,5,24
       defb ENDCHR
ktxt1  defb AT,7,7
       defb 4,15,23,14,AT,7,24
       defb ENDCHR
ktxt2  defb AT,9,7
       defb 12,5,6,20,AT,9,24
       defb ENDCHR
ktxt3  defb AT,11,7
       defb 18,9,7,8,20,AT,11,24
       defb ENDCHR
ktxt4  defb AT,13,7
       defb 3,8,1,14,7,5,0,16,12,1,20,6,15,18,13,AT,13,24
       defb ENDCHR
ktxt5  defb AT,18,7,ATTR,68
       defb 16,1,21,19,5,AT,18,24
       defb ENDCHR
ktxt7  defb 2,8,25,33,32,20,7,22
       defb 14,10,21,34,31,18,6,3
       defb 13,11,9,35,30,5,4,24
       defb 48,12,15,36,29,23,19,26
       defb 47,47,16,27,28,17,1,47

redky0 call 654            ; D=shift, E=key.
       ld a,e              ; get value.
       inc a               ; is it 255?
       jr z,redky0         ; yes - loop until something pressed.
       ld a,(keys)         ; first key.
       cp e                ; is this the same?
       jr z,redky0         ; yes - try again.
       ld a,(keys+1)       ; down key.
       cp e                ; is this the same?
       jr z,redky0         ; yes - try again.
       ld a,(keys+2)       ; left key.
       cp e                ; is this the same?
       jr z,redky0         ; yes - try again.
       ld a,(keys+3)       ; right key.
       cp e                ; is this the same?
       jr z,redky0         ; yes - try again.
       ld a,(keys+4)       ; fire key.
       cp e                ; is this the same?
       jr z,redky0         ; yes - try again.
       ld a,(keys+5)       ; stake key.
       cp e                ; is this the same?
       jr z,redky0         ; yes - try again.
       push de
       ld hl,ktxt7         ; table of key names.
       ld d,0
       add hl,de           ; name of key in look-up table.
       ld a,(hl)           ; want result in DE.
       push af             ; store character.
       call scadd          ; find screen address.
       pop af              ; restore character.
       call dchar          ; routine to display character.
       pop de
       ret

; Noise - beeper white noise low, used in key redefinition.

noise  ld b,32             ; length of step.
noise0 call random         ; random value.
       and 248             ; don't change border colour.
       out (254),a         ; write to port.
       ld a,250
noise1 dec a
       jr nz,noise1
       djnz noise0
       ret


; Jump table.

jtab   defb 250,251,252,253,254,254,255,255,255,0,255
jtabd  defb 1,0,1,1,1,2,2,3,4,5,6,128


; Food table.

; ix + 0 = type (255 = off).
; ix + 1 = direction (1 = left, 2 = right).
; ix + 2 = x.
; ix + 3 = y.
; ix + 4 = jump pointer low.
; ix + 5 = jump pointer high.


ftable equ $
       defb 'Rather than leave tables blank, I prefer '
       defb 'to fill them with messages.  '
       defb "Are 14 sprites too much?  "
       defb "Oh, who cares.  Where's my bottle of grapefruit wine?  "

NEWTAB equ ftable + TABSIZ

       org ftable + TABSIZ + TABSIZ

dumtab defb 0              ; dummy item used in cycling items around buffer.

       org dumtab + ELSIZE


; ----------------------- Start of editor code ---------------------------

; Screen editor.

kmdrsc defb 8
       defw drsc08
       defb 9
       defw drsc09
       defb 10
       defw drsc10
       defb 11
       defw drsc11
       defb 13             ; Enter key.
       defw testg          ; quit to menu.
       defb 32             ; space.
       defw putblk         ; draw block.
       defb 48             ; zero key.
       defw putblk         ; draw block.
       defb 53
       defw drsc08
       defb 54
       defw drsc10
       defb 55
       defw drsc11
       defb 56
       defw drsc09
       defb 49             ; previous character.
       defw drsc97
       defb 50             ; next character.
       defw drsc99
       defb 'd'            ; draw mode key.
       defw drscd          ; toggle draw mode.
       defb 'n'            ; next screen.
       defw drscn
       defb 'p'            ; previous screen.
       defw drscp          ; go to previous.
       defb 255


; Match key presses with jump table.

mkey   ld a,(hl)           ; fetch key from table.
       inc a               ; is it end marker?
       ret z               ; yes, nothing pressed.
       ld a,(23560)        ; get key pressed.
       cp (hl)             ; does it match table entry?
       jr z,mkey1          ; yes, key matched.
       inc hl              ; find next key please.
       inc hl
       inc hl
       jr mkey             ; repeat.
mkey1  pop de              ; remove return address from stack.
       ld (mkeyb),a        ; set key pressed.
       inc hl              ; point to address low.
       ld e,(hl)           ; fetch low byte.
       inc hl              ; point to address high.
       ld d,(hl)           ; fetch high byte now.
       push de             ; store on stack.
       ret                 ; jump to routine.
mkeyb  defb 0              ; menu key byte.


; Draw screens.

drsc   call 3503           ; clear screen.
       xor a               ; clear accumulator.
       ld (fastdr),a       ; reset fast draw flag.
       ld h,a              ; zero in hl.
       ld l,a              ; zero in hl.
       ld (dispx),hl       ; reset cusor to origin.
drsc01 ld hl,(dispx)       ; cursor position.
       push hl             ; store that on the stack.
       ld hl,0             ; zeroes in h and l.
       ld (dispx),hl       ; set screen coordinates.
       call gradd          ; addresses for screens.
       call droom          ; display this screen.
       pop hl              ; restore cursor from stack.
       ld (dispx),hl       ; replace cursor position.
       jp drsc98

drsc02 call curon          ; cursor on.
       ld hl,23560         ; keyboard.
       ld (hl),0           ; clear key press.
drsc00 ld a,(23560)        ; get keypress.
       and a               ; anything pressed?
       jr z,drsc00         ; no, wait for key.
       call curoff         ; cursor off again.
       ld hl,kmdrsc        ; draw screen key matches.
       call mkey           ; match keys.
       jr drsc02
drsc08 ld a,(dispy)        ; horizontal position.
       and a               ; at left edge?
       jr z,drsc02         ; yes, go no further.
       dec a               ; cursor left.
       ld (dispy),a        ; new cursor position.
       jr drscdr           ; do draw processing.
drsc09 ld a,(dispy)        ; horizontal position.
       cp 31               ; reached screen edge?
       jr z,drsc02         ; yes, stop there.
       inc a               ; move right.
       ld (dispy),a        ; new position.
       jr drscdr           ; do draw processing.
drsc10 ld a,(dispx)        ; vertical.
       cp 19               ; at bottom of screen?
       jp z,drsc02         ; yes, stop.
       inc a               ; go down.
       ld (dispx),a        ; new position.
       jr drscdr           ; do draw processing.
drsc11 ld a,(dispx)        ; get the vertical.
       and a               ; at top of screen?
       jp z,drsc02         ; yes, so don't move.
       dec a               ; up 1 cell.
       ld (dispx),a        ; amend position.
drscdr ld a,(fastdr)       ; fast draw flag.
       and a               ; is it set?
       jp z,drsc02         ; no, don't draw.

; Write a character to room data.

putblk ld a,(dispy)        ; y coordinate.
       cp 6                ; left edge of screen?
       jp c,drsc02         ; yes, don't write there.
       call gradd          ; get room address.
       ld a,(dispx)        ; x coordinate.
       rrca                ; multiply by 32.
       rrca
       rrca
       ld d,a              ; store in d.
       and 224             ; low byte bits.
       ld e,a              ; put them in e.
       ld a,d              ; restore shift.
       and 31              ; want the high byte bits now.
       ld d,a              ; put high byte in d.
       ld a,(dispy)        ; y coordinate of cursor.
       add a,e             ; add to displacement.
       ld e,a              ; displacement now in de.
       add hl,de           ; point to position on first screen.
       ld a,(chno)         ; selected character number.
;       ld (hl),a           ; write to screen.
       call putoth         ; write other blocks if necessary.
       jp drsc01
drsc99 ld a,(chno)         ; current character.
       inc a               ; move it along.
       cp MAXCHR + 1       ; gone past last one?
       jr c,drs99a         ; no, it's okay.
       xor a               ; start at beginning.
drs99a ld (chno),a         ; set newly selected block.
drsc98 ld hl,(dispx)       ; get cursor position.
       push hl             ; store it on stack.
       defb 33,21,7        ; put coordinates in hl.
       ld (dispx),hl       ; write to cursor position.
       ld a,(chno)         ; get current character.
       rlca                ; multiply by 8.
       rlca
       rlca
       ld c,a              ; copy to bc.
       ld b,0              ; no high byte, less than 32 cells.
       ld hl,blkgfx        ; address of block graphics.
       add hl,bc           ; add displacement to find our block.
       call chadd          ; find address of screen at (dispx, dispy).
       ld b,8
drs98a ld a,(hl)           ; block graphic data.
       ld (de),a           ; transfer to screen.
       inc hl
       inc d
       djnz drs98a
       ld a,(chno)         ; get current character.
       ld e,a              ; copy to de.
       ld d,0              ; no high byte, obviously.
       ld hl,blcols        ; address of colours.
       add hl,de
       ld a,(hl)           ; fetch block colour.
       push af
       call atadd          ; find address of attribute cell.
       pop af
       ld (hl),a           ; write attribute to screen.
       ld hl,dispy         ; y coordinate.
       inc (hl)            ; move along so we don't overwrite block.
       ld hl,levtxt        ; hole text.
       call dfont          ; show text.
       pop hl              ; restore cursor position.
       ld (dispx),hl       ; set up the cursor.
       jp drsc02
drsc97 ld hl,chno          ; previous char.
       dec (hl)            ; back one.
       ld a,(hl)
       cp 255              ; gone negative?
       jr nz,drsc98        ; no, it's okay.
       ld (hl),MAXCHR      ; write max char number.
       jr drsc98
chno   defb 1              ; selected cell.

drscd  ld a,(fastdr)       ; fast draw mode.
       cpl                 ; reverse all bits.
       ld (fastdr),a       ; new setting.
       jp drscdr           ; draw this character if appropriate.
fastdr defb 0              ; fast draw mode on/off flag.

drscn  ld a,(levno)        ; next screen.
       inc a
       cp NUMLEV           ; reached the last screen?
       jp c,drsn0          ; no, not yet.
       xor a               ; move to first screen.
drsn0  ld (levno),a
       jp drsc01
drscp  ld hl,levno         ; previous screen.
       dec (hl)
       ld a,(hl)
       cp 255
       jp nz,drsc01
       ld (hl),NUMLEV - 1
       jp drsc01

testg  call game
       jp drsc

; Flashing cursor on/off.

curon  call atadd          ; attribute address.
       set 7,(hl)          ; set flash bit.
       ret

curoff call atadd
       res 7,(hl)          ; clear flash bit.
       ret

putoth ld b,a              ; store cell type in b register.
       and a               ; blank?
       jr z,putbl          ; write a blank.
       cp CELLW            ; standard wall?
       jr z,putwl          ; write a wall.
       cp CELLP2+1         ; is it standard platform?
       jr c,putsp          ; write standard platform.
       cp CELLR+1          ; is it a directional platform?
       jr c,putdp          ; put that into map.
       ld (hl),b           ; just draw block.
       ret

putdp  call validp         ; valid position for platform?
       ret nz              ; no, don't put one there.
       ld (hl),b           ; write platform.
       call getpar         ; get platform partner.
       ld (hl),b           ; draw the block.
       ret

putwl  ld (hl),CELLW       ; draw the wall.
       call getpar         ; get partner cell.
       cp CELLP1           ; is it blank/wall?
       ret c               ; yes, just write the wall.
       ld (hl),0           ; blank out what's left.
       ret

putsp  call validp         ; check position is valid for platform.
       ret nz              ; not valid, don't write.
       res 0,l             ; left edge of partnership.
       ld (hl),CELLP1      ; write standard platform.
       inc hl              ; next cell.
       ld (hl),CELLP2      ; write standard platform.
       ret

validp ld a,(dispx)        ; x coordinate of cursor.
       cp 4                ; valid position for platform.
       ret z
       cp 7                ; valid position for platform.
       ret z
       cp 10               ; valid position for platform.
       ret z
       cp 13               ; valid position for platform.
       ret z
       cp 16               ; valid position for platform.
       ret z
       cp 19               ; valid position for platform.
       ret

putbl  ld a,(dispx)        ; x position.
       cp 19               ; bottom of screen?
       ret nc              ; yes, don't write there.
       ld (hl),0           ; blank this cell.
       call getpar         ; get partner cell.
       cp CELLW            ; is it a wall?
       ret z               ; yes, leave it be.
       ld (hl),0           ; write partner cell too.
       ret

getpar ld a,l              ; low byte of cell.
       rra                 ; is it odd?
       jr c,getpo          ; yes, it's an odd address.
       inc hl              ; even, so partner is next cell.
       ld a,(hl)           ; get cell.
       ret
getpo  dec hl              ; odd, so partner cell is previous one.
       ld a,(hl)           ; get cell.
       ret

levtxt defb AT,21,0,ATTR,69,2,12,15,3,11,ENDCHR

; Orders.

ordtxt defb 22,0,0,16,7,'1'
       defb 22,0,4,'2'
       defb 22,0,8,'3'
       defb 22,0,12,'4'
       defb 22,0,16,'5'

; Define the orders.

ords   call 3503           ; clear screen.
       ld hl,orderx        ; user orders.
       ld (ordptr),hl      ; set up pointer for first order.
       ld de,orderx+99
       ld (hl),END         ; write termination byte.
       ld bc,99            ; bytes to clear down.
       ldir                ; clear all orders.
       ld de,sprgfx        ; point to image.
       ld hl,0+256*8       ; coordinates.
       call sprord         ; show sprite type.
       ld de,sprgfx+256    ; point to image.
       ld hl,0+256*40      ; coordinates.
       call sprord         ; show sprite type.
       ld de,sprgfx+512    ; point to image.
       ld hl,0+256*72      ; coordinates.
       call sprord         ; show sprite type.
       ld de,sprgfx+768    ; point to image.
       ld hl,0+256*104     ; coordinates.
       call sprord         ; show sprite type.
       ld de,sprgfx+1024   ; point to image.
       ld hl,0+256*136     ; coordinates.
       call sprord         ; show sprite type.
       ld de,ordtxt
       ld bc,ords-ordtxt
       call 8252           ; show text.

       ld hl,24
       ld (dispx),hl       ; set sprite coordinates.
ords2  xor a               ; put zero in accumulator.
       ld (numord),a       ; reset items ordered by customer.
       ld (dispy),a        ; set y coordinate of sprites.
ords1  ld hl,23560         ; keyboard.
       ld (hl),0           ; clear key press.
ords0  ld a,(23560)        ; fetch key.
       cp 32
       jp z,ordsok
       cp 13
       jp z,ords5
       cp 49               ; before first item?
       jr c,ords0          ; wait for valid key.
       cp 54               ; past last item?
       jr nc,ords0         ; not a valid key.
       sub 49              ; put into valid item range.
       ld hl,(ordptr)      ; pointer to orders.
       ld (hl),a           ; order the item.
       inc hl              ; move pointer along.
       ld (ordptr),hl      ; store new pointer.
       call dord
       ld a,(dispy)        ; sprite y position.
       add a,24            ; move right.
       ld (dispy),a        ; set y coordinate of sprites.

       ld a,(numord)       ; number ordered.
       inc a               ; one more.
       ld (numord),a       ; keep count.
       cp 3                ; reached maximum per customer?
       jr c,ords1          ; no yet, continue.
ords4  ld hl,(ordptr)      ; pointer to orders.
       ld (hl),99          ; order the item.
       inc hl              ; move pointer along.
       ld (ordptr),hl      ; store new pointer.
       ld a,(dispx)        ; x coordinate.
       add a,24            ; move down 24 pixels.
       cp 177              ; reached bottom of screen?
       jr nc,ords3         ; yes, scroll instead.
       ld (dispx),a        ; new coordinate.
       jp ords2
ords3  call scrol          ; scroll screen up.
       call scrol
       call scrol
       jp ords2

scrol  ld b,20             ; lines to scroll (minus one).
       jp 3584             ; scroll screen up.

ordsok ld hl,(ordptr)      ; pointer to orders.
       ld (hl),END         ; order the item.
       inc hl              ; move pointer along.
       ld (ordptr),hl      ; store new pointer.
       jp drsc
ords5  ld a,(numord)       ; number ordered.
       and a               ; any orders?
       jp z,ords1          ; no, must order.
       jp ords4

numord defb 0

dord   ld d,a              ; fetch type.
       ld e,0              ; sprite direction.
       ld a,(dispy)        ; sprite y.
       call gspra0         ; get sprite address.
       call scadd          ; work out screen address.
       call spmask         ; get sprite mask.
       ld a,16             ; rows to display/delete.
       jp sspri0           ; display sprite.

sprord ld (dispx),hl       ; coordinates for display.
       call scadd          ; work out screen address.
       call spmask         ; get sprite mask.
       ld a,16             ; rows to display/delete.
       jp sspri0

; ------------------------ End of editor code ----------------------------




; Rotate an ENDCHR-terminated string at hl.

rfont  ld b,8              ; number of rotations.
rfont0 push hl             ; pointer to text.
       call rsymb          ; display text.
       pop hl              ; restore pointer.
       halt                ; delay.
       djnz rfont0         ; repeat until on screen.
       ret
rsymb  ld a,(hl)           ; get char from hl.
       inc hl              ; point to next char.
       cp ENDCHR           ; is it a null terminator?
       ret z               ; yes, job done.
       call rsymb3         ; display char.
       jp rsymb            ; repeat.
rsymb3 cp AT               ; is it the AT code?
       jr z,dsymb0         ; yes, set x and y coordinates.
       cp ATTR             ; attribute control byte?
       jr z,dsymb2         ; yes, set attributes.
       push hl             ; store pointer to string.
       rlca                ; multiply char number by 8.
       rlca
       rlca
       ld e,a              ; store shift in e.
       and 3               ; high bits.
       ld d,a              ; put those in high byte.
       ld a,e              ; restore shift.
       and 248             ; mask off all except low bits.
       ld e,a              ; de now set to graphic displacement.
       ld hl,font          ; point to font.
       add hl,de           ; address of char image.
       call chadd          ; get screen address in de.
       ld c,8              ; set number of pixel lines.
rsymb1 ld a,(hl)           ; get image data.
       push bc             ; store state.
       dec b               ; between 7 and one rotation.
       jr z,rsymb4         ; no rotations required.
rsymb5 and a               ; clear carry.
       rra                 ; rotate pixels out of square.
       djnz rsymb5         ; continue until image in position.
rsymb4 pop bc              ; restore rotations.
       ld (de),a           ; write image to screen.
       inc hl              ; next image byte.
       inc d               ; next screen line down.
       dec c               ; one less line to do.
       jr nz,rsymb1        ; repeat for all lines.
       call atadd          ; get character's attributes.
       ld a,(23693)        ; fetch current attributes.
       ld (hl),a           ; write to screen.
       ld hl,dispy         ; y position.
       inc (hl)            ; move to next column.
       pop hl              ; restore string pointer.
       ret

; Display an ENDCHR-terminated string at hl.

dfont  ld a,(hl)           ; get char from hl.
       inc hl              ; point to next char.
       cp ENDCHR           ; is it a null terminator?
       ret z               ; yes, job done.
       call dsymb          ; display char.
       jp dfont            ; repeat.
dsymb  cp AT               ; is it the AT code?
       jr z,dsymb0         ; yes, set x and y coordinates.
       cp ATTR             ; attribute control byte?
       jr z,dsymb2         ; yes, set attributes.
       push hl             ; store pointer to string.
       rlca                ; multiply char number by 8.
       rlca
       rlca
       ld e,a              ; store shift in e.
       and 3               ; high bits.
       ld d,a              ; put those in high byte.
       ld a,e              ; restore shift.
       and 248             ; mask off all except low bits.
       ld e,a              ; de now set to graphic displacement.
       ld hl,font          ; point to font.
       add hl,de           ; address of char image.
       call chadd          ; get screen address in de.
       defb 1,99,8         ; set b to 8 and c out of the way.
dsymb1 ldi                 ; transfer byte to screen.
       inc d               ; next screen line down.
       dec de              ; back one char as ldi moved us on.
       djnz dsymb1         ; repeat for all lines.
       call atadd          ; get character's attributes.
       ld a,(23693)        ; fetch current attributes.
       ld (hl),a           ; write to screen.
       ld hl,dispy         ; y position.
       inc (hl)            ; move to next column.
       pop hl              ; restore string pointer.
       ret
dsymb0 ld e,(hl)           ; get first control code.
       inc hl              ; point to next one.
       ld d,(hl)           ; get that code too.
       inc hl              ; point to next valid character.
       ld (dispx),de       ; set coordinates.
       ret                 ; back to main loop.
dsymb2 ld a,(hl)           ; get attribute byte.
       ld (23693),a        ; set attribute.
       inc hl              ; point to next character.
       ret




blkgfx defb 0,0,0,0,0,0,0,0
       defb 239,239,239,0,254,254,254,0
       defb 255,248,7,3,1,0,0,0,255,31,224,192,128,0,0,0
       defb 227,201,28,62,127,28,28,0
       defb 227,203,24,62,126,62,24,8
       defb 199,211,24,124,126,124,24,16
       defb 201,107,54,220,59,108,214,147

blcols defb 71,66,67,67,68,68,68,86

chprop defb 0,WALATT,PLAT,PLAT,JUMP,LEFT,RIGHT
       defb DEADLY

; Character set.

font   defb 0,0,0,0,0,0,0,0
       defb 56,124,124,238,254,254,238,238
       defb 252,254,206,252,254,206,254,252
       defb 126,254,224,224,224,224,254,126
       defb 240,252,254,238,238,254,252,240
       defb 254,254,224,252,252,224,254,254
       defb 254,254,224,248,248,224,224,224
       defb 126,254,224,238,238,238,254,126
       defb 238,238,238,254,238,238,238,238
       defb 124,56,56,56,56,56,56,124
       defb 14,14,14,14,14,238,254,124
       defb 238,252,248,240,248,252,238,238
       defb 224,224,224,224,224,224,254,254
       defb 238,254,254,254,254,254,238,238
       defb 206,238,254,254,254,254,238,230
       defb 124,254,238,238,238,238,254,124
       defb 252,254,238,238,254,252,224,224
       defb 124,254,238,238,238,254,255,127
       defb 252,254,238,238,252,254,238,238
       defb 126,254,240,120,60,30,254,252
       defb 254,254,56,56,56,56,56,56
       defb 238,238,238,238,238,238,254,124
       defb 238,238,238,124,124,56,56,16
       defb 238,238,238,238,254,254,254,108
       defb 238,238,124,56,124,238,238,238
       defb 238,238,238,254,124,56,56,56
       defb 254,254,30,60,120,240,254,254
       defb 124,254,238,238,238,238,254,124
       defb 56,120,56,56,56,56,56,124
       defb 124,254,30,60,120,240,254,254
       defb 252,254,14,60,60,14,254,252
       defb 14,30,62,110,255,255,14,14
       defb 254,254,224,252,254,14,254,252
       defb 124,252,224,252,254,238,254,124
       defb 254,254,14,30,28,60,56,56
       defb 124,254,238,124,254,238,254,124
       defb 124,254,238,254,126,14,126,124
       defb 0,0,0,0,0,0,56,56
       defb 0,16,124,56,124,16,0,0
       defb 56,56,56,0,0,0,0,0

gradd  ld hl,rooms         ; fetch screen data.
       ld a,(levno)        ; level number.
       rlca                ; two bytes per address.
       call addac          ; add displacement to start adress.
       ld e,(hl)           ; low byte of pointer.
       inc hl              ; next byte.
       ld d,(hl)           ; pointer high.
       ex de,hl            ; put the address in hl.
       ret

; Check for collisions.

coll   ld a,(NEWTAB+1)     ; primary sprite direction.
       cp (ix+1)           ; secondary sprite direction.
       ret nz              ; not the same.

       and 248             ; are they stationary?
       ret nz              ; yes, no check needed.
       ld a,(NEWTAB+2)     ; primary sprite x.
       cp (ix+2)           ; secondary x.
       ret nz              ; different, no clash then.
       ld a,(NEWTAB+3)     ; y coordinate.
       sub (ix+3)          ; compare horizontal positions.
       jr c,collr          ; new sprite is to the right.
colll  cp 13               ; too much overlap?
       ret nc              ; no, no collision.
       ld a,(NEWTAB+1)     ; fetch direction.
       dec a               ; moving left?
       jr z,stoppr         ; yes, stop primary sprite moving.
       jp stopse           ; stop secondary sprite.

collr  cp 244              ; too much overlap?
       ret c               ; no, no collision.
       ld a,(NEWTAB+1)     ; fetch direction.
       dec a               ; moving left?
       jr z,stopse         ; yes, stop secondary sprite moving.
stoppr ld a,(NEWTAB+1)     ; primary sprite.
       or 56               ; stop it moving.
       ld (NEWTAB+1),a     ; new direction.
       ret
stopse ld a,(ix+1)         ; secondary sprite.
       or 56               ; stop it moving.
       ld (NEWTAB+1),a     ; new direction.
       ret


; Test for pause key.
; Pause mode.

pause  ld a,(keys+5)       ; pause key.
       call ktest          ; has it been pressed?
       ret c               ; no.
pause0 ld a,(keys+5)       ; pause key.
       call ktest          ; has it been pressed?
       jr nc,pause0        ; wait until pause key is released.
pause1 ld a,(keys+5)       ; pause button.
       call ktest          ; pressed it yet?
       jr c,pause1         ; pause game until pause key pressed.
pause2 ld a,(keys+5)       ; pause key.
       call ktest
       jr nc,pause2        ; wait until pause key is released.
       ret



haltr  ld hl,pretim        ; previous clock setting.
       ld a,(23672)        ; current clock setting.
       sub (hl)            ; subtract last reading.
       cp 2                ; reached elapsed time already?
       jp nc,haltr0        ; yes, no more processing please.

; End-of-loop processing here.

; Collision check code.  Looks for sprites which are occupying same space,
; and attempts to separate them a little.

       ld a,(NEWTAB)       ; check first sprite.
       inc a               ; is it switched on?
       jr z,haltr2         ; no, don't compare.
       ld ix,NEWTAB+ELSIZE ; second element in table.
       ld b,NUMITM-1       ; rest of items.
haltr3 ld a,(ix)           ; item in table.
       inc a               ; is it enabled?
       call nz,coll        ; yes, check for collision.
       ld de,ELSIZE        ; distance to next item.
       add ix,de           ; point to next sprite.
       djnz haltr3         ; check rest of table.

; Cycle items through the buffer.
; Do old items first.

haltr2 ld hl,ftable        ; table.
       ld de,dumtab        ; dummy element.
       ld bc,ELSIZE        ; size of one element in table.
       ldir                ; transfer first item to dummy area.
       ld de,ftable        ; table.
       ld bc,TABSIZ-ELSIZE ; remainder of table.
       ldir                ; transfer across.
       ld hl,dumtab        ; dummy element.
       ld bc,ELSIZE        ; size of one element in table.
       ldir                ; transfer first item to dummy area.

; Now the new ones.

       ld hl,NEWTAB        ; table.
       ld de,dumtab        ; dummy element.
       ld bc,ELSIZE        ; size of one element in table.
       ldir                ; transfer first item to dummy area.
       ld de,NEWTAB        ; table.
       ld bc,TABSIZ-ELSIZE ; remainder of table.
       ldir                ; transfer across.
       ld hl,dumtab        ; dummy element.
       ld bc,ELSIZE        ; size of one element in table.
       ldir                ; transfer first item to dummy area.


; Now check sprite for collisions with others and slow down if necessary.

haltr1 ld hl,pretim        ; previous clock setting.
       ld a,(23672)        ; current clock setting.
       sub (hl)            ; subtract last reading.
       cp 2                ; reached elapsed time already?
       jp nc,haltr0        ; yes, no more processing please.
       jp haltr1

haltr0 ld a,(23672)        ; current clock setting.
       ld (pretim),a       ; new setting.

       ret


pretim defb 0              ; previous clock setting.


; Clear screen routine.

clrsc  xor a               ; top line.
       ld (clrx0),a        ; set up position.
       ld a,23             ; bottom line.
       ld (clrx1),a        ; set up position.
       ld b,24             ; 24 character lines on screen.
clrsc0 push bc             ; store counter.
       ld a,(clrx0)        ; top down pointer.
       ld c,64             ; top 4 lines.
       call clrlin         ; clear this line.
       ld a,(clrx1)        ; bottom up pointer.
       ld c,65             ; bottom 4 lines.
       call clrlin         ; clear this line.
       ld hl,clrx0         ; top down pointer.
       inc (hl)            ; next row down.
       inc hl              ; cottum-up position.
       dec (hl)            ; move up one line.
       halt                ; pause.
       pop bc              ; restore loop count.
       djnz clrsc0         ; repeat.
       ret
clrlin ld b,4              ; 4 lines to clear.
       ld l,a              ; store x coordinate away in l register.
       and 24              ; mask away all but the segment bits.
       add a,c             ; add to screen start address.
       ld h,a              ; put into high byte of address.
       ld a,l              ; get x coord again.
       rrca                ; multiply by 32.
       rrca                ; 3 rrcas faster than 5 rlcas.
       rrca
       and 224             ; make it a multiple of 32.
       ld l,a              ; put result in low byte.
clrln0 push bc             ; remember the count.
       ld d,h              ; copy h to d.
       ld e,l              ; copy l to e, so de=hl.
       inc de              ; point to next byte.
       ld bc,31            ; line length minus one.
       ld (hl),b           ; blank firt byte of line.
       ldir                ; copy byte to remainder of line.
       ld de,481           ; 2 pixel lines down.
       add hl,de           ; next line down.
       pop bc              ; restore loop counter.
       djnz clrln0         ; repeat 4 times.
       ret
clrx0  defb 0              ; first position.
clrx1  defb 0              ; second position.


; Blind effect, used to clear game window.

blind  ld b,8              ; pixels to rotate.
blind0 exx                 ; store counter.
       call effec          ; do the effect.
       halt                ; synch with display.
       exx                 ; restore counter.
       djnz blind0         ; repeat until screen cleared.
       ret

effec  ld hl,16384         ; screen address.
       ld bc,2048          ; half the bytes to clear.
effec0 and a               ; clear carry flag.
       rr (hl)             ; rotate bits.
       inc hl              ; next byte.
       and a               ; clear carry flag.
       rl (hl)             ; rotate bits.
       inc hl              ; next byte.
       dec bc              ; one less loop.
       ld a,b              ; loop high.
       or c                ; merge with low.
       jp nz,effec0        ; repeat for top 2 segments.
       ld de,128           ; length to skip.
       ld a,8              ; lines per character cell.
effec2 ld b,64             ; half bytes to rotate.
effec1 and a               ; clear carry flag.
       rr (hl)             ; rotate bits.
       inc hl              ; next byte.
       and a               ; clear carry flag.
       rl (hl)             ; rotate bits.
       inc hl              ; next byte.
       djnz effec1         ; repeat for top 4 lines.
       add hl,de           ; skip the next 4.
       dec a               ; one less outer loop.
       jp nz,effec2        ; repeat until finished segment.
       ret


; Sprite masks.

masks  defb 0,128,192,224,240,248,252,254
masken equ $


; User-defined orders.

orderx defb END




       org 48573           ; both bytes are 189.

; Interrupt routine.

int    push af
       push de
       push bc
       push hl
       push ix
       rst 56
       call music+6
       pop ix
       pop hl
       pop bc
       pop de
       pop af
       ei
       reti
       ret

; Here's the interrupt vector table.

       org 48640

       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int,int,int,int
       defw int

       org 49152

music  defb 33,60,196,195,9,192,195,68,193,243,126,50,120,192,34,187
       defb 192,35,205,181,192,26,19,60,50,122,192,237,83,112,192,205
       defb 181,192,237,83,114,192,213,205,181,192,237,83,116,192,33,27
       defb 0,205,186,192,235,34,118,192,33,129,192,34,123,192,33,130
       defb 192,17,131,192,1,44,0,112,237,176,225,1,33,0,175,205
       defb 175,192,61,50,139,192,50,149,192,50,159,192,62,1,50,121
       defb 192,35,34,137,192,34,147,192,34,157,192,205,31,196,251,201
       defb 119,241,143,241,19,242,94,238,6,1,12,69,231,145,242,207
       defb 242,255,0,0,0,0,0,0,0,144,241,255,0,0,0,0
       defb 0,0,0,144,241,255,0,0,0,0,0,0,0,144,241,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,190
       defb 200,9,195,175,192,94,35,86,35,235,1,67,238,9,235,201
       defb 22,0,95,135,131,95,221,25,221,126,1,203,127,14,16,194
       defb 211,192,74,203,119,6,2,194,219,192,66,230,31,103,221,94
       defb 2,221,126,0,245,230,240,15,15,15,15,87,241,230,15,111
       defb 221,203,1,110,200,203,226,201,58,160,192,79,33,122,192,190
       defb 218,5,193,175,79,60,50,160,192,105,38,0,41,237,91,112
       defb 192,25,78,35,126,50,68,195,121,42,116,192,1,7,0,205
       defb 175,192,35,205,181,192,237,83,123,192,205,181,192,237,83,125
       defb 192,205,181,192,237,83,127,192,201,221,53,2,240,221,126,255
       defb 221,119,2,201,58,121,192,61,50,121,192,194,142,194,58,120
       defb 192,50,121,192,221,33,132,192,205,57,193,242,111,193,42,123
       defb 192,126,60,204,248,192,42,123,192,205,152,193,34,123,192,221
       defb 33,142,192,205,57,193,242,130,193,42,125,192,205,152,193,34
       defb 125,192,221,33,152,192,205,57,193,242,142,194,42,127,192,205
       defb 152,193,34,127,192,195,142,194,126,254,96,218,198,193,254,112
       defb 218,211,193,254,128,218,244,193,202,235,193,254,129,202,209,193
       defb 254,130,202,241,193,254,143,218,16,194,214,161,221,119,2,221
       defb 119,255,35,195,152,193,221,119,1,221,54,0,0,221,54,7
       defb 32,35,201,214,96,229,1,99,0,42,118,192,205,175,192,35
       defb 221,117,3,221,116,4,225,35,195,152,193,35,221,54,7,255
       defb 201,175,24,2,214,112,229,1,33,0,42,114,192,205,175,192
       defb 35,221,117,5,221,116,6,221,54,254,0,225,35,195,152,193
       defb 214,128,50,174,192,35,126,35,50,172,192,221,54,254,1,229
       defb 175,1,33,0,42,114,192,205,175,192,35,221,117,5,221,116
       defb 6,225,195,152,193,221,126,7,60,200,61,61,221,119,7,245
       defb 221,126,0,79,60,230,31,221,119,0,241,192,221,94,3,221
       defb 86,4,33,96,0,25,126,61,250,236,193,79,60,230,31,221
       defb 119,0,35,126,60,221,119,7,201,121,183,192,124,50,167,192
       defb 201,221,126,7,60,200,221,126,254,183,200,254,2,202,135,194
       defb 221,54,254,2,195,139,194,175,50,174,192,203,230,201,221,33
       defb 132,192,205,53,194,121,50,60,195,221,42,135,192,205,192,192
       defb 121,176,15,50,168,192,221,33,132,192,221,126,7,60,202,186
       defb 194,205,105,194,205,50,195,34,161,192,33,169,192,119,205,113
       defb 194,221,33,142,192,205,53,194,221,126,7,60,202,239,194,121
       defb 50,60,195,221,42,145,192,205,192,192,58,168,192,177,176,50
       defb 168,192,205,105,194,221,33,142,192,205,50,195,34,163,192,33
       defb 170,192,119,205,113,194,221,33,152,192,205,53,194,221,126,7
       defb 60,202,40,195,121,50,60,195,221,42,155,192,205,192,192,58
       defb 168,192,203,1,203,0,176,177,50,168,192,205,105,194,221,33
       defb 152,192,205,50,195,34,165,192,33,171,192,119,205,113,194,195
       defb 31,196,125,245,213,221,110,5,221,102,6,17,3,0,25,221
       defb 126,1,134,198,0,135,95,22,0,33,95,195,25,94,35,86
       defb 235,209,241,203,98,40,4,203,162,25,201,167,237,82,201,248
       defb 14,16,14,96,13,128,12,216,11,40,11,136,10,240,9,96
       defb 9,224,8,88,8,224,7,124,7,8,7,176,6,64,6,236
       defb 5,148,5,68,5,248,4,176,4,112,4,44,4,240,3,190
       defb 3,132,3,88,3,32,3,246,2,202,2,162,2,124,2,88
       defb 2,56,2,22,2,248,1,223,1,194,1,172,1,144,1,123
       defb 1,101,1,81,1,62,1,44,1,28,1,11,1,252,0,239
       defb 0,225,0,214,0,200,0,189,0,178,0,168,0,159,0,150
       defb 0,142,0,133,0,126,0,119,0,112,0,107,0,100,0,94
       defb 0,89,0,84,0,79,0,75,0,71,0,66,0,63,0,59
       defb 0,56,0,53,0,50,0,47,0,44,0,42,0,39,0,37
       defb 0,35,0,33,0,31,0,29,0,28,0,26,0,25,0,23
       defb 0,22,0,21,0,19,0,18,0,17,0,16,0,15,0,33
       defb 174,192,175,182,62,13,32,5,214,3,43,43,43,14,253,6
       defb 255,237,121,6,191,237,171,61,242,47,196,201,4,249,3,26
       defb 4,34,5,83,79,78,71,32,66,89,32,83,84,32,67,79
       defb 77,80,73,76,69,5,10,1,15,128,0,15,128,0,14,128
       defb 0,14,128,0,13,128,0,13,128,0,12,128,0,12,128,0
       defb 11,128,0,11,128,0,10,128,0,10,128,0,9,128,0,9
       defb 128,0,8,128,0,8,128,0,7,128,0,7,128,0,6,128
       defb 0,6,128,0,5,128,0,5,128,0,4,128,0,4,128,0
       defb 3,128,0,3,128,0,2,128,0,2,128,0,1,128,0,1
       defb 128,0,0,128,0,0,128,0,0,15,3,15,128,0,15,128
       defb 0,15,128,0,15,128,0,14,128,0,14,128,0,14,128,0
       defb 14,160,0,13,160,0,13,160,0,13,160,0,13,160,0,12
       defb 128,0,12,128,0,12,128,0,12,128,0,11,128,0,11,128
       defb 0,11,128,0,11,160,0,10,160,0,10,160,0,10,160,0
       defb 10,160,0,9,128,0,9,128,0,9,128,0,9,128,0,8
       defb 128,0,8,128,0,8,128,0,8,128,0,0,0,5,47,160
       defb 0,78,160,0,108,160,0,139,160,0,169,160,0,200,160,0
       defb 230,160,0,229,160,151,227,160,186,226,160,216,0,128,0,0
       defb 128,0,0,128,0,0,128,0,0,128,0,0,128,0,0,128
       defb 0,0,128,0,0,128,0,0,128,0,0,128,0,0,128,0
       defb 0,128,0,0,128,0,0,128,0,0,128,0,0,128,0,0
       defb 128,0,0,128,0,0,128,0,0,128,0,0,128,0,0,0
       defb 6,15,32,0,14,38,47,13,44,94,12,50,141,11,56,188
       defb 10,62,235,25,36,26,24,42,73,22,48,120,21,54,167,20
       defb 60,214,35,34,5,34,40,52,33,46,99,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,7,15,128,0,15,128,0,15,128,2,15,128,2
       defb 14,128,0,14,128,0,14,160,2,14,160,2,13,128,0,13
       defb 128,0,13,128,2,13,128,2,12,128,0,12,128,0,12,160
       defb 2,12,160,2,11,128,0,11,128,0,11,128,2,11,128,2
       defb 10,128,0,10,128,0,10,160,2,10,160,2,9,128,0,9
       defb 128,0,9,128,2,9,128,2,9,128,0,9,128,0,9,160
       defb 2,9,160,2,20,11,8,15,160,21,15,160,18,15,160,15
       defb 15,160,12,14,160,10,14,160,8,14,160,6,14,160,4,13
       defb 160,3,13,160,2,13,160,1,13,160,0,12,160,0,12,160
       defb 0,12,160,0,12,160,0,11,160,0,11,160,0,11,160,0
       defb 11,160,0,10,160,0,10,160,0,10,160,0,10,160,0,9
       defb 160,0,9,160,0,9,160,0,9,160,0,8,160,0,8,160
       defb 0,8,160,0,8,160,0,20,5,9,12,128,0,12,128,0
       defb 11,128,0,11,128,0,10,128,0,10,128,0,9,128,0,9
       defb 160,0,8,160,0,8,160,0,7,160,0,7,160,0,6,128
       defb 0,6,128,0,5,128,0,5,128,0,4,128,0,4,128,0
       defb 3,128,0,3,160,0,2,160,0,2,160,0,1,160,0,1
       defb 160,0,0,128,0,0,128,0,0,128,0,0,128,0,0,128
       defb 0,0,128,0,0,128,0,0,128,0,0,0,12,11,128,0
       defb 11,128,0,10,128,0,10,128,0,9,128,0,9,128,0,8
       defb 128,0,8,128,0,7,128,0,7,128,0,6,128,0,6,128
       defb 0,5,128,0,5,128,0,4,128,0,4,128,0,3,128,0
       defb 3,128,0,2,128,0,2,128,0,1,128,0,1,128,0,0
       defb 128,0,0,128,0,0,128,0,0,128,0,0,128,0,0,128
       defb 0,0,128,0,0,128,0,0,128,0,0,128,0,0,0,13
       defb 13,67,0,9,69,0,6,71,0,4,73,0,3,75,0,2
       defb 77,0,1,79,0,1,81,0,0,64,0,0,64,0,0,64
       defb 0,0,64,0,0,64,0,0,64,0,0,64,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,14,28,160,0,25,160,128,38,160,0,35,160,128,48
       defb 160,0,0,160,0,0,160,0,0,160,0,0,128,0,0,128
       defb 0,0,128,0,0,128,0,0,128,0,0,128,0,0,128,0
       defb 0,128,0,0,128,0,0,128,0,0,128,0,0,128,0,0
       defb 128,0,0,128,0,0,128,0,0,128,0,0,128,0,0,128
       defb 0,0,128,0,0,128,0,0,128,0,0,128,0,0,128,0
       defb 0,128,0,0,0,15,1,0,2,0,1,0,3,0,4,0
       defb 6,0,4,0,7,0,1,0,2,0,1,0,2,0,5,0
       defb 8,0,9,0,10,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 0,0,0,0,0,0,0,3,0,0,4,4,9,9,0,0
       defb 4,4,9,9,0,0,4,4,9,9,0,0,4,4,9,9
       defb 0,0,4,4,9,9,0,0,5,0,0,4,4,7,7,0
       defb 0,4,4,7,7,0,0,4,4,7,7,0,0,4,4,7
       defb 7,0,0,4,4,7,7,0,0,6,0,0,5,5,9,9
       defb 0,0,5,5,9,9,0,0,5,5,9,9,0,0,5,5
       defb 9,9,0,0,5,5,9,9,0,0,8,0,0,5,5,8
       defb 8,0,0,5,5,8,8,0,0,5,5,8,8,0,0,5
       defb 5,8,8,0,0,5,5,8,8,0,0,11,0,0,3,3
       defb 8,8,0,0,3,3,8,8,0,0,3,3,8,8,0,0
       defb 3,3,8,8,0,0,3,3,8,8,0,0,12,0,0,2
       defb 2,7,7,0,0,2,2,7,7,0,0,2,2,7,7,0
       defb 0,2,2,7,7,0,0,2,2,7,7,0,0,13,0,0
       defb 6,6,9,9,0,0,6,6,9,9,0,0,6,6,9,9
       defb 0,0,6,6,9,9,0,0,6,6,9,9,0,0,1,105
       defb 5,144,5,241,5,2,74,6,144,5,241,5,3,123,6,144
       defb 5,241,5,4,173,6,144,5,212,6,5,51,7,144,5,98
       defb 7,6,203,7,144,5,212,6,7,12,8,144,5,212,6,8
       defb 59,8,144,5,117,8,9,222,8,144,5,15,9,10,118,9
       defb 144,5,168,9,255,164,103,48,104,48,162,97,45,41,39,166
       defb 103,48,164,104,48,162,97,45,41,164,103,39,104,46,99,44
       defb 162,103,46,164,44,172,48,162,36,38,36,255,162,101,48,110
       defb 48,102,55,161,110,48,109,55,162,101,48,110,48,102,55,161
       defb 110,48,109,55,162,101,48,110,48,102,55,161,110,48,109,55
       defb 162,101,48,110,48,102,55,161,110,48,109,55,162,101,48,110
       defb 48,102,55,161,110,48,109,55,162,101,48,110,48,102,55,161
       defb 110,48,109,55,162,101,48,110,48,102,55,161,110,48,109,55
       defb 162,101,48,110,48,102,55,161,110,48,109,55,255,164,97,138
       defb 45,17,162,118,48,138,45,17,140,45,29,118,46,138,45,17
       defb 118,48,164,138,45,17,162,118,48,138,45,17,140,45,29,118
       defb 46,138,45,17,118,48,164,138,66,10,162,123,50,138,45,17
       defb 140,45,29,105,118,46,97,138,45,17,105,118,48,164,97,138
       defb 45,17,162,105,118,48,97,138,45,17,140,45,29,118,46,138
       defb 45,17,105,118,48,255,164,103,48,104,48,162,97,45,41,39
       defb 166,103,48,164,104,48,162,97,45,41,164,103,39,162,46,44
       defb 99,45,46,103,44,41,39,166,41,161,108,35,36,39,41,44
       defb 47,162,97,36,38,36,255,164,103,48,104,48,162,97,45,41
       defb 39,166,103,48,164,104,48,162,97,45,41,164,103,39,162,46
       defb 44,99,45,46,103,44,41,39,166,41,161,105,35,36,39,41
       defb 44,47,48,51,53,51,48,45,255,164,99,48,104,48,162,99
       defb 52,97,53,54,164,103,55,104,52,103,48,162,99,48,52,53
       defb 164,103,51,99,51,162,104,53,99,51,97,46,178,103,50,255
       defb 164,97,138,60,12,162,105,118,43,97,138,60,12,140,60,24
       defb 120,45,138,45,17,117,48,164,138,60,12,162,105,117,48,97
       defb 138,60,12,140,45,29,118,46,138,45,17,105,118,48,164,97
       defb 138,66,10,162,105,123,50,97,138,45,17,140,45,29,118,46
       defb 138,45,17,105,117,46,164,97,138,66,10,162,105,118,46,97
       defb 138,45,17,140,45,29,117,46,138,45,17,105,123,47,255,164
       defb 97,123,45,99,45,162,97,45,112,51,48,166,99,123,45,164
       defb 45,162,97,118,46,166,99,123,45,164,43,43,162,97,118,41
       defb 112,48,46,172,99,120,40,162,97,112,36,38,36,255,164,97
       defb 138,45,17,162,105,118,48,97,138,45,17,140,45,29,105,118
       defb 46,97,138,45,17,105,118,48,164,97,138,45,17,162,105,118
       defb 48,97,138,45,17,140,45,29,105,118,46,97,138,45,17,105
       defb 118,48,164,97,138,66,10,162,105,123,50,97,138,45,17,140
       defb 45,29,105,118,46,97,138,45,17,105,118,48,164,97,138,45
       defb 17,162,105,118,48,97,138,45,17,140,45,29,105,118,46,97
       defb 138,45,17,105,118,48,255,164,99,48,104,48,162,99,52,97
       defb 53,54,164,103,55,104,52,103,48,162,99,52,53,55,164,103
       defb 58,162,99,56,55,104,53,99,50,97,48,166,103,46,161,105
       defb 53,108,46,105,50,108,53,105,48,108,50,105,46,108,48,105
       defb 43,108,46,105,41,108,43,255,164,99,48,104,48,162,99,52
       defb 97,53,54,164,103,55,104,52,103,48,162,99,55,58,55,164
       defb 60,162,104,63,164,99,60,162,58,97,54,103,53,51,48,105
       defb 46,42,41,39,36,41,255,164,97,123,45,99,45,162,97,45
       defb 99,112,51,103,48,166,99,123,45,164,45,162,97,45,99,112
       defb 55,57,164,123,50,162,97,112,56,104,53,97,51,124,41,112
       defb 46,44,166,99,123,40,162,108,112,42,43,48,97,36,38,36
       defb 255,164,97,138,45,17,162,105,118,48,97,138,45,17,140,45
       defb 29,105,118,46,97,138,45,17,105,118,48,164,97,138,45,17
       defb 162,105,118,48,97,138,45,17,140,45,29,105,118,46,97,138
       defb 45,17,105,118,48,164,97,138,66,10,162,105,117,46,97,138
       defb 45,17,140,45,29,105,117,46,97,138,45,17,105,117,46,164
       defb 97,140,60,12,162,105,117,48,97,138,60,12,140,60,24,105
       defb 118,48,97,138,60,12,105,117,48,255,164,97,123,45,99,45
       defb 162,97,45,112,51,48,166,99,123,45,164,45,162,97,118,46
       defb 166,99,123,45,164,43,43,162,97,118,41,112,48,46,164,99
       defb 120,40,118,40,115,41,166,97,125,43,255,164,97,138,45,17
       defb 162,105,118,48,97,138,45,17,140,45,29,105,118,46,97,138
       defb 45,17,105,118,48,164,97,138,45,17,162,105,118,48,97,138
       defb 45,17,140,45,29,105,118,46,97,138,45,17,105,118,48,164
       defb 97,138,66,10,162,105,123,50,97,138,45,17,140,45,29,105
       defb 118,46,97,138,45,17,105,118,48,164,97,138,35,9,162,105
       defb 123,49,97,138,35,21,9,105,123,49,97,138,35,9,105,123
       defb 49,255,162,97,123,45,112,50,99,117,41,97,112,44,43,41
       defb 38,99,36,125,29,112,41,44,45,97,115,41,166,99,123,40
       defb 164,104,112,50,99,48,162,97,44,43,38,172,99,41,162,97
       defb 36,38,36,255,164,97,138,26,14,162,105,115,41,97,138,26
       defb 26,140,45,29,105,117,41,97,138,45,17,105,117,43,164,97
       defb 138,40,19,162,118,38,138,40,31,19,118,38,138,40,19,138
       defb 36,21,164,138,66,10,162,105,123,50,97,138,63,11,140,60
       defb 12,105,117,48,97,138,60,12,105,118,48,164,97,138,45,17
       defb 162,118,48,138,45,17,140,45,29,118,46,138,45,17,118,48
       defb 255


; Buffer to which screens are transferred before being used.

rbuff  defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
       defb 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00

; Loading screen.
; Not part of the game, but this is somewhere to stick it to make it
; easier to create a .tap file.

       org 55000

loadsc defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,255,255,255,240,0,15,255,255,252,0,63,255,128,63,255,128,7,255,255,255,224,1,255,255,255,240,63,255,255,255,248
       defb 255,255,255,255,254,0,31,255,255,254,0,63,255,224,63,255,128,127,255,231,255,254,1,255,255,255,240,63,255,255,255,255
       defb 255,255,129,255,255,0,63,255,191,255,0,63,255,248,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,63,255,128,63,255,254,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,252,0,255,255,31,255,192,63,255,255,191,255,128,255,255,128,0,0,1,255,255,255,224,63,255,255,255,255
       defb 255,255,255,255,240,0,255,254,31,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,224
       defb 255,255,129,255,254,1,255,252,15,255,240,63,255,191,255,255,128,255,255,143,255,255,1,255,255,0,0,63,255,224,127,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,255,128,0,0,0,0,0,0,0,0,0,0,0
       defb 255,255,255,255,248,0,31,255,255,254,0,63,255,192,63,255,128,15,255,255,255,240,1,255,255,255,240,63,255,255,255,252
       defb 255,255,135,255,254,0,31,255,255,255,0,63,255,240,63,255,128,127,255,195,255,254,1,255,255,255,240,63,255,225,255,255
       defb 255,255,129,255,255,0,63,255,191,255,0,63,255,248,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,63,255,128,63,255,254,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,248,0,255,255,31,255,192,63,255,255,191,255,128,255,255,128,0,0,1,255,255,255,224,63,255,255,255,254
       defb 255,255,255,255,248,1,255,254,15,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,248
       defb 255,255,129,255,255,1,255,252,15,255,240,63,255,191,255,255,128,255,255,143,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,192,0,0,15,255,255,252,0,63,255,0,63,255,128,0,31,255,248,0,1,255,255,255,240,63,255,255,240,0
       defb 255,255,255,255,248,0,31,255,255,254,0,63,255,192,63,255,128,31,255,255,255,248,1,255,255,255,240,63,255,255,255,254
       defb 255,255,131,255,254,0,31,255,255,255,0,63,255,240,63,255,128,127,255,195,255,254,1,255,255,255,240,63,255,225,255,255
       defb 255,255,129,255,255,0,63,255,191,255,0,63,255,252,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,63,255,128,63,255,255,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,240,0,255,254,31,255,192,63,255,255,255,255,128,255,255,128,0,0,1,255,255,255,224,63,255,255,255,254
       defb 255,255,255,255,252,1,255,254,15,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,252
       defb 255,255,129,255,255,1,255,252,15,255,240,63,255,191,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,248,0,0,15,255,255,252,0,63,255,0,63,255,128,0,63,255,252,0,1,255,255,255,240,63,255,255,252,0
       defb 255,255,255,255,248,0,31,255,255,254,0,63,255,192,63,255,128,31,255,255,255,248,1,255,255,255,240,63,255,255,255,254
       defb 255,255,131,255,254,0,31,255,255,255,0,63,255,240,63,255,128,127,255,129,255,254,1,255,255,255,240,63,255,224,255,255
       defb 255,255,129,255,255,0,63,255,191,255,128,63,255,252,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,31,255,128,63,255,255,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,224,0,255,254,31,255,192,63,255,255,255,255,128,255,255,128,0,0,1,255,255,255,224,63,255,255,255,252
       defb 255,255,255,255,252,1,255,254,15,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,252
       defb 255,255,129,255,255,1,255,252,15,255,240,63,255,191,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,254,0,0,15,255,255,252,0,63,255,0,63,255,128,0,127,255,254,0,1,255,255,255,240,63,255,255,255,128
       defb 255,255,255,255,252,0,31,255,255,254,0,63,255,192,63,255,128,63,255,255,255,252,1,255,255,255,240,63,255,255,255,254
       defb 255,255,129,255,255,0,63,255,255,255,0,63,255,240,63,255,128,127,255,129,255,254,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,63,255,191,255,128,63,255,252,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,31,255,128,63,255,255,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,128,0,255,254,31,255,192,63,255,255,255,255,128,255,255,128,0,0,1,255,255,255,224,63,255,255,255,252
       defb 255,255,255,255,252,1,255,254,15,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,254
       defb 255,255,129,255,255,3,255,252,15,255,240,63,255,159,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,128,0,15,255,255,252,0,63,255,128,63,255,128,1,255,255,255,128,1,255,255,255,240,63,255,255,255,224
       defb 255,255,255,255,252,0,31,255,255,254,0,63,255,224,63,255,128,63,255,255,255,252,1,255,255,255,240,63,255,255,255,255
       defb 255,255,129,255,255,0,63,255,191,255,0,63,255,248,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,63,255,191,255,128,63,255,252,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,131,255,254,0,127,255,31,255,192,63,255,255,63,255,128,255,255,128,0,0,1,255,255,0,0,63,255,224,255,255
       defb 255,255,255,252,0,0,255,254,31,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,240
       defb 255,255,135,255,254,1,255,252,15,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,225,255,255
       defb 255,255,129,255,255,3,255,255,255,255,240,63,255,159,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,192,0,15,255,255,252,0,63,255,128,63,255,128,3,255,255,255,192,1,255,255,255,240,63,255,255,255,240
       defb 255,255,255,255,252,0,31,255,255,254,0,63,255,224,63,255,128,63,255,255,255,252,1,255,255,255,240,63,255,255,255,255
       defb 255,255,129,255,255,0,63,255,191,255,0,63,255,248,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,191,255,128,63,255,254,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,135,255,254,0,127,255,31,255,192,63,255,255,191,255,128,255,255,128,0,0,1,255,255,255,224,63,255,225,255,255
       defb 255,255,255,255,128,0,255,254,31,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,192
       defb 255,255,131,255,254,1,255,252,15,255,240,63,255,191,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,224,255,255
       defb 255,255,129,255,255,3,255,255,255,255,240,63,255,159,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,224,0,15,255,255,252,0,63,255,128,63,255,128,3,255,255,255,192,1,255,255,255,240,63,255,255,255,240
       defb 255,255,255,255,254,0,31,255,255,254,0,63,255,224,63,255,128,127,255,255,255,252,1,255,255,255,240,63,255,255,255,255
       defb 255,255,129,255,255,0,63,255,191,255,0,63,255,248,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,0,127,255,191,255,128,63,255,254,63,255,128,255,255,129,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,252,0,255,255,31,255,192,63,255,255,191,255,128,255,255,128,0,0,1,255,255,255,224,63,255,255,255,255
       defb 255,255,255,255,224,0,255,254,31,255,224,63,255,255,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,255,255,0
       defb 255,255,131,255,254,1,255,252,15,255,240,63,255,191,255,255,128,255,255,143,255,255,1,255,255,255,224,63,255,224,255,255
       defb 255,255,129,255,255,3,255,255,255,255,248,63,255,159,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,3,255,255,255,255,248,63,255,143,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,7,255,255,255,255,252,63,255,135,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,255,15,255,252,7,255,254,63,255,129,255,255,128,127,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,252,15,255,248,3,255,254,63,255,128,127,255,128,7,255,255,247,255,1,255,255,255,248,63,255,224,127,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,255,255,192,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,252,127,252,15,255,248,31,240,255,129,255,255,1,255,255,224,127,255,135,255,227,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,247,248,31,248,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,252,127,192,31,224
       defb 255,255,129,255,255,3,255,255,255,255,248,63,255,143,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,7,255,255,255,255,252,63,255,135,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,255,15,255,252,7,255,254,63,255,129,255,255,128,127,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,248,31,255,248,3,255,254,63,255,128,127,255,128,3,255,255,247,255,1,255,255,255,248,63,255,224,127,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,255,255,192,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,252,127,252,15,255,248,31,240,255,129,255,255,3,255,63,240,127,255,135,255,227,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,247,248,31,248,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,252,127,192,31,224
       defb 255,255,129,255,255,3,255,255,255,255,248,63,255,143,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,7,255,255,255,255,252,63,255,131,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,254,15,255,252,7,255,254,63,255,129,255,255,128,63,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,240,31,255,248,3,255,255,63,255,128,127,255,128,1,255,255,231,255,1,255,255,255,248,63,255,224,127,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,255,255,192,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,252,127,252,15,255,248,31,240,255,129,255,255,3,255,63,240,127,255,135,255,227,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,247,248,31,252,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,254,127,192,31,224
       defb 255,255,129,255,255,3,255,255,255,255,248,63,255,143,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,129,255,255,7,255,255,255,255,252,63,255,131,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,254,15,255,248,3,255,254,63,255,128,255,255,128,63,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,224,31,255,248,3,255,255,63,255,128,63,255,128,0,255,255,227,255,1,255,255,255,248,63,255,224,127,255
       defb 255,248,63,252,7,255,240,31,192,255,128,255,254,0,31,254,0,127,255,135,255,193,255,224,255,255,15,224,127,199,255,255
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,255,255,192,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,252,127,252,15,255,248,31,248,255,129,255,255,3,254,31,240,127,255,135,255,227,255,224,255,255,15,252,127,199,255,255
       defb 255,252,127,252,15,247,248,31,252,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,254,127,192,31,224
       defb 255,255,129,255,255,3,255,255,255,255,248,63,255,135,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,131,255,255,7,255,255,255,255,252,63,255,131,255,255,128,127,255,128,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,254,15,255,248,3,255,254,63,255,128,255,255,128,63,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,192,31,255,248,3,255,255,63,255,128,63,255,128,0,127,255,195,255,1,255,255,255,248,63,255,224,127,255
       defb 255,248,63,252,7,255,240,31,192,255,128,255,254,0,63,255,0,127,255,135,255,193,255,224,255,255,15,224,127,199,255,255
       defb 255,248,63,252,7,255,240,31,240,255,128,255,254,1,255,255,224,127,255,135,255,193,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,255,248,31,248,255,129,255,255,3,254,31,240,127,255,135,255,227,255,224,255,255,15,252,127,199,255,255
       defb 255,252,127,252,15,247,248,31,252,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,254,127,192,31,224
       defb 255,255,129,255,255,7,255,255,255,255,248,63,255,135,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,131,255,255,7,255,255,255,255,252,63,255,131,255,255,128,127,255,128,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,254,15,255,248,3,255,254,63,255,128,255,255,128,31,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,252,0,31,255,248,3,255,255,63,255,128,63,255,128,0,63,255,131,255,1,255,255,255,248,63,255,224,127,255
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,63,255,0,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,248,63,252,7,255,240,31,240,255,128,255,254,1,255,255,224,127,255,135,255,193,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,247,248,31,248,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,252,127,192,31,224
       defb 255,252,127,252,15,247,248,31,252,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,254,127,192,31,224
       defb 255,255,129,255,255,7,255,255,255,255,248,63,255,135,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,135,255,255,7,255,252,7,255,252,63,255,129,255,255,128,127,255,193,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,252,15,255,248,3,255,254,63,255,128,255,255,128,31,255,255,255,255,1,255,255,255,248,63,255,224,127,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,255,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,127,255,128,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,248,63,252,7,255,240,31,240,255,128,255,254,1,255,255,224,127,255,135,255,193,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,247,248,31,248,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,252,127,192,31,224
       defb 255,252,127,252,15,247,248,31,252,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,254,127,192,31,224
       defb 255,255,129,255,255,7,255,255,255,255,248,63,255,135,255,255,128,255,255,128,255,255,1,255,255,0,0,63,255,224,127,255
       defb 255,255,255,255,255,15,255,252,7,255,252,63,255,129,255,255,128,127,255,227,255,255,1,255,255,255,248,63,255,224,127,255
       defb 255,255,255,255,252,15,255,248,3,255,254,63,255,128,127,255,128,15,255,255,247,255,1,255,255,255,248,63,255,224,127,255
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,252,0,0,0,0,0,0,0,0,0,0,0,0
       defb 255,248,63,252,7,255,240,31,224,255,128,255,254,0,127,255,128,127,255,135,255,193,255,224,255,255,15,240,127,199,255,255
       defb 255,252,127,252,15,255,248,31,240,255,129,255,255,1,255,255,224,127,255,135,255,227,255,224,255,255,15,248,127,199,255,255
       defb 255,252,127,252,15,247,248,31,248,255,129,254,255,3,254,31,240,127,192,7,255,227,255,224,255,128,15,252,127,192,31,224
       defb 255,254,255,252,31,247,252,31,252,255,131,254,255,131,254,31,240,127,192,7,255,247,255,224,255,128,15,254,127,192,31,224
       defb 255,254,255,252,31,247,252,31,252,255,131,254,255,131,254,31,240,127,192,7,255,247,255,224,255,128,15,254,127,192,31,224
       defb 255,190,247,252,31,247,252,31,255,255,131,254,255,131,254,0,0,127,255,7,253,247,191,224,255,254,15,255,255,192,31,224
       defb 255,191,247,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,253,255,191,224,255,252,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,247,255,135,252,127,195,254,127,240,127,192,7,252,255,63,224,255,255,241,251,139,0,31,224
       defb 255,159,231,252,127,255,255,31,247,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,206,179,255,1,255,192,31,224
       defb 255,143,199,252,127,255,255,31,241,255,143,255,255,227,254,31,240,127,192,7,252,126,63,132,32,127,255,240,255,192,31,224
       defb 255,143,199,252,255,193,255,159,241,255,159,248,63,241,255,255,240,127,255,199,252,126,63,224,255,207,255,248,255,192,31,224
       defb 255,135,135,252,255,193,255,159,240,127,159,248,63,240,127,251,240,127,255,199,252,60,63,224,255,159,255,240,63,192,31,224
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,31,240,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,190,247,252,31,247,252,31,255,255,131,254,255,131,254,0,0,127,255,7,253,247,191,224,255,254,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,224,255,254,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,247,255,135,252,127,195,254,127,240,127,192,7,252,255,63,224,255,255,248,251,14,0,31,224
       defb 255,159,231,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,199,147,255,137,255,192,31,224
       defb 255,143,199,252,127,255,255,31,241,255,143,255,255,227,254,31,240,127,192,7,252,126,63,158,194,63,255,240,255,192,31,224
       defb 255,143,199,252,255,193,255,159,240,255,159,248,63,241,255,255,240,127,255,199,252,126,63,224,255,207,255,248,127,192,31,224
       defb 255,135,135,252,255,193,255,159,240,127,159,248,63,240,127,251,240,127,255,199,252,60,63,224,255,159,255,240,63,192,31,224
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,31,240,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,190,247,252,31,227,252,31,255,255,131,252,127,131,254,0,0,127,255,7,253,247,191,224,255,254,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,225,255,255,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,247,255,135,252,127,195,254,31,240,127,192,7,252,255,63,224,255,255,252,251,60,64,31,224
       defb 255,159,231,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,227,159,255,137,255,192,31,224
       defb 255,143,199,252,127,255,255,31,241,255,143,255,255,227,254,31,240,127,255,199,252,126,63,135,15,63,255,240,255,192,31,224
       defb 255,143,199,252,255,193,255,159,240,255,159,248,63,241,255,255,240,127,255,199,252,126,63,224,255,207,255,248,127,192,31,224
       defb 255,135,135,252,255,193,255,159,240,127,159,248,63,240,63,243,240,127,255,199,252,60,63,224,255,159,255,224,63,192,31,224
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,0,0,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,190,247,252,31,227,252,31,255,255,131,252,127,131,254,0,0,127,255,7,253,247,191,224,224,30,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,225,255,255,143,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,247,255,135,252,127,195,254,31,240,127,192,7,252,255,63,224,127,255,252,120,30,64,31,224
       defb 255,143,199,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,126,63,224,241,251,255,201,255,192,31,224
       defb 255,143,199,252,127,255,255,31,241,255,143,255,255,227,254,31,240,127,255,199,252,126,63,195,31,31,255,240,255,192,31,224
       defb 255,135,135,252,255,193,255,159,240,255,159,248,63,240,255,255,240,127,255,199,252,60,63,224,255,207,255,248,127,192,31,224
       defb 255,135,135,252,255,193,255,159,240,127,159,248,63,240,63,243,240,127,255,199,252,60,63,224,255,143,255,224,63,192,31,224
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,0,0,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,191,247,252,31,227,252,31,255,255,131,252,127,131,254,127,240,127,255,7,253,255,191,224,128,6,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,225,255,255,199,255,255,192,31,224
       defb 255,159,231,252,127,255,255,31,247,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,127,243,254,64,98,64,31,224
       defb 255,143,199,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,126,63,192,240,239,255,201,255,192,31,224
       defb 255,143,199,252,255,193,255,159,241,255,159,248,63,243,255,63,240,127,255,199,252,126,63,230,63,159,255,240,255,192,31,224
       defb 255,135,135,252,255,193,255,159,240,255,159,248,63,240,255,255,240,127,255,199,252,60,63,224,255,143,255,248,127,192,31,224
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,224,0,0,0,0,0,0,0,0,0,15,255,128,0,0,0,0
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,0,0,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,191,247,252,31,227,252,31,255,255,131,252,127,131,254,127,240,127,255,7,253,255,191,224,15,194,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,225,255,255,231,255,199,192,31,224
       defb 255,159,231,252,127,255,255,31,247,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,63,207,254,3,128,64,31,224
       defb 255,143,199,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,126,63,128,192,255,255,193,255,192,31,224
       defb 255,143,199,252,255,193,255,159,241,255,159,248,63,243,255,63,240,127,255,199,252,126,63,228,127,159,255,248,255,192,31,224
       defb 255,135,135,252,255,193,255,159,240,255,159,248,63,240,255,251,240,127,255,199,252,60,63,224,255,159,255,248,127,192,31,224
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,224,0,0,0,0,0,0,0,0,0,7,255,128,0,0,0,0
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,0,0,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,191,247,252,31,227,252,31,255,255,131,252,127,131,254,127,240,127,255,7,253,255,191,224,63,240,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,225,255,255,227,255,128,64,31,224
       defb 255,159,231,252,127,255,255,31,247,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,31,127,255,28,8,192,31,224
       defb 255,143,199,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,126,63,144,134,121,255,225,255,192,31,224
       defb 255,143,199,252,255,193,255,159,241,255,159,248,63,243,255,63,240,127,255,199,252,126,63,224,255,143,255,248,255,192,31,224
       defb 255,135,135,252,255,193,255,159,240,255,159,248,63,240,255,251,240,127,255,199,252,60,63,224,255,159,255,248,127,192,31,224
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,192,0,0,0,0,0,0,0,0,0,3,254,0,0,0,0,0
       defb 255,190,247,252,31,247,252,31,254,255,131,254,255,131,254,0,0,127,192,7,253,247,191,224,255,128,15,255,127,192,31,224
       defb 255,191,247,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,253,255,191,224,127,248,15,255,255,192,31,224
       defb 255,159,231,252,63,227,254,31,255,255,135,252,127,195,254,127,240,127,255,7,252,255,63,225,255,255,243,255,144,0,31,224
       defb 255,159,231,252,127,255,255,31,247,255,143,255,255,227,254,31,240,127,192,7,252,255,63,224,142,247,255,96,63,192,31,224
       defb 255,143,199,252,127,255,255,31,243,255,143,255,255,227,254,31,240,127,192,7,252,126,63,200,24,121,255,225,255,192,31,224
       defb 255,143,199,252,255,193,255,159,241,255,159,248,63,241,255,255,240,127,255,199,252,126,63,224,255,207,255,248,255,192,31,224
       defb 255,135,135,252,255,193,255,159,240,255,159,248,63,240,255,251,240,127,255,199,252,60,63,224,255,159,255,248,127,192,31,224
       defb 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0
       defb 71,71,71,71,71,0,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,0,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,0,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,0,0,71,71,71,71,71
       defb 71,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,0,0,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,0,0,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,0,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71
       defb 71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71,71

       org 64768

buffer defb 0
